_TITLE "QB64 Editor ver. 1.1"

TIMER ON
ON TIMER(2) GOSUB ONETIME
ON ERROR GOTO errorhandle

SCREEN 0
screenw = 120
screenh = 50


DIM thelist(50) AS STRING
DIM SHARED edited
DIM SHARED highest
DIM SHARED bgcsetting
DIM SHARED fgcsetting
DIM SHARED codetext(100000) AS STRING
DIM SHARED undo(20, 60) AS STRING
DIM SHARED undocount
DIM SHARED onoff
DIM SHARED keyflags%(0 TO 127) 'the keyboard states
DIM SHARED moretoleft
DIM SHARED moretoup
DIM SHARED startx, starty, endx, endy
DIM SHARED curpos, curx
DIM SHARED xrel, yrel
DIM SHARED selinfo$
DIM SHARED comment AS STRING
DIM SHARED quotes(60) AS STRING
DIM SHARED ordinary(60) AS STRING
DIM SHARED filemenu(10) AS STRING
DIM SHARED editmenu(10) AS STRING
DIM SHARED viewmenu(10) AS STRING
DIM SHARED searchmenu(10) AS STRING
DIM SHARED runmenu(10) AS STRING
DIM SHARED helpmenu(10) AS STRING
DIM SHARED optionsmenu(10) AS STRING
DIM SHARED releasemouse
DIM SHARED selrelease
DIM SHARED thekeysel
DIM SHARED tfx, tfy, tfh, tfw
DIM SHARED formatset
DIM SHARED usefont
DIM SHARED thefont$
DIM SHARED fontheight
DIM SHARED wisizew, wisizeh 'values returned from setwindowsize function
DIM SHARED syntaxlist$(1000) 'more than 1000 keywords probably not needed
DIM SHARED helpfile$(10000) '10000 lines of text should be enough for the helpfile.
DIM SHARED linkx(500), linky(500), linktext$(500) 'helplinks to sections
DIM SHARED linksel, links
DIM SHARED item$(-10 TO 1000) '-10 to avoid subscript out of range errors (don't have to check if index is > 0)
DIM SHARED itemtype$(-10 TO 1000) '"statement", "function", "variable", "sub", "number", "string"
DIM SHARED functions$(1000)
DIM SHARED functionline(1000)
DIM SHARED subs$(1000)
DIM SHARED subline(1000)
DIM SHARED variable$(1000)
DIM SHARED variablelindex(1000)
DIM SHARED variableuindex(1000)
DIM SHARED variabletype$(1000)

formatset = 1 'unless changed with editor.cfg

'read the keywords from DATA in order to know the number of keywords
DO
    READ dummy$
    READ dummy$
    IF dummy$ = "-1" THEN EXIT DO
    numkey = numkey + 1
LOOP
dummy$ = ""

'dimension it to the correct amount (+10 for safety)
DIM SHARED keyword(numkey + 10) AS STRING
DIM SHARED keytype(numkey + 10) AS STRING

'restore it so we can read it again
RESTORE

'and store the keywords into arrays
FOR keynum = 1 TO numkey
    READ keyword(keynum)
    READ keytype(keynum)
NEXT


'check if config exists...
SHELL _HIDE "dir editor.cfg/b > temp.tmp"
OPEN "temp.tmp" FOR INPUT AS #1
IF LOF(1) THEN INPUT #1, dummy$
CLOSE #1
KILL "temp.tmp"
IF LCASE$(dummy$) = "editor.cfg" THEN configexists = 1
IF dummy$ = "" THEN configexists = 0


'check if keywordsyntax.txt exists...
SHELL _HIDE "dir keywordsyntax.txt/b > temp.tmp"
OPEN "temp.tmp" FOR INPUT AS #1
IF LOF(1) THEN INPUT #1, dummy$
CLOSE #1
KILL "temp.tmp"
IF LCASE$(dummy$) = "keywordsyntax.txt" THEN nohelp = 0
IF dummy$ = "" THEN nohelp = 1


'check if help.qhp exists...
SHELL _HIDE "dir help.qhp/b > temp.tmp"
OPEN "temp.tmp" FOR INPUT AS #1
IF LOF(1) THEN INPUT #1, dummy$
CLOSE #1
KILL "temp.tmp"
IF LCASE$(dummy$) = "help.qhp" THEN helpfound = 1
IF dummy$ = "" THEN helpfound = 0


'check current path
SHELL _HIDE "cd > temp.tmp"
OPEN "temp.tmp" FOR INPUT AS #1
INPUT #1, currentpath$
CLOSE #1
KILL "temp.tmp"

'set foreground and background colors
bgcsetting = 1
fgcsetting = 7

'open config and use the settings there (if it exists)
IF configexists = 1 THEN
    OPEN "editor.cfg" FOR INPUT AS #1
    DO UNTIL EOF(1)
        INPUT #1, thecommand$
        IF EOF(1) THEN EXIT DO
        IF thecommand$ = "QB64 Path:" THEN
            INPUT #1, qb64path$
            IF MID$(qb64path$, LEN(qb64path$), 1) <> "\" THEN qb64path$ = qb64path$ + "\"
        END IF
        IF thecommand$ = "Formatting 1/0:" THEN
            INPUT #1, formatset
        END IF
        IF thecommand$ = "Use Font 1/0:" THEN
            INPUT #1, usefont
        END IF
        IF thecommand$ = "Font:" THEN
            INPUT #1, thefont$
            INPUT #1, fontheight
        END IF
        IF thecommand$ = "Background Color:" THEN
            INPUT #1, bgcsetting

        END IF
        IF thecommand$ = "Foreground Color:" THEN
            INPUT #1, fgcsetting
        END IF
        IF thecommand$ = "Position:" THEN
            INPUT #1, tfx
            INPUT #1, tfy
            INPUT #1, tfw
            INPUT #1, tfh
        END IF
        IF thecommand$ = "Window Size:" THEN
            INPUT #1, screenw
            INPUT #1, screenh
        END IF



        INPUT #1, dummy$
    LOOP
    CLOSE #1
    dummy$ = ""
END IF

'set the syntaxlist
IF nohelp = 0 THEN
    OPEN "keywordsyntax.txt" FOR INPUT AS #1
    DO UNTIL EOF(1)
        numsyntax = numsyntax + 1
        IF numsyntax > 1000 THEN PRINT "Too many syntaxes, change DIMension": _DISPLAY: END
        LINE INPUT #1, syntaxlist$(numsyntax)
    LOOP
    CLOSE #1
END IF

'set the helpfile
IF helpfound = 1 THEN
    OPEN "help.qhp" FOR INPUT AS #1
    DO UNTIL EOF(1)
        helplines = helplines + 1
        IF helplines > 10000 THEN PRINT "Too many lines in helpfile, change DIMension": _DISPLAY: END
        LINE INPUT #1, helpfile$(helplines)
    LOOP
    CLOSE
END IF
section$ = "Index"

'set the screen size and VIEW PRINT in order to use the full screen
formerfont = _FONT
WIDTH screenw, screenh
VIEW PRINT 1 TO _HEIGHT
_FONT formerfont

'check to see if the path to qb64 actually leads to qb64, otherwise assume current directory
IF qb64path$ <> "" THEN
    dummy$ = ""
    SHELL _HIDE "dir qb64.exe/b > temp.tmp"
    OPEN "temp.tmp" FOR INPUT AS #1
    IF LOF(1) THEN INPUT #1, dummy$
    CLOSE #1
    KILL "temp.tmp"
    IF LCASE$(dummy$) <> "qb64.exe" THEN qb64path$ = ""
    dummy$ = ""
END IF


'just to check that the foreground color and background color are within range
IF fgcsetting > 15 THEN fgcsetting = 15
IF fgcsetting < 0 THEN fgcsetting = 0
IF bgcsetting > 9 THEN bgcsetting = 9
IF bgcsetting < 0 THEN bgcsetting = 0

'some settings being done here, the path should end with a \
IF MID$(currentpath$, LEN(currentpath$), 1) <> "\" THEN currentpath$ = currentpath$ + "\"
IF qb64path$ = "" THEN qb64path$ = currentpath$
editorpath$ = currentpath$
IF COMMAND$ = "" THEN filename$ = currentpath$ + "untitled.bas"
keynum = 0

'setting the textfield parameters
changedline = -1
xrel = 1
yrel = 1
IF statush = 0 THEN statush = 5
IF tfx = 0 THEN tfx = 2 'textfieldx (2)
IF tfy = 0 THEN tfy = 3 'textfieldy (3)
IF tfw = 0 THEN tfw = _WIDTH - tfx 'textfieldwidth (78)
IF tfh = 0 THEN tfh = (_HEIGHT - statush) - tfy 'textfieldheight (17)
curx = tfx
curpos = tfy


'setting the menu
thelist(1) = "  "
thelist(2) = " File "
thelist(3) = " Edit "
thelist(4) = " View "
thelist(5) = " Search "
thelist(6) = " Run "
thelist(7) = " Help "
thelist(8) = " Options "

filemenu(1) = " New        "
filemenu(2) = " Open...    "
filemenu(3) = " Save       "
filemenu(4) = " Save As... "
filemenu(5) = "-"
filemenu(6) = " Exit       "

editmenu(1) = " Cut            (CTRL+X) "
editmenu(2) = " Copy           (CTRL+C) "
editmenu(3) = " Paste          (CTRL+V) "
editmenu(4) = "-"
editmenu(5) = " Dump Undo Bank          "

viewmenu(1) = " Subs/Functions... "

searchmenu(1) = " Find...          (F3) "
searchmenu(2) = " Repeat Last Find (F3) "
searchmenu(3) = " Change...             "

runmenu(1) = " Start                       (F5) "
runmenu(2) = "-"
runmenu(3) = " Make EXE and Start          (F5) "
runmenu(4) = " Make EXE and Start Detached      "
runmenu(5) = " Make EXE Only                    "
runmenu(6) = "-"
runmenu(7) = " Open QB64                        "
runmenu(8) = " Open QB64 with File (if it exist)"
runmenu(9) = "-"
runmenu(10) = " Check Code for Common Errors (F6)"

helpmenu(1) = " Help Index...   (Shift+F1) "
helpmenu(2) = " Syntax Help...  (F1)       "

optionsmenu(1) = " Set Paths...               "
optionsmenu(2) = " Set Font...                "
optionsmenu(3) = " Formatting options...      "
optionsmenu(4) = "-"
optionsmenu(5) = " Update editor.cfg          "

formatline = tfy - 1

'setting the font
IF usefont = 1 THEN
    IF thefont$ <> "" THEN f& = _LOADFONT(thefont$, fontheight, "monospace"): _FONT f&
END IF

'default font is _FONT 16 a predefined font displaying SCREEN 0 (80*25) text
IF thefont$ = "" OR usefont = 0 THEN _FONT 16

'load file if set in COMMAND$
IF COMMAND$ <> "" AND MID$(COMMAND$, 1, 2) <> "-c" THEN
    filename$ = COMMAND$

    FOR delitem = 0 TO highest
        codetext(delitem) = ""
    NEXT
    curpos = tfy: curx = tfx: highest = 1: xrel = 1: yrel = 1: maxlen = 0: edited = 0: startx = 0: starty = 0: endx = 0: endy = 0
    filength = file2array(filename$, codetext())
    IF filength <> -1 THEN highest = filength


    IF formatset = 1 THEN runformat = 1
    currentpath$ = extractpath$(filename$)
END IF


'start of the program loop
'currentline - tfy = -17 tfy = 20

1
'IF (changedline - tfy < -1) THEN changedline = changedline + (tfy + 1)
IF pasteit = 0 OR action = 1 THEN
    _LIMIT 30

    'changing screen size cancels help
    IF help = 1 AND changescreenclick = 1 THEN

        help = 0
        section$ = "Index"
        IF prevtfy <> 0 THEN curpos = curpos - (20 - prevtfy): tfh = tfh + (20 - prevtfy): tfy = tfy - (20 - prevtfy)
    END IF
    IF keyhelp = 1 AND changescreenclick = 1 THEN keyhelp = 0: tfh = gobackh: tfy = gobacky: curpos = curpos - 4: onetimekeyhelp = 0: foundsyntax = 0

    'display mouse if fullscreen
    IF _FULLSCREEN THEN
        COLOR 0, 2
        IF xmouse > 0 AND ymouse > 0 AND xmouse <= _WIDTH AND ymouse <= _HEIGHT THEN
            LOCATE ymouse, xmouse: PRINT CHR$(SCREEN(ymouse, xmouse))
        END IF
    END IF
    exittype = _EXIT
    IF exittype = 1 OR exittype = 3 THEN
        IF edited = 0 THEN
            SYSTEM
        ELSE
            retcode = msgbox("Are you sure?", "Code has been changed since the latest save, are you sure you want to quit?", 1, 22, 6)
            IF retcode = 1 THEN
                SYSTEM
            END IF
        END IF
    END IF


    IF cursortype = 0 THEN
        IF menuclick = 0 AND browsemenu = 0 THEN

            IF mode = 0 THEN LOCATE curpos, curx, 1, 8, 8
            IF mode = 1 THEN LOCATE curpos, curx, 1, 0, 8
        ELSE
            LOCATE curpos, curx, 0
        END IF
    END IF
    IF cursortype = 1 THEN
        IF menuclick = 0 AND browsemenu = 0 THEN
            createcursor curx, curpos, mode
        END IF
    END IF




    _DISPLAY
    LOCATE curpos, curx, 0

    'PCOPY 1, 0
    '    COLOR fgcsetting, bgcsetting


    COLOR fgcsetting, bgcsetting
    CLS
    'displaying color selection (behind the textbox)
    FOR colsettings = 2 TO 17
        COLOR colsettings - 2
        IF colsettings < 10 THEN
            IF tfy + tfh + statush < screenh - 5 AND colsettings < screenw THEN LOCATE screenh - 4, colsettings: PRINT CHR$(219)
        END IF
        IF tfy + tfh + statush < screenh - 6 AND colsettings < screenw THEN LOCATE screenh - 5, colsettings: PRINT CHR$(219)
    NEXT
    COLOR fgcsetting, bgcsetting
    IF screenw > 30 THEN IF tfy + tfh + statush < screenh - 5 THEN LOCATE screenh - 4, 10: PRINT "Background Color:"; bgcsetting
    IF screenw > 39 THEN IF tfy + tfh + statush < screenh - 6 THEN LOCATE screenh - 5, 19: PRINT "Foreground Color:"; fgcsetting


    IF help = 0 AND starthelp = 1 THEN starthelp = 0
    info$ = ininfo$
    info$ = STR$(curx - tfx + xrel) + ":" + LTRIM$(STR$(curpos - tfy + yrel))
    IF action = 0 THEN firstinfo$ = "Ready."
    IF action = 1 THEN firstinfo$ = "Please wait while pasting..."
    IF changescreenclick = 1 THEN firstinfo$ = "Changing size to" + STR$(screenw) + "," + STR$(screenh) + " (ESC to stop)"
    IF runformat = 1 AND action = 0 THEN firstinfo$ = "Formatting line: " + STR$(formatline - tfy)
    IF founderror$ <> "" THEN firstinfo$ = founderror$ + " (press ESC to confirm).": fcfc = 4 ELSE fcfc = 0
    print25 firstinfo$ + SPACE$((_WIDTH - LEN(info$)) - LEN(firstinfo$)) + info$, fcfc, 3
    IF endy < 3 AND endy > 0 THEN endy = 3

    COLOR fgcsetting, bgcsetting
    DrawMenu 6, sel, 0, thelist()
    DrawMenuItem _WIDTH - 6, sel, thelist(), 7 '74
    DrawMenuItem 34, sel, thelist(), 8
    DrawFrame tfx - 1, tfy - 1, tfw + 2, tfh + 3, 1 '1,2,80,20,1
    COLOR 3, 1: LOCATE _HEIGHT - 1, _WIDTH - 1: PRINT CHR$(187)
    DrawFrame tfx - 1, tfy + tfh + 1, tfw + 2, statush, 0
    DrawVScrollBar tfx + tfw, tfy, tfh, curpos - tfy + yrel - 1, 0, highest + 1
    DrawHScrollBar tfx, tfy + tfh, tfw, curx - tfx + xrel - 1, 1, maxlen + 1
    textbox tfx, tfy, (tfx + tfw) - 1, (tfy + tfh) - 1, codetext(), xrel, yrel
    scrinfo$ = STR$(SCREEN(curpos, curx))
    onpos$ = STR$(SCREEN(curpos, curx))
    shiftit startx, starty, endx, endy, selinfo$

    'textbox title
    COLOR 7, 0
    IF currentsub$ = "" THEN thetitle$ = filename$ ELSE thetitle$ = filename$ + " - " + currentsub$
    LOCATE tfy - 1, CINT((_WIDTH / 2) - (LEN(thetitle$) / 2))
    PRINT MID$(thetitle$, 1, _WIDTH)
    COLOR fgcsetting, bgcsetting

    'check current sub/function
    IF pasteit = 0 THEN
        looksub = looksub - 1
        IF curpos - tfy + yrel - 1 < currentsuby THEN currentsub$ = "": currentsuby = 0: looksub = curpos - tfy + yrel - 1
        IF currentsuby = 0 THEN currentsub$ = ""
        IF looksub <= 0 THEN currentsub$ = "": currentsuby = 0: looksub = curpos - tfy + yrel - 1
        IF codetext(looksub) <> "" THEN
            IF LCASE$(MID$(LTRIM$(codetext(looksub)), 1, 4)) = "sub " THEN currentsub$ = LTRIM$(codetext(looksub)): currentsuby = looksub: looksub = curpos - tfy + yrel - 1
            IF LCASE$(MID$(LTRIM$(codetext(looksub)), 1, 7)) = "end sub" THEN currentsub$ = "": currentsuby = 0: looksub = curpos - tfy + yrel - 1
            IF LCASE$(MID$(LTRIM$(codetext(looksub)), 1, 9)) = "function " THEN currentsub$ = LTRIM$(codetext(looksub)): currentsuby = looksub: looksub = curpos - tfy + yrel - 1
            IF LCASE$(MID$(LTRIM$(codetext(looksub)), 1, 12)) = "end function" THEN currentsub$ = "": currentsuby = 0: looksub = curpos - tfy + yrel - 1
        END IF
    END IF


    'display the message that help is not found here so that the menues and stuff has been drawn.
    IF helpfound = 0 AND help = 1 THEN ret = msgokonly("Help not found", "help.qlp was not found. Help not available!", 10, 10, 50, 5): help = 0

    IF action = 1 THEN _DISPLAY: action = 0
    ' edit the textbox

    IF checkleny > highest THEN
        IF foundonecycle = 0 THEN
            maxlen = 0
            FOR koaljj = 0 TO highest
                IF LEN(codetext(koaljj)) > maxlen THEN maxlen = LEN(codetext(koaljj))
            NEXT
        END IF
        checkleny = 0: foundonecycle = 0
    END IF

    IF LEN(codetext(checkleny)) > maxlen THEN maxlen = LEN(codetext(checkleny)): foundonecycle = 1
    IF LEN(codetext(checkleny)) = maxlen THEN foundonecycle = 1
    checkleny = checkleny + 1

    'blinking cursor
    IF tidbit = 0 THEN tidbit = TIMER
    IF TIMER > tidbit + .2 THEN
        tidbit = 0
        IF onoff = 0 THEN onoff = 1 ELSE onoff = 0
    END IF

    'error check
    IF errorcheck = 1 AND founderror$ = "" THEN
        lastnext = 0
        firstfor = -1
        lastloop = 0
        firstdo = -1
        lastendif = 0
        firstif = -1
        lastwend = 0
        firstwhile = -1
        lastsel = 0
        firstsel = -1
        lastsif = 0
        firstsif = -1
        lastendtype = 0
        firsttype = -1
        asub = 0
        afunction = 0
        suberror = -1
        endsuberror = -1
        functionerror = -1
        endfunctionerror = -1
        forn = 0
        don = 0
        ifn = 0
        whin = 0
        seln = 0
        ifsi = 0
        typen = 0
        afunction = 0
        asub = 0
        lastfunction = 0
        lastsub = 0




        ' get a list of subs and functions
        FOR checksubs = 0 TO highest + 5
            linecheck$ = LTRIM$(RTRIM$(LCASE$(codetext(checksubs))))
            IF MID$(linecheck$, 1, 4) = "sub " THEN
                su = su + 1
                subline(su) = checksubs
                dummy = INSTR(5, linecheck$, "(")
                dummy2 = INSTR(5, linecheck$, " ")
                IF dummy2 = 0 AND dummy = 0 THEN subs$(su) = LTRIM$(RTRIM$(MID$(linecheck$, 5, LEN(linecheck$) - 1))): GOTO gogo
                IF dummy = 0 THEN subs$(su) = LTRIM$(RTRIM$(MID$(linecheck$, 5, LEN(linecheck$) - 1))): GOTO gogo
                IF dummy2 <> 0 AND dummy <> 0 THEN IF dummy2 < dummy THEN subs$(su) = LTRIM$(RTRIM$(MID$(linecheck$, 5, dummy2 - 5))): GOTO gogo
                IF dummy2 <> 0 AND dummy <> 0 THEN IF dummy2 > dummy THEN subs$(su) = LTRIM$(RTRIM$(MID$(linecheck$, 5, dummy - 5))): GOTO gogo
                IF dummy <> 0 AND dummy2 = 0 THEN subs$(su) = LTRIM$(RTRIM$(MID$(linecheck$, 5, dummy - 5)))
            END IF
            IF MID$(linecheck$, 1, 9) = "function " THEN
                fu = fu + 1
                functionline(fu) = checksubs
                dummy = INSTR(10, linecheck$, "(")
                dummy2 = INSTR(10, linecheck$, " ")
                IF dummy2 = 0 AND dummy = 0 THEN functions$(fu) = LTRIM$(RTRIM$(MID$(linecheck$, 10, LEN(linecheck$) - 1))): GOTO gogo
                IF dummy = 0 THEN functions$(fu) = LTRIM$(RTRIM$(MID$(linecheck$, 10, LEN(linecheck$) - 1))): GOTO gogo
                IF dummy2 <> 0 AND dummy <> 0 THEN IF dummy2 < dummy THEN functions$(fu) = LTRIM$(RTRIM$(MID$(linecheck$, 10, dummy2 - 10))): GOTO gogo
                IF dummy2 <> 0 AND dummy <> 0 THEN IF dummy2 > dummy THEN functions$(fu) = LTRIM$(RTRIM$(MID$(linecheck$, 10, dummy - 10))): GOTO gogo
                IF dummy <> 0 AND dummy2 = 0 THEN functions$(fu) = LTRIM$(RTRIM$(MID$(linecheck$, 10, dummy - 10)))
            END IF
            gogo:
        NEXT

        'check integrity of the found subs/functions (the names shouldn't contain any spaces, or paranteses is expected)
        FOR thesubs = 1 TO su
            IF INSTR(1, subs$(thesubs), " ") THEN founderror$ = "Expected ( in SUB on line" + STR$(subline(thesubs) + 1)
        NEXT
        FOR thefuncs = 1 TO fu
            IF INSTR(1, functions$(thefuncs), " ") THEN founderror$ = "Expected ( in FUNCTION on line" + STR$(functionline(thefuncs) + 1)
        NEXT


        'start the error checking!


        FOR erchline = 0 TO highest + 5
            erline$ = RTRIM$(LTRIM$(LCASE$(codetext(erchline))))
            'Remove remarks from the string as those mustn't be checked!
            '...we got to check that the ' or REM isn't within a quote...
            strl = 1
            qn = 0
            DO UNTIL strl > LEN(erline$)
                IF MID$(erline$, strl, 1) = CHR$(34) THEN
                    IF qn = 0 THEN qn = 1 ELSE qn = 0
                END IF
                IF MID$(erline$, strl, 1) = "'" AND qn = 0 THEN erline$ = MID$(erline$, 1, strl - 1) '...and away you go!
                IF MID$(erline$, strl, 3) = "rem" AND qn = 0 THEN
                    'found a possible REM! Let's see if it really is REM!
                    IF strl > 1 THEN
                        'check to see if surrounding characters are non-alphanumeric
                        IF ASC(erline$, strl - 1) < 48 OR (ASC(erline$, strl - 1) > 57 AND ASC(erline$, strl - 1) < 65) OR (ASC(erline$, strl - 1) > 90 AND ASC(erline$, strl - 1) < 97) OR ASC(erline$, strl - 1) > 122 THEN
                            IF LEN(erline$) >= strl + 3 THEN
                                IF ASC(erline$, strl + 3) < 48 OR (ASC(erline$, strl + 3) > 57 AND ASC(erline$, strl + 3) < 65) OR (ASC(erline$, strl + 3) > 90 AND ASC(erline$, strl + 3) < 97) OR ASC(erline$, strl + 3) > 122 THEN
                                    'it really is a rem!
                                    'remove it.
                                    erline$ = MID$(erline$, 1, strl - 1): EXIT DO 'gone!
                                END IF
                            END IF
                        END IF
                    END IF
                    IF strl = 1 THEN
                        'check to see if it ends with a non-alphanumeric character
                        IF LEN(erline$) >= strl + 3 THEN
                            IF ASC(erline$, strl + 3) < 48 OR (ASC(erline$, strl + 3) > 57 AND ASC(erline$, strl + 3) < 65) OR (ASC(erline$, strl + 3) > 90 AND ASC(erline$, strl + 3) < 97) OR ASC(erline$, strl + 3) > 122 THEN
                                'it really is a rem!
                                'remove it.
                                erline$ = MID$(erline$, 1, strl - 1): EXIT DO 'gone!
                            END IF
                        END IF
                    END IF
                END IF
                strl = strl + 1
            LOOP


            'Check so that each " has a corresponding " and that each ( has a corresponding )
            qn = 0
            pn = 0
            qs = 0
            qnum = 0
            strl = 1
            DO UNTIL strl > LEN(erline$)
                IF MID$(erline$, strl, 1) = CHR$(34) THEN
                    IF qn = 0 THEN qn = 1: qs = 1: qnum = qnum + 1 ELSE qn = 0
                END IF
                IF MID$(erline$, strl, 1) = "(" AND qn = 0 THEN pn = pn + 1
                IF MID$(erline$, strl, 1) = ")" AND qn = 0 THEN pn = pn - 1
                strl = strl + 1
            LOOP
            IF qn = 1 THEN founderror$ = "Missing " + CHR$(34) + " on line " + LTRIM$(STR$(erchline + 1)): lineoferror = erchline + 1: GOTO skiperchecking
            IF pn < 0 THEN founderror$ = "Missing ( on line " + LTRIM$(STR$(erchline + 1)): lineoferror = erchline + 1: GOTO skiperchecking
            IF pn > 0 THEN founderror$ = "Missing ) on line " + LTRIM$(STR$(erchline + 1)): lineoferror = erchline + 1: GOTO skiperchecking
            'now remove quotes as they are not wanted for checking (replace them with spaces)
            IF qs = 1 THEN 'quotes are found
                FOR dummy = 1 TO qnum 'to the number of quotes found
                    qst = INSTR(qp, erline$, CHR$(34))
                    qp = qst + 1
                    qen = INSTR(qp, erline$, CHR$(34))
                    qp = qen + 1
                    MID$(erline$, qst, (qen - qst) + 1) = SPACE$((qen - qst) + 1) 'consider yourself ignored!
                NEXT
                qp = 0
            END IF
            'isolate items (don't have to worry about "quotes" or remarks)

            strl = 1

            ERASE item$
            ERASE itemtype$

            itemindex = 0
            waitalpha = 0
            DO UNTIL strl > LEN(erline$)
                alphanum = 1
                IF ASC(erline$, strl) <= 32 THEN alphanum = 0: waitalpha = 0: itemindex = itemindex + 1
                IF ASC(erline$, strl) > 39 AND ASC(erline$, strl) < 48 AND ASC(erline$, strl) <> 46 THEN itemindex = itemindex + 1: item$(itemindex) = MID$(erline$, strl, 1): itemtype$(itemindex) = "symbol": alphanum = 0: waitalpha = 0: itemindex = itemindex + 1
                IF ASC(erline$, strl) > 57 AND ASC(erline$, strl) < 65 THEN itemindex = itemindex + 1: item$(itemindex) = MID$(erline$, strl, 1): itemtype$(itemindex) = "symbol": alphanum = 0: waitalpha = 0: itemindex = itemindex + 1
                IF ASC(erline$, strl) > 90 AND ASC(erline$, strl) < 95 THEN itemindex = itemindex + 1: item$(itemindex) = MID$(erline$, strl, 1): itemtype$(itemindex) = "symbol": alphanum = 0: waitalpha = 0: itemindex = itemindex + 1
                IF ASC(erline$, strl) > 122 THEN itemindex = itemindex + 1: item$(itemindex) = MID$(erline$, strl, 1): itemtype$(itemindex) = "symbol": alphanum = 0: waitalpha = 0: itemindex = itemindex + 1
                IF alphanum = 1 THEN item$(itemindex) = item$(itemindex) + MID$(erline$, strl, 1)
                strl = strl + 1
            LOOP



            ' organize index...

            ' first remove all "" items
            FOR indie = 0 TO itemindex
                IF item$(indie) = "" THEN
                    'remove item
                    FOR jojo = indie TO itemindex
                        item$(jojo) = item$(jojo + 1)
                        itemtype$(jojo) = itemtype$(jojo + 1)
                    NEXT
                END IF
            NEXT

            'finish the removal of items
            FOR itemindex = itemindex TO 0 STEP -1
                IF item$(itemindex) <> "" OR itemindex = 0 THEN EXIT FOR
            NEXT


            FOR indie = 0 TO itemindex
                FOR keys = 0 TO numkey
                    IF LCASE$(keyword(keys)) = item$(indie) AND INSTR(1, keytype(keys), "statement") > 0 THEN
                        itemtype$(indie) = "statement"
                        'now, some keywords are both statements and functions, and type used is then "multi"
                        'since the keyword list is in alphabetic order those "multi" items are next to eachother.
                        'for now the error checker will ignore such items.
                        IF keys > 0 THEN
                            IF LCASE$(keyword(keys - 1)) = item$(indie) AND INSTR(1, keytype(keys - 1), "function") > 0 THEN itemtype$(indie) = "multi"
                        END IF
                        IF LCASE$(keyword(keys + 1)) = item$(indie) AND INSTR(1, keytype(keys + 1), "function") > 0 THEN itemtype$(indie) = "multi"
                    END IF

                    IF LCASE$(keyword(keys)) = item$(indie) AND INSTR(1, keytype(keys), "function") > 0 THEN
                        itemtype$(indie) = "function"
                        IF keys > 0 THEN
                            IF LCASE$(keyword(keys - 1)) = item$(indie) AND INSTR(1, keytype(keys - 1), "statement") > 0 THEN itemtype$(indie) = "multi"
                        END IF
                        IF LCASE$(keyword(keys + 1)) = item$(indie) AND INSTR(1, keytype(keys + 1), "statement") > 0 THEN itemtype$(indie) = "multi"
                    END IF

                NEXT
                FOR thesubs = 1 TO su
                    IF item$(indie) = subs$(thesubs) THEN itemtype$(indie) = "sub"
                NEXT
                FOR thefuncs = 1 TO fu
                    IF item$(indie) = functions$(thefuncs) THEN itemtype$(indie) = "function"
                NEXT
                isnum = 0
                FOR strinu = 1 TO LEN(item$(indie))
                    IF ASC(item$(indie), strinu) > 47 AND ASC(item$(indie), strinu) < 58 THEN isnum = isnum + 1
                NEXT
                IF isnum = LEN(item$(indie)) THEN itemtype$(indie) = "number"

                IF itemtype$(indie) = "" AND item$(indie) <> "" THEN itemtype$(indie) = "unknown"
                IF item$(indie) = "" THEN itemtype$(indie) = ""
            NEXT

            itemtype$(itemindex + 1) = ""

            ' index is done.

            '******************************Troubleshooting if needed*************************************
            'COLOR 15, 0
            'PRINT erline$
            'FOR k = 0 TO itemindex
            '    PRINT "ITEM"; k; CHR$(34) + item$(k) + CHR$(34) + ": " + CHR$(34) + itemtype$(k) + CHR$(34)
            'NEXT
            '_DISPLAY
            'END
            '***********************Use the first line for troubleshooting*******************************

            'use index to check FOR...NEXT, DO...LOOP, WHILE...WEND, IF...THEN, SUB...END SUB, FUNCTION...END FUNCTION, etc.

            FOR indie = 0 TO itemindex
                IF item$(indie) = "for" AND item$(indie - 1) <> "exit" AND item$(indie + 1) <> "output" AND item$(indie + 1) <> "input" AND item$(indie + 1) <> "random" AND item$(indie + 1) <> "binary" AND item$(indie + 1) <> "append" THEN forn = forn + 1: IF firstfor = -1 THEN firstfor = erchline
                IF item$(indie) = "next" AND item$(indie - 1) <> "resume" THEN
                    n = 0
                    DO
                        forn = forn - 1: lastnext = erchline
                        n = n + 2
                    LOOP UNTIL item$(indie + n) <> "," 'supports NEXT a, b, c (doesn't check validity though)
                END IF

                IF item$(indie) = "do" AND item$(indie - 1) <> "exit" THEN don = don + 1: IF firstdo = -1 THEN firstdo = erchline
                IF item$(indie) = "loop" THEN don = don - 1: lastloop = erchline: IF don = 0 THEN firstdo = -1
                IF item$(indie) = "if" AND item$(indie - 1) <> "end" THEN ifsi = ifsi + 1: IF firstsif = -1 THEN firstsif = erchline
                IF item$(indie) = "then" THEN ifsi = ifsi - 1: lastsif = erchline: IF ifsi = 0 THEN firstsif = -1
                IF item$(indie) = "goto" AND item$(indie - 1) <> "then" AND indie <> 0 AND item$(indie - 1) <> ":" AND item$(indie - 1) <> "else" AND item$(indie - 1) <> "error" AND item$(indie - 1) <> "timer" AND item$(indie - 2) <> "on" AND indie <> 1 THEN ifsi = ifsi - 1: lastsif = erchline: IF ifsi = 0 THEN firstsif = -1 'GOTO can be used instead of THEN
                IF item$(indie) = "then" AND indie = itemindex THEN ifn = ifn + 1: IF firstif = -1 THEN firstif = erchline
                IF item$(indie) = "end" AND item$(indie + 1) = "if" THEN ifn = ifn - 1: lastendif = erchline: IF ifn = 0 THEN firstif = -1
                IF item$(indie) = "while" AND item$(indie - 1) <> "do" AND item$(indie - 1) <> "exit" AND item$(indie - 1) <> "loop" THEN whin = whin + 1: IF firstwhile = -1 THEN firstwhile = erchline
                IF item$(indie) = "wend" THEN whin = whin - 1: lastwend = erchline: IF whin = 0 THEN firstwhile = -1
                IF item$(indie) = "select" AND item$(indie + 1) = "case" THEN seln = seln + 1: IF firstseln = -1 THEN firstseln = erchline
                IF item$(indie) = "end" AND item$(indie + 1) = "select" THEN seln = seln - 1: lastendsel = erchline: IF seln = 0 THEN firstseln = -1
                IF item$(indie) = "type" AND item$(indie - 1) <> "end" THEN typen = typen + 1: IF firsttype = -1 THEN firsttype = erchline
                IF item$(indie) = "end" AND item$(indie + 1) = "type" THEN typen = typen - 1: lastendtype = erchline: IF typen = 0 THEN firsttype = -1

                IF item$(indie) = "sub" AND indie = 0 THEN
                    IF asub = 0 THEN asub = 1: lastsub = erchline ELSE suberror = erchline: GOTO errorwasfound
                    IF afunction = 1 THEN functionerror = erchline: GOTO errorwasfound
                END IF

                IF item$(indie) = "end" AND item$(indie + 1) = "sub" AND indie = 0 THEN
                    IF asub = 0 THEN endsuberror = erchline: GOTO errorwasfound ELSE asub = 0
                    IF afunction = 1 THEN functionerror = erchline: GOTO errorwasfound
                END IF

                IF item$(indie) = "function" AND indie = 0 THEN
                    IF afunction = 0 THEN afunction = 1: lastfunction = erchline ELSE functionerror = erchline: GOTO errorwasfound
                    IF asub = 1 THEN suberror = erchline: GOTO errorwasfound
                END IF

                IF item$(indie) = "end" AND item$(indie + 1) = "function" AND indie = 0 THEN
                    IF afunction = 1 THEN afunction = 0 ELSE endfunctionerror = erchline: GOTO errorwasfound
                    IF asub = 1 THEN suberror = erchline: GOTO errorwasfound
                END IF



                IF itemtype$(indie) = "function" AND itemtype$(indie + 1) = "function" THEN founderror$ = "Function incorrectly used ( maybe? On line" + STR$(erchline + 1): lineoferror = erchline + 1: GOTO errorwasfound
                IF itemtype$(indie) = "unknown" AND item$(indie) <> "def" AND item$(indie - 1) <> ":" AND itemtype$(indie + 1) = "unknown" AND indie <> itemindex AND indie > 0 THEN founderror$ = "Seperator expected on line" + STR$(erchline + 1): lineoferror = erchline + 1: GOTO errorwasfound

            NEXT

            'here we can continue searching for errors...


        NEXT
        IF asub = 1 THEN suberror = lastsub: GOTO errorwasfound
        IF afunction = 1 THEN functionerror = lastfunction: GOTO errorwasfound
        IF forn < 0 THEN founderror$ = "NEXT without FOR on line" + STR$(lastnext + 1): lineoferror = lastnext + 1
        IF forn > 0 THEN founderror$ = "FOR without NEXT on line" + STR$(firstfor + 1): lineoferror = firstfor + 1
        IF don < 0 THEN founderror$ = "LOOP without DO on line" + STR$(lastloop + 1): lineoferror = lastloop + 1
        IF don > 0 THEN founderror$ = "DO without LOOP on line" + STR$(firstdo + 1): lineoferror = firstdo + 1
        IF ifn < 0 THEN founderror$ = "END IF without IF on line" + STR$(lastendif + 1): lineoferror = lastendif + 1
        IF ifn > 0 THEN founderror$ = "IF without END IF on line" + STR$(firstif + 1): lineoferror = firstif + 1
        IF whin < 0 THEN founderror$ = "WEND without WHILE on line" + STR$(lastwend + 1): lineoferror = lastwend + 1
        IF whin > 0 THEN founderror$ = "WHILE without WEND on line" + STR$(firstwhile + 1): lineoferror = firstwhile + 1
        IF seln < 0 THEN founderror$ = "END SELECT without SELECT on line" + STR$(lastsel + 1): lineoferror = lastsel + 1
        IF seln > 0 THEN founderror$ = "SELECT CASE without END SELECT on line" + STR$(firstsel + 1): lineoferror = firstsel + 1
        IF ifsi < 0 THEN founderror$ = "THEN without IF on line" + STR$(lastsif + 1): lineoferror = lastsif + 1
        IF ifsi > 0 THEN founderror$ = "IF without THEN on line" + STR$(firstsif + 1): lineoferror = firstsif + 1
        IF typen < 0 THEN founderror$ = "END TYPE without TYPE on line" + STR$(lastendtype + 1): lineoferror = lastendtype + 1
        IF typen > 0 THEN founderror$ = "TYPE without END TYPE on line" + STR$(firsttype + 1): lineoferror = firsttype + 1
        errorwasfound:
        lastnext = 0
        firstfor = -1
        lastloop = 0
        firstdo = -1
        lastendif = 0
        firstif = -1
        lastwend = 0
        firstwhile = -1
        lastsel = 0
        firstsel = -1
        lastsif = 0
        firstsif = -1
        lastendtype = 0
        firsttype = -1
        errorcheck = 0
        IF suberror >= 0 THEN founderror$ = "SUB without END SUB on (or above) line" + STR$(suberror + 1): lineoferror = suberror + 1
        IF endsuberror >= 0 THEN founderror$ = "END SUB without SUB on line" + STR$(endsuberror + 1): lineoferror = endsuberror + 1
        IF functionerror >= 0 THEN founderror$ = "FUNCTION without END FUNCTION on (or above) line" + STR$(functionerror + 1): lineoferror = functionerror + 1
        IF endfunctionerror >= 0 THEN founderror$ = "END FUNCTION without FUNCTION on line" + STR$(endfunctionerror + 1): lineoferror = endfunctionerror + 1
        suberror = -1
        endsuberror = -1
        functionerror = -1
        endfunctionerror = -1
        forn = 0
        don = 0
        ifn = 0
        whin = 0
        seln = 0
        ifsi = 0
        typen = 0
        afunction = 0
        asub = 0
        lastfunction = 0
        lastsub = 0
    END IF
    skiperchecking:

    'help
    IF help = 1 THEN
        IF screenh > 45 AND screenw > 79 THEN readyforhelp = 1 ELSE readyforhelp = 0: help = 0: ret = msgokonly("Screen size too small to display help!", "Change size to 80*46 or more!", 10, 10, 37, 5)
        IF helpfound = 1 AND readyforhelp = 1 THEN
            IF starthelp = 0 THEN
                'initialise help
                starthelp = 1
                IF tfy < 20 THEN prevtfy = tfy: curpos = curpos + (20 - tfy): tfh = tfh - (20 - tfy): tfy = 20
            END IF

            'here goes the help code...
            IF currentsection$ <> section$ THEN
                'find the helpsection...
                FOR findsec = 1 TO helplines
                    secpos1 = INSTR(1, helpfile$(findsec), "<")
                    secpos2 = INSTR(1, helpfile$(findsec), ">")
                    IF secpos1 < secpos2 THEN
                        'found the beginning of a section
                        IF MID$(helpfile$(findsec), secpos1 + 1, secpos2 - (secpos1 + 1)) = section$ THEN foundsec = 1: EXIT FOR
                    END IF
                NEXT
                IF foundsec = 0 THEN ret = msgokonly("Section not found (" + section$ + ")", "Going back to previous section.", 10, 10, 50, 5): tryprevsec = 1: section$ = currentsection$
                IF foundsec = 0 AND tryprevsec = 1 THEN ret = msgokonly("Section not found (" + section$ + ")", "Help corrupted, ending help.", 10, 10, 50, 5): help = 0: tryprevsec = 0: section$ = "Index"
                IF foundsec = 1 THEN
                    sthelp = findsec
                    enhelp = findsec + 17
                    currentsection$ = section$
                END IF
            END IF
            IF currentsection$ = section$ THEN
                COLOR fgcsetting, 0
                FOR k = 2 TO 19
                    IF k < tfy - 1 AND k = 2 THEN LOCATE k, 1: PRINT CHR$(218) + STRING$(_WIDTH - 2, 196) + CHR$(191)
                    IF k < tfy - 1 AND k > 2 AND k < 19 THEN LOCATE k, 1: PRINT CHR$(179) + SPACE$(_WIDTH - 2) + CHR$(179)
                    IF k < tfy AND k = 19 THEN
                        IF tfy = 19 + 1 THEN
                            COLOR fgcsetting, bgcsetting: LOCATE k, 1: PRINT CHR$(195) + STRING$(_WIDTH - 2, 196) + CHR$(180)
                            COLOR fgcsetting, 0
                        END IF
                        IF tfy > 19 + 1 THEN
                            LOCATE k, 1: PRINT CHR$(192) + STRING$(_WIDTH - 2, 196) + CHR$(217)
                        END IF

                    END IF
                NEXT
                COLOR 9, 0
                LOCATE 2, CINT(_WIDTH / 2) - CINT(LEN("Help - " + section$) / 2): PRINT "Help - " + section$
                COLOR 7, 0
                links = 0
                FOR k = 3 TO 18
                    helplinehere$ = helpfile$((k - 2) + sthelp)
                    subtractone = 1
                    'IF INSTR(1, helplinehere$, "**color") > 0 AND INSTR(1, helplinehere$, "**center**") > 0 THEN subtractone = 1
                    colorcheck = INSTR(1, helplinehere$, "**color")
                    IF colorcheck THEN endofcolor = INSTR(colorcheck + 2, helplinehere$, "*")
                    IF colorcheck THEN COLOR VAL(MID$(helplinehere$, colorcheck + 8, endofcolor - colorcheck + 8))
                    IF colorcheck THEN helplinehere$ = MID$(helplinehere$, 1, colorcheck - 1) + MID$(helplinehere$, endofcolor + 2)
                    centercheck = INSTR(1, helplinehere$, "**center**")
                    IF centercheck THEN helplinehere$ = MID$(helplinehere$, centercheck + 10)
                    IF centercheck THEN helplinehere$ = SPACE$((CINT(_WIDTH / 2) - CINT(LEN(helplinehere$) / 2)) - (1 + subtractone)) + helplinehere$
                    DO
                        linkcheck = INSTR(1, helplinehere$, "[[")
                        IF linkcheck THEN links = links + 1: linkx(links) = linkcheck: linky(links) = k: linktext$(links) = MID$(helplinehere$, linkcheck + 2, (INSTR(1, helplinehere$, "]]") - (linkcheck + 2))): MID$(helplinehere$, linkcheck, (INSTR(1, helplinehere$, "]]") - linkcheck) + 2) = SPACE$(((INSTR(1, helplinehere$, "]]") - linkcheck) + 2)): helplinehere$ = MID$(helplinehere$, 1, linkcheck) + MID$(helplinehere$, linkcheck + 4)
                    LOOP UNTIL linkcheck = 0

                    IF k < tfy - 1 THEN LOCATE k, 2: PRINT helplinehere$
                    IF MID$(helplinehere$, 1, 1) = "-" AND k < tfy - 1 THEN LOCATE k, 1: PRINT CHR$(195) + STRING$(_WIDTH - 2, 196) + CHR$(180)
                    IF links > 0 THEN
                        overanylink = 0
                        FOR curlink = 1 TO links
                            IF linky(curlink) < tfy - 1 THEN
                                IF ymouse = linky(curlink) AND xmouse >= linkx(curlink) + 2 AND xmouse <= linkx(curlink) + LEN(linktext$(curlink)) + 3 THEN COLOR 14, 0: overlink = 1: overanylink = 1 ELSE COLOR 2, 0: overlink = 0
                                IF linksel = curlink THEN COLOR 14, 0
                                IF overlink = 1 AND bmouse = -1 THEN waitforrelease = 1
                                IF overlink = 1 AND bmouse = 0 AND waitforrelease = 1 THEN section$ = linktext$(curlink): waitforrelease = 0
                                LOCATE linky(curlink), linkx(curlink) + 2: PRINT CHR$(17) + linktext$(curlink) + CHR$(16)
                            END IF
                        NEXT
                        'IF overanylink = 0 AND bmouse = 0 THEN waitforrelease = 0
                        COLOR 7, 0
                    END IF


                NEXT
                COLOR fgcsetting, bgcsetting
            END IF


        END IF
    END IF


    'keyword help
    IF keyhelp = 1 THEN

        IF onetimekeyhelp = 0 THEN
            onetimekeyhelp = 1
            'first look for subs/functions since keywords can't be subs or functions anyway...
            description$ = ""
            FOR subsyntaxy = 0 TO highest + 5
                codechecking$ = LTRIM$(LCASE$(codetext(subsyntaxy)))
                ' delete all &%# etc., only $ are checked.
                strip = 0
                DO
                    IF LEN(codechecking$) = 0 THEN EXIT DO
                    strip = strip + 1
                    IF strip > LEN(codechecking$) THEN EXIT DO
                    IF ASC(MID$(codechecking$, strip, 1)) > 32 AND ASC(MID$(codechecking$, strip, 1)) < 48 AND ASC(MID$(codechecking$, strip, 1)) <> 36 THEN codechecking$ = MID$(codechecking$, 1, strip - 1) + MID$(codechecking$, strip + 1): strip = strip - 1
                LOOP UNTIL strip >= LEN(codechecking$)
                IF MID$(codechecking$, 1, 4) = "sub " AND MID$(codechecking$, 5, LEN(syntaxcheck$) + 1) = LCASE$(syntaxcheck$) + " " THEN
                    thesyntax$ = codetext(subsyntaxy)
                    'check if first line after SUB is a comment and use that as description
                    IF MID$(LTRIM$(RTRIM$(codetext(subsyntaxy + 1))), 1, 1) = "'" THEN description$ = MID$(LTRIM$(RTRIM$(codetext(subsyntaxy + 1))), 2, _WIDTH)
                    IF LCASE$(MID$(LTRIM$(RTRIM$(codetext(subsyntaxy + 1))), 1, 3)) = "rem" THEN description$ = MID$(LTRIM$(RTRIM$(codetext(subsyntaxy + 1))), 4, _WIDTH)
                    foundsyntax = 1
                    EXIT FOR
                END IF
                IF MID$(codechecking$, 1, 9) = "function " AND MID$(codechecking$, 10, LEN(syntaxcheck$) + 1) = LCASE$(syntaxcheck$) + " " THEN
                    thesyntax$ = codetext(subsyntaxy)
                    IF MID$(LTRIM$(RTRIM$(codetext(subsyntaxy + 1))), 1, 1) = "'" THEN description$ = MID$(LTRIM$(RTRIM$(codetext(subsyntaxy + 1))), 2, _WIDTH)
                    IF LCASE$(MID$(LTRIM$(RTRIM$(codetext(subsyntaxy + 1))), 1, 3)) = "rem" THEN description$ = MID$(LTRIM$(RTRIM$(codetext(subsyntaxy + 1))), 4, _WIDTH)
                    foundsyntax = 1
                    EXIT FOR
                END IF
            NEXT

            'if no subs/functions were found look for keywords
            IF nohelp = 0 AND foundsyntax = 0 THEN
                IF former = 0 THEN former = 1
                skipnextsyntax = 0
                FOR place = former TO numsyntax
                    IF INSTR(1, syntaxlist$(place), UCASE$(syntaxcheck$)) THEN thesyntax$ = syntaxlist$(place): skipnextsyntax = 1: former = place + 1: foundsyntax = 1: EXIT FOR
                NEXT
                IF skipnextsyntax = 0 THEN
                    IF former > 1 THEN
                        FOR place = 1 TO former
                            IF INSTR(1, syntaxlist$(place), UCASE$(syntaxcheck$)) THEN thesyntax$ = syntaxlist$(place): former = place + 1: foundsyntax = 1: EXIT FOR
                        NEXT
                    END IF
                END IF
            END IF

            'no subs/functions were found and no keywords.
            IF foundsyntax = 0 THEN
                thesyntax$ = "No syntax found..."
            END IF

        END IF


        COLOR 15, 0
        IF tfy > 3 THEN
            LOCATE 2, 1: PRINT SPACE$(_WIDTH)
            IF nohelp = 0 THEN LOCATE 2, 1: PRINT "Syntax:"
            IF nohelp = 1 THEN LOCATE 2, 1: PRINT "Syntax: (keywordsyntax.txt not found!)"
        END IF

        IF tfy > 4 THEN
            LOCATE 3, 1: PRINT SPACE$(_WIDTH)
            LOCATE 3, 1: PRINT "    " + thesyntax$
        END IF

        IF tfy > 5 THEN
            LOCATE 4, 1: PRINT SPACE$(_WIDTH)
            COLOR 7, 0
            LOCATE 4, 1: PRINT description$
        END IF

        IF tfy > 6 THEN
            LOCATE 5, 1: PRINT SPACE$(_WIDTH)
            COLOR 14, 0
            LOCATE 5, 1: PRINT "(press F1 again if this is not the usage you were looking for)"
        END IF

        COLOR fgcsetting, bgcsetting
    END IF



    'running format (if line is changed formatting is automatically produced)
    IF runformat = 1 THEN
        formatline = formatline + 1
        IF formatline + 1 <> curpos + yrel - 1 THEN
            changedline = formatline
            IF formatline > highest + 2 THEN runformat = 0: formatline = tfy - 1
        END IF
    END IF


    'verify and change...
    IF ifoundit = 1 THEN
        ifoundit = 0

        DO

            exittype = _EXIT
            IF exittype = 1 OR exittype = 3 THEN
                IF edited = 0 THEN
                    SYSTEM
                ELSE
                    retcode = msgbox("Are you sure?", "Code has been changed since the latest save, are you sure you want to quit?", 1, 22, 6)
                    IF retcode = 1 THEN
                        SYSTEM
                    END IF
                END IF
            END IF

            IF curpos - tfy > 2 OR curpos + tfy > 20 THEN
                fyfyfy = -3
                sysysy = -2
                tytyty = -1
            ELSE
                fyfyfy = 1
                sysysy = 2
                tytyty = 3
            END IF

            LOCATE curpos + fyfyfy, 10: COLOR 0, 7: PRINT CHR$(218) + STRING$(26, 196) + CHR$(191)
            LOCATE curpos + sysysy, 10: COLOR 0, 7: PRINT CHR$(179) + STRING$(26, 32) + CHR$(179)
            LOCATE curpos + tytyty, 10: COLOR 0, 7: PRINT CHR$(192) + STRING$(26, 196) + CHR$(217)
            IF selecta = 0 THEN COLOR 7, 0 ELSE COLOR 0, 7
            LOCATE curpos + sysysy, 11: PRINT "<OK>"
            IF selecta = 1 THEN COLOR 7, 0 ELSE COLOR 0, 7
            LOCATE curpos + sysysy, 19: PRINT "<Skip>"
            IF selecta = 2 THEN COLOR 7, 0 ELSE COLOR 0, 7
            LOCATE curpos + sysysy, 29: PRINT "<Cancel>"
            akeyb$ = INKEY$
            SELECT CASE akeyb$
                CASE CHR$(0) + "K": IF selecta > 0 THEN selecta = selecta - 1 ELSE selecta = 2
                CASE CHR$(0) + "M": IF selecta < 2 THEN selecta = selecta + 1 ELSE selecta = 0
                CASE CHR$(9): selecta = selecta + 1: IF selecta > 2 THEN selecta = 0
                CASE CHR$(27): verifyandchange = 0: nametochange$ = "": find$ = "": GOTO wearedonenow
                CASE CHR$(13)
                    IF selecta = 0 THEN codetext(currentsy) = MID$(codetext(currentsy), 1, posin - 1) + changeto$ + MID$(codetext(currentsy), posin + LEN(find$))
                    '                    IF selecta = 1 THEN makesureitskipped = 1
                    IF selecta = 2 THEN verifyandchange = 0: nametochange$ = "": find$ = "": selecta = 0
                    EXIT DO
            END SELECT
            DO WHILE _MOUSEINPUT
                musenxe = CINT(_MOUSEX)
                musenye = CINT(_MOUSEY)
                musenbe = _MOUSEBUTTON(1)
            LOOP
            IF musenye = curpos + sysysy AND musenxe >= 11 AND musenxe <= 14 THEN
                IF musenbe = -1 THEN waitokrelease = 1: selecta = 0
                IF waitokrelease = 1 AND musenbe = 0 THEN codetext(currentsy) = MID$(codetext(currentsy), 1, posin - 1) + changeto$ + MID$(codetext(currentsy), posin + LEN(find$)): waitokrelease = 0: EXIT DO
            ELSE
                waitokrelease = 0
            END IF

            IF musenye = curpos + sysysy AND musenxe >= 19 AND musenxe <= 24 THEN
                IF musenbe = -1 THEN waitskiprelease = 1: selecta = 1
                IF waitskiprelease = 1 AND musenbe = 0 THEN waitskiprelease = 0: EXIT DO
            ELSE
                waitskiprelease = 0
            END IF

            IF musenye = curpos + sysysy AND musenxe >= 29 AND musenxe <= 36 THEN
                IF musenbe = -1 THEN waitcancelrelease = 1: selecta = 2
                IF waitcancelrelease = 1 AND musenbe = 0 THEN verifyandchange = 0: nametochange$ = "": find$ = "": selecta = 0: waitcancelrelease = 0: GOTO wearedonenow 'EXIT DO
            ELSE
                waitcancelrelease = 0
            END IF


            IF _FULLSCREEN THEN

                IF musenxe > 0 AND musenye > 0 AND musenxe <= _WIDTH AND musenye <= _HEIGHT THEN
                    LOCATE musenye, musenxe, 1, 1, 8
                END IF
            END IF

            _DISPLAY
            'IF _WIDTH = 80 AND _HEIGHT = 25 THEN PCOPY 1, 0 ELSE PCOPY 0, 1



        LOOP

    END IF
    IF verifyandchange = 0 THEN firstcheckcurrent = 0
    IF verifyandchange = 1 THEN
        find$ = nametochange$
        IF find$ = changeto$ THEN GOTO wearedonenow
        herewegoagain2:
        foundsearchstring = 0
        searchx = (curx - (tfx - 1)) + (xrel - 1): searchy = curpos - tfy + yrel - 1
        IF onetimeonly2 = 0 THEN
            onetimeonly2 = 1

            IF curallmod = 1 THEN
                startmody = 0
                endmody = highest + 5
            END IF
            IF curallmod = 0 THEN
                checkingmody = searchy
                DO
                    IF checkingmody <= 0 THEN checkingmody = 0: EXIT DO
                    IF firstcheckcurrent = 0 THEN firstcheckcurrent = 1: IF LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 4))) = "sub " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 9))) = "function " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 8))) = "end sub " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 13))) = "end function " THEN EXIT DO
                    checkingmody = checkingmody - 1
                    IF LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 4))) = "sub " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 9))) = "function " THEN EXIT DO
                    IF LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 8))) = "end sub " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 13))) = "end function " THEN checkingmody = checkingmody + 1: EXIT DO
                LOOP UNTIL checkingmody = 0
                startmody = checkingmody
                checkingendy = searchy
                DO
                    checkingendy = checkingendy + 1
                    IF checkingendy >= highest + 5 THEN checkingendy = highest + 5: EXIT DO
                    IF LCASE$(LTRIM$(MID$(codetext(checkingendy), 1, 4))) = "sub " OR LCASE$(LTRIM$(MID$(codetext(checkingendy), 1, 9))) = "function " THEN checkingendy = checkingendy - 1: EXIT DO
                    IF LCASE$(LTRIM$(MID$(codetext(checkingendy), 1, 8))) = "end sub " OR LCASE$(LTRIM$(MID$(codetext(checkingendy), 1, 13))) = "end function " THEN checkingendy = checkingendy - 1: EXIT DO
                LOOP UNTIL checkingendy = highest + 5
                endmody = checkingendy
            END IF
        END IF

        'only the first time does currentsx become searchx
        IF onetimeonly = 0 THEN currentsx = searchx: firstsearchx = searchx: firstsearchy = searchy: onetimeonly = 1


        IF nextsearch = 0 THEN
            FOR currentsy = searchy TO endmody
                FOR posin = currentsx TO LEN(codetext(currentsy))
                    thereitis = 0
                    IF (casesensitive = 1 AND MID$(codetext(currentsy), posin, LEN(find$)) = find$) AND (lastx <> posin OR lasty <> currentsy) THEN thereitis = 1: EXIT FOR
                    IF (casesensitive = 0 AND LCASE$(MID$(codetext(currentsy), posin, LEN(find$))) = LCASE$(find$)) AND (lastx <> posin OR lasty <> currentsy) THEN thereitis = 1: EXIT FOR
                NEXT
                IF thereitis = 0 THEN currentsx = 1
                IF thereitis = 1 THEN lastx = posin: lasty = currentsy: foundsearchstring = 1: GOTO foundsearchagain4
            NEXT
        END IF
        IF nextsearch = 0 THEN searchy = startmody
        nextsearch = 1

        ' searchstring doesn't exist from searchy (searchx) to endmody

        ' checking to see if it exists from startmody to firstsearchy (with searchx = 1)
        ' firstsearchy since searchy is corrupted with the current y position.
        'the first search is now disabled (why search it again?)

        FOR currentsy = searchy TO firstsearchy
            'IF currentsx + LEN(find$) - 1 > LEN(codetext(currentsy)) THEN currentsx = 1: GOTO skipthisnow
            FOR posin = currentsx TO LEN(codetext(currentsy))
                thereitis = 0
                IF posin = firstsearchx AND currentsy = firstsearchy THEN GOTO wearedonenow ' if it reaches the first x (which is checked) then we are done.
                IF (casesensitive = 1 AND MID$(codetext(currentsy), posin, LEN(find$)) = find$) AND (lastx <> posin OR lasty <> currentsy) THEN thereitis = 1: EXIT FOR
                IF (casesensitive = 0 AND LCASE$(MID$(codetext(currentsy), posin, LEN(find$))) = LCASE$(find$)) AND (lastx <> posin OR lasty <> currentsy) THEN thereitis = 1: EXIT FOR
            NEXT
            skipthisnow:
            IF thereitis = 1 THEN lastx = posin: lasty = currentsy: foundsearchstring = 1: GOTO foundsearchagain4
            IF thereitis = 0 THEN currentsx = 1
        NEXT
        ' it may reach this if the first cursor x position was larger than the length of the text of the first search line. (but then that entire line wasn't searched so the user should be allowed to choose to change each item there).

        GOTO wearedonenow
        foundsearchagain4:
        IF foundsearchstring = 1 THEN

            yrel = 1 + (ABS(currentsy - 7 > 0) * (currentsy - 7))
            IF yrel = 1 THEN curpos = currentsy + tfy
            IF yrel > 1 THEN curpos = 10
            IF yrel > highest + 5 THEN yrel = highest: curpos = 5
            xrel = 1 + (ABS(posin - 38 > 0) * (posin - 38))
            IF xrel = 1 THEN curx = posin + (tfx - 1)
            IF xrel > 1 THEN curx = 39
            '             firstsearchx = firstsearchx + 1

            currentsx = posin + 1
            startx = curx + xrel - 1: endx = curx + (xrel - 1) + LEN(find$) - 1: starty = curpos + yrel - 1: endy = curpos + yrel - 1
            ifoundit = 1: GOTO wearedone2

        END IF
        GOTO wearedone2
        wearedonenow:

        rete = msgokonly("Search Complete", "Done.", 10, 10, 28, 5)
        currentsy = 0: currentsx = 0: firstsearchy = 0: firstsearchx = 0: nextsearch = 0: endline = 0
        verifyandchange = 0: tryagain = 0: searchx = 0: searchy = 0: startmody = 0: endmody = 0
        checkingmody = 0: checkingendy = 0: foundsearch = 0: onetimeonly = 0: nexty = 0
        lastx = 0: lasty = 0: selecta = 0: onetimeonly2 = 0: firstcheckcurrent = 0


        wearedone2:

    END IF


    SHIFT = scankey(54) OR scankey(42)
    alt = scankey(56)
    ctrl = scankey(29)
    key1 = scankey(2)
    key2 = scankey(3)
    key3 = scankey(4)
    key4 = scankey(5)
    key5 = scankey(6)
    key6 = scankey(7)
    key7 = scankey(8)
    key8 = scankey(9)
    key9 = scankey(10)
    key0 = scankey(11)

    searchst$ = ""
    IF alt = 0 AND dontmenu = 1 THEN dontmenu = 0
    IF alt = 0 AND waitrelease = 1 THEN waitrelease = 0
    IF ctrl AND key1 THEN searchst$ = "1"
    IF ctrl AND key2 THEN searchst$ = "2"
    IF ctrl AND key3 THEN searchst$ = "3"
    IF ctrl AND key4 THEN searchst$ = "4"
    IF ctrl AND key5 THEN searchst$ = "5"
    IF ctrl AND key6 THEN searchst$ = "6"
    IF ctrl AND key7 THEN searchst$ = "7"
    IF ctrl AND key8 THEN searchst$ = "8"
    IF ctrl AND key9 THEN searchst$ = "9"
    IF ctrl AND key0 THEN searchst$ = "0"
    IF alt AND key4 THEN dontmenu = 1: browsemenu = 0: sel = 0: keysel = 0
    IF alt AND key2 THEN dontmenu = 1: browsemenu = 0: sel = 0: keysel = 0
    IF alt AND key3 THEN dontmenu = 1: browsemenu = 0: sel = 0: keysel = 0
    IF alt AND key7 THEN dontmenu = 1: browsemenu = 0: sel = 0: keysel = 0
    IF alt AND key8 THEN dontmenu = 1: browsemenu = 0: sel = 0: keysel = 0
    IF alt AND key9 THEN dontmenu = 1: browsemenu = 0: sel = 0: keysel = 0
    IF alt AND key0 THEN dontmenu = 1: browsemenu = 0: sel = 0: keysel = 0


    IF searchst$ <> "" THEN
        FOR searchplace = 0 TO highest + 5
            IF LTRIM$(RTRIM$(codetext(searchplace))) = "'$" + searchst$ THEN
                curpos = tfy
                curx = tfx
                yrel = searchplace + 1
                xrel = 0
            END IF

        NEXT

    END IF


    wmouse = 0

    DO WHILE _MOUSEINPUT
        xmouse = CINT(_MOUSEX)
        ymouse = CINT(_MOUSEY)
        bmouse = _MOUSEBUTTON(1)

        wmouse = wmouse + _MOUSEWHEEL
        '        xmouse = CINT(xmouse)
        '        ymouse = CINT(ymouse)
    LOOP

    IF wmouse THEN
        IF wmouse < 0 THEN curpos = tfy: IF yrel > tfy THEN yrel = yrel - 3 ELSE yrel = 1
        IF wmouse > 0 THEN curpos = (tfy + tfh) - 1: IF yrel < highest - 3 THEN yrel = yrel + 3 ELSE yrel = highest - 3
    END IF
    IF changescreenclick = 1 THEN
        startx = 0: endx = 0: starty = 0: endy = 0: selinfo$ = ""
        IF xmouse > tfx + 45 AND ymouse > tfy + statush + 7 THEN
            screenh = ymouse + 1
            screenw = xmouse + 1
            IF screenh <> _HEIGHT OR screenw <> _WIDTH THEN
                prevfont = _FONT
                IF _FULLSCREEN THEN

                    IF xmouse > 0 AND ymouse > 0 AND xmouse <= _WIDTH AND ymouse <= _HEIGHT THEN
                        LOCATE ymouse, xmouse, 1, 1, 8
                    END IF
                END IF

                _DISPLAY
                WIDTH screenw, screenh: VIEW PRINT 1 TO _HEIGHT
                _FONT prevfont
                tfw = _WIDTH - tfx
                tfh = (_HEIGHT - statush) - tfy
            END IF
        END IF
        'IF bmouse = 0 THEN changescreenclick = 0
    END IF
    'IF bmouse = 0 THEN changescreenclick = 0
    IF bmouse OR (alt AND dontmenu = 0) THEN
        IF waitrelease = 0 OR changescreenclick = 1 THEN
            IF changexyclick = 0 AND changewyclick = 0 AND changexhclick = 0 AND changewhclick = 0 THEN
                IF xmouse = tfx - 1 AND ymouse = tfy - 1 AND codeclick = 0 AND changescreenclick = 0 THEN changexyclick = 1
                IF xmouse = tfx + tfw AND ymouse = tfy - 1 AND codeclick = 0 AND changescreenclick = 0 AND fieldudclick = 0 AND uparrowclick = 0 THEN changewyclick = 1
                IF xmouse = tfx - 1 AND ymouse = tfy + tfh + 1 AND codeclick = 0 AND changescreenclick = 0 AND fieldlrclick = 0 AND leftarrowclick = 0 THEN changexhclick = 1
                IF xmouse = tfx + tfw AND ymouse = tfy + tfh + 1 AND codeclick = 0 AND changescreenclick = 0 AND fieldudclick = 0 AND fieldlrclick = 0 AND downarrowclick = 0 AND rightarrowclick = 0 THEN changewhclick = 1
                IF xmouse > (tfx - 1) AND xmouse < tfx + tfw AND ymouse > (tfy - 1) AND ymouse < tfy + tfh AND click = 0 AND menuclick = 0 AND browsemenu = 0 AND changescreenclick = 0 THEN codeclick = 1
                IF ymouse = 1 AND click = 0 AND changescreenclick = 0 THEN menuclick = 1
                IF xmouse = ((tfx + tfw)) AND ymouse = tfy AND changewyclick = 0 AND changescreenclick = 0 THEN uparrowclick = 1
                IF xmouse = ((tfx + tfw)) AND ymouse = ((tfy + tfh) - 1) AND changewhclick = 0 AND changescreenclick = 0 THEN downarrowclick = 1
                IF (xmouse = ((tfx + tfw)) AND ymouse > tfy AND ymouse < ((tfy + tfh) - 1)) AND fieldlrclick = 0 AND changescreenclick = 0 THEN fieldudclick = 1
                IF ymouse = (tfy + tfh) AND xmouse = tfx AND changexhclick = 0 AND changescreenclick = 0 THEN leftarrowclick = 1
                IF ymouse = (tfy + tfh) AND xmouse = ((tfx + tfw) - 1) AND changewhclick = 0 AND changescreenclick = 0 THEN rightarrowclick = 1
                IF (ymouse = (tfy + tfh) AND xmouse > tfx AND xmouse < ((tfx + tfw) - 1)) AND fieldudclick = 0 AND changescreenclick = 0 THEN fieldlrclick = 1
                IF xmouse = _WIDTH - 1 AND ymouse = _HEIGHT - 1 THEN changescreenclick = 1
                IF ymouse = screenh - 5 AND tfy + tfh + statush < screenh - 5 AND xmouse > 1 AND xmouse < 10 THEN bgcsetting = xmouse - 2
                IF ymouse = screenh - 6 AND tfy + tfh + statush < screenh - 6 AND xmouse > 1 AND xmouse < 18 THEN fgcsetting = xmouse - 2
            END IF
        END IF




        IF changexyclick = 1 THEN
            startx = 0: endx = 0: starty = 0: endy = 0: selinfo$ = ""
            tfx = xmouse + 1: tfy = ymouse + 1
            IF tfx + tfw > _WIDTH THEN tfw = _WIDTH - tfx
            IF tfy + tfh > _HEIGHT - statush THEN tfh = (_HEIGHT - statush) - tfy
            IF tfx < 2 THEN tfx = 2
            IF tfy < 3 THEN tfy = 3
            IF tfy > (_HEIGHT - statush) - 3 THEN tfy = (_HEIGHT - statush) - 3
            IF tfx > _WIDTH - 3 THEN tfx = _WIDTH - 3
            IF tfh < 3 THEN tfh = 3
            IF tfw < 3 THEN tfw = 3

        END IF
        IF changewyclick = 1 THEN
            startx = 0: endx = 0: starty = 0: endy = 0: selinfo$ = ""
            IF xmouse > tfx + 2 THEN tfw = (xmouse - tfx)
            tfy = ymouse + 1
            IF tfx < 2 THEN tfx = 2
            IF tfy < 3 THEN tfy = 3
            IF tfy > (_HEIGHT - statush) - 3 THEN tfy = (_HEIGHT - statush) - 3
            IF tfx > _WIDTH - 3 THEN tfx = _WIDTH - 3

            IF tfx + tfw > _WIDTH THEN tfw = _WIDTH - tfx
            IF tfy + tfh > _HEIGHT - statush THEN tfh = (_HEIGHT - statush) - tfy
            IF tfh < 3 THEN tfh = 3
            IF tfw < 3 THEN tfw = 3

        END IF
        IF changexhclick = 1 THEN
            startx = 0: endx = 0: starty = 0: endy = 0: selinfo$ = ""
            tfx = xmouse + 1
            IF ymouse > tfy + 2 THEN tfh = (ymouse - tfy) - 1
            IF tfx < 2 THEN tfx = 2
            IF tfx > _WIDTH - 3 THEN tfx = _WIDTH - 3
            IF tfy < 3 THEN tfy = 3
            IF tfy > (_HEIGHT - statush) - 3 THEN tfy = (_HEIGHT - statush) - 3
            IF tfy + tfh > _HEIGHT - statush THEN tfh = (_HEIGHT - statush) - tfy
            IF tfx + tfw > _WIDTH THEN tfw = _WIDTH - tfx
            IF tfh < 3 THEN tfh = 3
            IF tfw < 3 THEN tfw = 3

        END IF
        IF changewhclick = 1 THEN
            startx = 0: endx = 0: starty = 0: endy = 0: selinfo$ = ""
            IF xmouse > tfx + 2 AND ymouse > tfy + 3 THEN tfw = (xmouse - tfx): tfh = (ymouse - tfy) - 1
            IF tfy + tfh > _HEIGHT - statush THEN tfh = (_HEIGHT - statush) - tfy
            IF tfx + tfw > _WIDTH THEN tfw = _WIDTH - tfx
            IF tfx < 2 THEN tfx = 2
            IF tfx > _WIDTH - 3 THEN tfx = _WIDTH - 3
            IF tfy < 3 THEN tfy = 3
            IF tfy > (_HEIGHT - statush) - 3 THEN tfy = (_HEIGHT - statush) - 3
            IF tfh < 3 THEN tfh = 3
            IF tfw < 3 THEN tfw = 3
        END IF


        IF scankey(56) = 0 THEN waitrelease = 0
        IF alt AND (menuclick = 0 AND browsemenu = 0 AND sel = 0) THEN
            DO
                IF scankey(5) THEN GOTO dontmenuthis
                IF scankey(3) THEN GOTO dontmenuthis
                IF scankey(4) THEN GOTO dontmenuthis
                IF scankey(7) THEN GOTO dontmenuthis
                IF scankey(8) THEN GOTO dontmenuthis
                IF scankey(9) THEN GOTO dontmenuthis
                IF scankey(10) THEN GOTO dontmenuthis
                IF scankey(11) THEN GOTO dontmenuthis
                IF scankey(12) THEN GOTO dontmenuthis
                IF scankey(0) THEN overrideinput = 1: GOTO dontmenuthis
                IF waitrelease = 1 THEN GOTO dontmenuthis
            LOOP WHILE scankey(56)
            alt = 0: menuclick = 1: browsemenu = 2: sel = 2: thekeysel = 1
        END IF
        IF alt AND (menuclick = 1 OR browsemenu > 0 OR sel <> 0) THEN DO: LOOP WHILE scankey(56): alt = 0: menuclick = 0: browsemenu = 0: sel = 0: thekeysel = 0
        click = 1
        IF SHIFT THEN
            IF codeclick = 1 AND followmouse = 0 AND dontfollowmouse = 0 THEN
                flyingmouse = 1
                IF starty = 0 THEN starty = curpos + yrel - 1
                IF starty > 0 THEN endy = curpos + yrel - 1
                IF startx = 0 AND starty = endy THEN startx = (curx) + (xrel - 1)
                IF startx > 0 AND starty = endy THEN endx = (curx) + (xrel - 1)
            END IF
        ELSE
            IF codeclick = 1 THEN startx = 0: endx = 0: starty = 0: endy = 0: selinfo$ = ""
        END IF
        IF codeclick = 1 AND menuclick = 0 AND browsemenu = 0 AND followmouse = 0 AND dontfollowmouse = 0 THEN
            flyingmouse = 1
            IF xmouse > (tfx - 1) AND xmouse < (tfx + tfw) THEN curx = xmouse
            IF ymouse > (tfy - 1) AND ymouse < (tfy + tfh) THEN curpos = ymouse: changedline = curpos + yrel - 1
            IF xmouse <= (tfx - 1) AND xrel > 1 THEN xrel = xrel - 1: curx = tfx
            IF xmouse <= (tfx - 1) AND xrel = 1 THEN curx = tfx
            IF xmouse >= (tfx + tfw) THEN xrel = xrel + 1: curx = (tfx + tfw) - 1
            IF ymouse <= (tfy - 1) AND yrel > 1 THEN yrel = yrel - 1: curpos = tfy: changedline = curpos + yrel - 1
            IF ymouse <= (tfy - 1) AND yrel = 1 THEN curpos = tfy: changedline = curpos + yrel - 1
            IF ymouse >= (tfy + tfh) AND yrel < highest - 2 THEN yrel = yrel + 1: curpos = (tfy + tfh) - 1: changedline = curpos + yrel - 1
            IF ymouse >= (tfy + tfh) AND yrel = highest - 2 THEN curpos = (tfy + tfh) - 1: changedline = curpos + yrel - 1
        END IF
        IF menuclick = 0 AND browsemenu = 0 THEN
            IF uparrowclick = 1 AND followmouse = 0 AND dontfollowmouse = 0 AND flyingmouse = 0 THEN curpos = curpos - 1
            IF downarrowclick = 1 AND followmouse = 0 AND dontfollowmouse = 0 AND flyingmouse = 0 THEN curpos = curpos + 1
            IF leftarrowclick = 1 AND followmouse = 0 AND dontfollowmouse = 0 AND flyingmouse = 0 THEN curx = curx - 1
            IF rightarrowclick = 1 AND followmouse = 0 AND dontfollowmouse = 0 AND flyingmouse = 0 THEN curx = curx + 1
        END IF
        IF menuclick = 1 AND followmouse = 0 AND dontfollowmouse = 0 AND flyingmouse = 0 THEN
            IF xmouse > 2 AND xmouse < 9 AND ymouse = 1 THEN sel = 2
            IF xmouse >= 9 AND xmouse < 15 AND ymouse = 1 THEN sel = 3
            IF xmouse >= 15 AND xmouse < 21 AND ymouse = 1 THEN sel = 4
            IF xmouse >= 21 AND xmouse < 29 AND ymouse = 1 THEN sel = 5
            IF xmouse >= 29 AND xmouse < 34 AND ymouse = 1 THEN sel = 6
            IF xmouse >= 34 AND xmouse < 43 AND ymouse = 1 THEN sel = 8
            IF xmouse >= _WIDTH - 6 AND xmouse < _WIDTH AND ymouse = 1 THEN sel = 7

        END IF
        IF fieldudclick = 1 AND flyingmouse = 0 AND followmouse = 0 THEN
            posizion = tfy + 1 + INT((curpos - tfy + yrel - 1) * ((tfh - 2) / (highest + 2)))
            IF ymouse > posizion AND followmouse = 0 THEN dontfollowmouse = 1: curpos = tfy + tfh - 1: IF yrel < highest + 5 THEN yrel = yrel + 2 ELSE yrel = highest + 5
            IF ymouse < posizion AND followmouse = 0 THEN dontfollowmouse = 1: curpos = tfy: IF yrel > 2 THEN yrel = yrel - 2 ELSE yrel = 1
            IF ymouse = posizion AND dontfollowmouse = 0 THEN followmouse = 1: followmode = 0
        END IF
        IF fieldlrclick = 1 AND flyingmouse = 0 AND followmouse = 0 THEN
            posizion = tfx + 1 + INT((curx - tfx + xrel - 1) * ((tfw - 2) / (1 + maxlen + 2)))
            IF xmouse > posizion AND followmouse = 0 THEN dontfollowmouse = 1: IF curx - tfx + xrel - 1 < maxlen + 5 THEN curx = curx + 1 ELSE xrel = 1 + (maxlen + 5 - curx) + 2
            IF xmouse < posizion AND followmouse = 0 THEN dontfollowmouse = 1: IF curx - tfx + xrel - 1 > 2 THEN curx = curx - 1 ELSE curx = tfx - 1: xrel = 1
            IF xmouse = posizion AND dontfollowmouse = 0 THEN followmouse = 1: followmode = 1
        END IF

        IF followmouse = 1 AND flyingmouse = 0 THEN
            IF followmode = 0 THEN
                posizion = tfy + 1 + INT((curpos - tfy + yrel - 1) * ((tfh - 2) / (highest + 2)))
                IF ymouse < CINT(posizion) THEN curpos = tfy
                IF ymouse > CINT(posizion) THEN curpos = tfy + tfh - 1
                IF ymouse <> CINT(posizion) THEN
                    yrel = INT((ymouse - tfy) * ((highest + 2) / (tfh - 2)))
                    IF yrel > highest + 2 THEN yrel = highest + 5
                    IF yrel < 1 THEN yrel = 1
                END IF
            END IF
            IF followmode = 1 THEN
                posizion = tfx + 1 + INT((curx - tfx + xrel - 1) * ((tfw - 2) / (1 + maxlen + 2)))
                IF xmouse < CINT(posizion) THEN curx = tfx '3
                IF xmouse > CINT(posizion) THEN curx = tfx + tfw - 1 '19
                IF xmouse <> CINT(posizion) THEN
                    xrel = INT((xmouse - tfx) * ((1 + maxlen + 2) / (tfw - 2)))
                    IF xrel > maxlen + 2 THEN xrel = maxlen + 5
                    IF xrel < 1 THEN xrel = 1
                END IF
            END IF
        END IF

    ELSE
        click = 0
        IF menuclick = 1 AND ymouse = 1 THEN browsemenu = sel
        flyingmouse = 0
        followmode = 0
        followmouse = 0
        dontfollowmouse = 0
        menuclick = 0
        codeclick = 0
        uparrowclick = 0
        downarrowclick = 0
        leftarrowclick = 0
        rightarrowclick = 0
        fieldudclick = 0
        fieldlrclick = 0
        fieldudarrowclick = 0
        fieldrlarrowclick = 0
        changexyclick = 0
        changewyclick = 0
        changexhclick = 0
        changewhclick = 0
        '        changescreenclick = 0
    END IF

    IF browsemenu = 2 THEN
        doitem = createmenu(filemenu(), 6, 3, sel2, xmouse, ymouse, bmouse, INKEY$)
        IF doitem = 1 THEN
            'new
            browsemenu = 0: menuclick = 0: sel = 0
            IF edited = 0 THEN
                filename$ = currentpath$ + "untitled.bas"
                FOR delitem = 0 TO highest
                    codetext(delitem) = ""
                NEXT
                curpos = tfy: curx = tfx: highest = 1: xrel = 1: yrel = 1: maxlen = 0: startx = 0: starty = 0: endx = 0: endy = 0
            ELSE
                retcode = msgbox("Are you sure?", "Code has been changed since the latest save, are you sure you want to start a new file?", 1, 22, 6)
                IF retcode = 1 THEN
                    filename$ = currentpath$ + "untitled.bas"
                    FOR delitem = 0 TO highest
                        codetext(delitem) = ""
                    NEXT
                    curpos = tfy: curx = tfx: highest = 1: xrel = 1: yrel = 1: maxlen = 0: edited = 0: startx = 0: starty = 0: endx = 0: endy = 0
                END IF

            END IF
        END IF
        IF doitem = 2 THEN
            'open
            browsemenu = 0: menuclick = 0: sel = 0
            opfilename$ = openfile$("Open file", "", "")
            IF opfilename$ <> "" THEN
                IF edited = 0 THEN
                    filename$ = opfilename$

                    FOR delitem = 0 TO highest
                        codetext(delitem) = ""
                    NEXT
                    curpos = tfy: curx = tfx: highest = 1: xrel = 1: yrel = 1: maxlen = 0: edited = 0: startx = 0: starty = 0: endx = 0: endy = 0

                    filength = file2array(filename$, codetext())
                    IF filength <> -1 THEN highest = filength

                    IF formatset = 1 THEN runformat = 1
                    currentpath$ = extractpath$(opfilename$)

                ELSE
                    retcode = msgbox("Are you sure?", "Code has been changed since the latest save, are you sure you want to open a new file?", 1, 22, 6)
                    IF retcode = 1 THEN
                        filename$ = opfilename$

                        FOR delitem = 0 TO highest
                            codetext(delitem) = ""
                        NEXT
                        curpos = tfy: curx = tfx: highest = 1: xrel = 1: yrel = 1: maxlen = 0: edited = 0: startx = 0: starty = 0: endx = 0: endy = 0

                        filength = file2array(filename$, codetext())
                        IF filength <> -1 THEN highest = filength

                        IF formatset = 1 THEN runformat = 1
                        currentpath$ = extractpath$(opfilename$)
                    END IF
                END IF
            END IF
        END IF
        IF doitem = 3 THEN
            'save
            browsemenu = 0: menuclick = 0: sel = 0
            hithit = 0
            IF LEN(filename$) THEN
                FOR posfil = LEN(filename$) TO 1 STEP -1
                    IF MID$(filename$, posfil, 1) = "\" THEN hithit = 1: EXIT FOR
                NEXT
            END IF

            IF hithit = 1 THEN
                posfil = posfil + 1
                IF MID$(filename$, posfil) = "untitled.bas" THEN doitem = 4
                IF MID$(filename$, posfil) <> "untitled.bas" THEN

                    OPEN filename$ FOR OUTPUT AS #1
                    FOR lastline = highest TO 1 STEP -1
                        IF codetext(lastline) <> "" THEN EXIT FOR
                    NEXT

                    FOR currentsaveline = 0 TO lastline
                        PRINT #1, codetext(currentsaveline)

                    NEXT

                    CLOSE #1
                    edited = 0
                END IF
            END IF

        END IF

        IF doitem = 4 THEN
            'save as...
            browsemenu = 0: menuclick = 0: sel = 0
            thefilename$ = filename$
            savefilename$ = savefile$("Save file", thefilename$)
            IF savefilename$ <> "" THEN
                IF filexist(filename$) = 0 THEN
                    filename$ = savefilename$
                    OPEN filename$ FOR OUTPUT AS #1
                    FOR lastline = highest TO 1 STEP -1
                        IF codetext(lastline) <> "" THEN EXIT FOR
                    NEXT

                    FOR currentsaveline = 0 TO lastline
                        PRINT #1, codetext(currentsaveline)

                    NEXT

                    CLOSE #1
                    edited = 0
                    currentpath$ = extractpath$(filename$)
                ELSE
                    retcode = msgbox("Are you sure?", "A file with that name already exists         Overwrite?                    ", 1, 22, 6)
                    IF retcode = 1 THEN
                        filename$ = savefilename$
                        OPEN filename$ FOR OUTPUT AS #1
                        FOR lastline = highest TO 1 STEP -1
                            IF codetext(lastline) <> "" THEN EXIT FOR
                        NEXT

                        FOR currentsaveline = 0 TO lastline
                            PRINT #1, codetext(currentsaveline)

                        NEXT

                        CLOSE #1
                        edited = 0
                        currentpath$ = extractpath$(filename$)

                    END IF

                END IF

            END IF
        END IF

        IF doitem = 6 THEN
            'exit
            browsemenu = 0: menuclick = 0: sel = 0
            IF edited = 0 THEN
                SYSTEM
            ELSE
                retcode = msgbox("Are you sure?", "Code has been changed since the latest save, are you sure you want to quit?", 1, 22, 6)
                IF retcode = 1 THEN
                    SYSTEM
                END IF
            END IF
        END IF
    END IF
    IF browsemenu = 3 THEN
        doitem = createmenu(editmenu(), 5, 9, sel2, xmouse, ymouse, bmouse, INKEY$)
        IF doitem = 1 THEN
            'cut
            browsemenu = 0: menuclick = 0: sel = 0
            edited = 1
            IF selinfo$ <> "" THEN _CLIPBOARD$ = selinfo$
            IF starty > 0 AND starty = endy AND startx <= endx THEN codetext(curpos - tfy + yrel - 1) = MID$(codetext(curpos - tfy + yrel - 1), 1, (startx - 1) - 1) + MID$(codetext(curpos - tfy + yrel - 1), (endx - 1) + 1, LEN(codetext(curpos - tfy + yrel - 1))): curx = curx - (endx - startx + 1)
            IF starty > 0 AND starty = endy AND startx > endx THEN codetext(curpos - tfy + yrel - 1) = MID$(codetext(curpos - tfy + yrel - 1), 1, (endx - 1) - 1) + MID$(codetext(curpos - tfy + yrel - 1), (startx - 1), LEN(codetext(curpos - tfy + yrel - 1)))
            IF starty < endy THEN
                curx = tfx: xrel = 1
                mer = 0
                FOR whala = (starty - tfy) TO (starty - tfy) + (endy - starty)
                    FOR whasa = (starty - tfy) TO highest
                        codetext(whasa) = codetext(whasa + 1)

                    NEXT
                    IF whala <= highest THEN mer = mer + 1
                NEXT
                highest = highest - mer
                IF highest < 0 THEN highest = 0
                curpos = curpos - (endy - starty)
                IF curpos < tfy THEN yrel = yrel + (curpos - tfy): curpos = tfy
            END IF
            IF starty > endy THEN
                curx = tfx: xrel = 1
                mer = 0
                FOR whala = (endy - tfy) TO (endy - tfy) + (starty - endy)
                    FOR whasa = (endy - tfy) TO highest
                        codetext(whasa) = codetext(whasa + 1)

                    NEXT
                    IF whala <= highest THEN mer = mer + 1
                NEXT
                highest = highest - mer
                IF highest < 0 THEN highest = 0
            END IF

            selinfo$ = "": startx = 0: endx = 0: starty = 0: endy = 0

        END IF
        IF doitem = 2 THEN browsemenu = 0: menuclick = 0: sel = 0: IF selinfo$ <> "" THEN _CLIPBOARD$ = selinfo$
        IF doitem = 3 THEN browsemenu = 0: menuclick = 0: sel = 0: pasteit = 1: action = 1
        IF doitem = 5 THEN
            browsemenu = 0: menuclick = 0: sel = 0
            OPEN editorpath$ + "undo.txt" FOR OUTPUT AS #1
            FOR undoinfo = 1 TO 50
                IF undo(0, undoinfo) <> "" THEN
                    PRINT #1, "' " + undo(0, undoinfo)
                    PRINT #1, "'-----------------"
                    FOR undocode = 1 TO 11
                        IF undo(undocode, undoinfo) = "'---end of code---" THEN EXIT FOR
                        IF undo(undocode, undoinfo) <> "" THEN PRINT #1, undo(undocode, undoinfo)
                    NEXT
                    PRINT #1, "'---end of code---"
                    PRINT #1, ""
                END IF
            NEXT
            CLOSE #1
        END IF

    END IF

    IF browsemenu = 4 THEN
        doitem = createmenu(viewmenu(), 1, 15, sel2, xmouse, ymouse, bmouse, INKEY$)

        IF doitem = 1 THEN
            browsemenu = 0: menuclick = 0: sel = 0
            retval = viewsubs
            IF retval <> 0 THEN
                yrel = retval + 1
                xrel = 0
                curpos = tfy
                curx = tfx
                IF retval = -1 THEN yrel = 0
            END IF
        END IF

    END IF

    IF browsemenu = 5 THEN
        doitem = createmenu(searchmenu(), 3, 21, sel2, xmouse, ymouse, bmouse, INKEY$)
        IF doitem = 1 THEN
            browsemenu = 0: menuclick = 0: sel = 0
            dummy$ = searchname$(casesensitive, curallmod)
            IF dummy$ <> "" THEN
                find$ = dummy$ 'guess it wasn't a dummy after all :)
                searchx = 1 + curx - tfx + xrel - 1: searchy = curpos - tfy + yrel - 1
                IF curallmod = 1 THEN
                    startmody = 0
                    endmody = highest + 5
                END IF
                IF curallmod = 0 THEN
                    checkingmody = searchy
                    DO
                        IF checkingmody <= 0 THEN checkingmody = 0: EXIT DO
                        IF firstcheckcurrent = 0 THEN firstcheckcurrent = 1: IF LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 4))) = "sub " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 9))) = "function " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 8))) = "end sub " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 13))) = "end function " THEN EXIT DO
                        checkingmody = checkingmody - 1
                        IF LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 4))) = "sub " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 9))) = "function " THEN EXIT DO
                        IF LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 8))) = "end sub " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 13))) = "end function " THEN checkingmody = checkingmody + 1: EXIT DO
                    LOOP UNTIL checkingmody = 0
                    startmody = checkingmody
                    checkingendy = searchy
                    DO
                        checkingendy = checkingendy + 1
                        IF checkingendy >= highest + 5 THEN checkingendy = highest + 5: EXIT DO
                        IF LCASE$(LTRIM$(MID$(codetext(checkingendy), 1, 4))) = "sub " OR LCASE$(LTRIM$(MID$(codetext(checkingendy), 1, 9))) = "function " THEN checkingendy = checkingendy - 1: EXIT DO
                        IF LCASE$(LTRIM$(MID$(codetext(checkingendy), 1, 8))) = "end sub " OR LCASE$(LTRIM$(MID$(codetext(checkingendy), 1, 13))) = "end function " THEN checkingendy = checkingendy - 1: EXIT DO
                    LOOP UNTIL checkingendy = highest + 5
                    endmody = checkingendy
                END IF
                currentsx = searchx + 1
                FOR currentsy = searchy TO endmody
                    IF casesensitive = 1 THEN posin = INSTR(currentsx, codetext(currentsy), find$)
                    IF casesensitive = 0 THEN posin = INSTR(currentsx, LCASE$(codetext(currentsy)), LCASE$(find$))
                    IF posin = 0 THEN currentsx = 1
                    IF posin <> 0 THEN foundsearchstring = 1: GOTO foundsearch
                NEXT
                FOR currentsy = startmody TO searchy
                    IF casesensitive = 1 THEN posin = INSTR(currentsx, codetext(currentsy), find$)
                    IF casesensitive = 0 THEN posin = INSTR(currentsx, LCASE$(codetext(currentsy)), LCASE$(find$))
                    IF posin = 0 THEN currentsx = 1
                    IF posin <> 0 THEN foundsearchstring = 1: GOTO foundsearch
                NEXT

                foundsearch:
                IF foundsearchstring = 1 THEN
                    yrel = 1 + (ABS(currentsy - 7 > 0) * (currentsy - 7))
                    IF yrel = 1 THEN curpos = currentsy + tfy
                    IF yrel > 1 THEN curpos = 10
                    xrel = 1 + (ABS(posin - 38 > 0) * (posin - 38))
                    IF xrel = 1 THEN curx = posin + (tfx - 1)
                    IF xrel > 1 THEN curx = 39
                    selinfo$ = find$: startx = curx + LEN(find$) + (xrel - 1): endx = curx + (xrel - 1): starty = curpos + yrel - 1: endy = curpos + yrel - 1
                END IF
                IF foundsearchstring = 0 THEN
                    rete = msgokonly("Search Complete", "Didn't find search string", 10, 10, 28, 5)
                END IF
                foundsearchstring = 0
            END IF

        END IF
        IF doitem = 2 THEN
            ' search again
            browsemenu = 0: menuclick = 0: sel = 0
            IF find$ = "" THEN find$ = searchname$(0, 0)
            IF find$ <> "" THEN
                searchx = 1 + curx - tfx + xrel - 1: searchy = curpos - tfy + yrel - 1
                IF curallmod = 1 THEN
                    startmody = 0
                    endmody = highest + 5
                END IF
                IF curallmod = 0 THEN
                    checkingmody = searchy
                    DO
                        IF checkingmody <= 0 THEN checkingmody = 0: EXIT DO
                        IF firstcheckcurrent = 0 THEN firstcheckcurrent = 1: IF LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 4))) = "sub " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 9))) = "function " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 8))) = "end sub " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 13))) = "end function " THEN EXIT DO
                        checkingmody = checkingmody - 1
                        IF LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 4))) = "sub " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 9))) = "function " THEN EXIT DO
                        IF LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 8))) = "end sub " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 13))) = "end function " THEN checkingmody = checkingmody + 1: EXIT DO
                    LOOP UNTIL checkingmody = 0
                    startmody = checkingmody
                    checkingendy = searchy
                    DO
                        checkingendy = checkingendy + 1
                        IF checkingendy >= highest + 5 THEN checkingendy = highest + 5: EXIT DO
                        IF LCASE$(LTRIM$(MID$(codetext(checkingendy), 1, 4))) = "sub " OR LCASE$(LTRIM$(MID$(codetext(checkingendy), 1, 9))) = "function " THEN checkingendy = checkingendy - 1: EXIT DO
                        IF LCASE$(LTRIM$(MID$(codetext(checkingendy), 1, 8))) = "end sub " OR LCASE$(LTRIM$(MID$(codetext(checkingendy), 1, 13))) = "end function " THEN checkingendy = checkingendy - 1: EXIT DO
                    LOOP UNTIL checkingendy = highest + 5
                    endmody = checkingendy
                END IF
                currentsx = searchx + 1
                FOR currentsy = searchy TO endmody
                    IF casesensitive = 1 THEN posin = INSTR(currentsx, codetext(currentsy), find$)
                    IF casesensitive = 0 THEN posin = INSTR(currentsx, LCASE$(codetext(currentsy)), LCASE$(find$))
                    IF posin = 0 THEN currentsx = 1
                    IF posin <> 0 THEN foundsearchstring = 1: GOTO foundsearchagain2
                NEXT
                FOR currentsy = startmody TO searchy
                    IF casesensitive = 1 THEN posin = INSTR(currentsx, codetext(currentsy), find$)
                    IF casesensitive = 0 THEN posin = INSTR(currentsx, LCASE$(codetext(currentsy)), LCASE$(find$))
                    IF posin = 0 THEN currentsx = 1
                    IF posin <> 0 THEN foundsearchstring = 1: GOTO foundsearchagain2
                NEXT

                foundsearchagain2:
                IF foundsearchstring = 1 THEN
                    yrel = 1 + (ABS(currentsy - 7 > 0) * (currentsy - 7))
                    IF yrel = 1 THEN curpos = currentsy + tfy
                    IF yrel > 1 THEN curpos = 10
                    xrel = 1 + (ABS(posin - 38 > 0) * (posin - 38))
                    IF xrel = 1 THEN curx = posin + (tfx - 1)
                    IF xrel > 1 THEN curx = 39
                    selinfo$ = find$: startx = curx + LEN(find$) + (xrel - 1): endx = curx + (xrel - 1): starty = curpos + yrel - 1: endy = curpos + yrel - 1
                END IF
                IF foundsearchstring = 0 THEN
                    rete = msgokonly("Search Complete", "Didn't find search string", 10, 10, 28, 5)
                END IF
                foundsearchstring = 0
            END IF

        END IF
        IF doitem = 3 THEN
            'change..
            browsemenu = 0: menuclick = 0: sel = 0
            nametochange$ = changename$(casesensitive, curallmod, verify, changeto$)
            IF nametochange$ <> "" AND verify = 1 THEN verifyandchange = 1
            IF nametochange$ <> "" AND verify = 0 THEN
                'code here, no verification
                find$ = nametochange$
                IF find$ = changeto$ THEN foundsearchstring = 0: GOTO foundsearchagain3
                herewegoagain:
                foundsearchstring = 0
                searchx = 1 + curx - tfx + xrel - 1: searchy = curpos - tfy + yrel - 1
                IF curallmod = 1 THEN
                    startmody = 0
                    endmody = highest + 5
                END IF
                IF curallmod = 0 THEN
                    checkingmody = searchy
                    DO
                        IF checkingmody <= 0 THEN checkingmody = 0: EXIT DO
                        IF firstcheckcurrent = 0 THEN firstcheckcurrent = 1: IF LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 4))) = "sub " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 9))) = "function " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 8))) = "end sub " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 13))) = "end function " THEN EXIT DO
                        checkingmody = checkingmody - 1
                        IF LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 4))) = "sub " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 9))) = "function " THEN EXIT DO
                        IF LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 8))) = "end sub " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 13))) = "end function " THEN checkingmody = checkingmody + 1: EXIT DO
                    LOOP UNTIL checkingmody = 0
                    startmody = checkingmody
                    checkingendy = searchy
                    DO
                        checkingendy = checkingendy + 1
                        IF checkingendy >= highest + 5 THEN checkingendy = highest + 5: EXIT DO
                        IF LCASE$(LTRIM$(MID$(codetext(checkingendy), 1, 4))) = "sub " OR LCASE$(LTRIM$(MID$(codetext(checkingendy), 1, 9))) = "function " THEN checkingendy = checkingendy - 1: EXIT DO
                        IF LCASE$(LTRIM$(MID$(codetext(checkingendy), 1, 8))) = "end sub " OR LCASE$(LTRIM$(MID$(codetext(checkingendy), 1, 13))) = "end function " THEN checkingendy = checkingendy - 1: EXIT DO
                    LOOP UNTIL checkingendy = highest + 5
                    endmody = checkingendy
                END IF
                currentsx = searchx + 1
                FOR currentsy = searchy TO endmody
                    IF casesensitive = 1 THEN posin = INSTR(currentsx, codetext(currentsy), find$)
                    IF casesensitive = 0 THEN posin = INSTR(currentsx, LCASE$(codetext(currentsy)), LCASE$(find$))
                    IF posin = 0 THEN currentsx = 1
                    IF posin <> 0 THEN foundsearchstring = 1: GOTO foundsearchagain3
                NEXT
                FOR currentsy = startmody TO searchy
                    IF casesensitive = 1 THEN posin = INSTR(currentsx, codetext(currentsy), find$)
                    IF casesensitive = 0 THEN posin = INSTR(currentsx, LCASE$(codetext(currentsy)), LCASE$(find$))
                    IF posin = 0 THEN currentsx = 1
                    IF posin <> 0 THEN foundsearchstring = 1: GOTO foundsearchagain3
                NEXT

                foundsearchagain3:
                IF foundsearchstring = 1 THEN
                    yrel = 1 + (ABS(currentsy - 7 > 0) * (currentsy - 7))
                    IF yrel = 1 THEN curpos = currentsy + tfy
                    IF yrel > 1 THEN curpos = 10
                    xrel = 1 + (ABS(posin - 38 > 0) * (posin - 38))
                    IF xrel = 1 THEN curx = posin + (tfx - 1)
                    IF xrel > 1 THEN curx = 39
                    codetext(currentsy) = MID$(codetext(currentsy), 1, posin - 1) + changeto$ + MID$(codetext(currentsy), posin + LEN(find$))
                END IF
                IF foundsearchstring = 0 THEN
                    rete = msgokonly("Search Complete", "Done.", 10, 10, 28, 5)
                    GOTO wearedone
                END IF
                GOTO herewegoagain
                wearedone:
            END IF

        END IF

    END IF

    IF browsemenu = 6 THEN
        doitem = createmenu(runmenu(), 10, 29, sel2, xmouse, ymouse, bmouse, INKEY$)

        IF doitem > 0 AND doitem < 9 THEN
            IF _FULLSCREEN THEN
                _AUTODISPLAY
                _FULLSCREEN _OFF
                _DISPLAY
                rete = msgokonly("Fullscreen must be off.", "Otherwise it will freeze...", 10, 10, 50, 5)
            END IF
        END IF

        IF doitem > 0 AND doitem < 6 THEN
            filexi = 0
            dummy$ = ""
            'check if filename already exists first.
            SHELL _HIDE "dir/b " + CHR$(34) + filename$ + CHR$(34) + " > tempie.tmp"
            OPEN "tempie.tmp" FOR INPUT AS #1
            IF LOF(1) THEN
                INPUT #1, dummy$
            END IF
            CLOSE #1
            KILL "tempie.tmp"
            IF dummy$ <> "" THEN filexi = 1
        END IF


        IF doitem = 1 THEN
            browsemenu = 0: menuclick = 0: sel = 0
            IF filexi = 1 THEN SHELL _HIDE "del " + CHR$(34) + currentpath$ + "tempie.tmp" + CHR$(34)
            IF filexi = 1 THEN SHELL _HIDE "ren " + CHR$(34) + filename$ + CHR$(34) + " tempie.tmp"
            'check if renaming was successfull!
            IF filexist(currentpath$ + "tempie.tmp") OR filexi = 0 THEN

                OPEN filename$ FOR OUTPUT AS #1
                FOR lastline = highest TO 1 STEP -1
                    IF codetext(lastline) <> "" THEN EXIT FOR
                NEXT
                FOR currentsaveline = 0 TO lastline
                    PRINT #1, codetext(currentsaveline)
                NEXT
                CLOSE #1

                SHELL CHR$(34) + qb64path$ + "qb64.exe" + CHR$(34) + " -c " + filename$

                IF filexi = 1 THEN SHELL _HIDE "del " + CHR$(34) + filename$ + CHR$(34)
                FOR iasjij = LEN(filename$) TO 1 STEP -1
                    IF MID$(filename$, iasjij, 1) = "\" THEN EXIT FOR
                NEXT
                IF filexi = 1 THEN SHELL _HIDE "ren " + CHR$(34) + currentpath$ + "tempie.tmp" + CHR$(34) + " " + CHR$(34) + MID$(filename$, iasjij + 1) + CHR$(34)
                SHELL CHR$(34) + qb64path$ + MID$(filename$, iasjij + 1, ((LEN(filename$) - 3) - (iasjij + 1))) + ".exe" + CHR$(34)
            ELSE
                rete = msgokonly("Cannot compile!", "Renaming Unsuccessful!" + currentpath$ + "-" + filepath$, 10, 10, 50, 5)
            END IF


        END IF
        IF doitem = 3 THEN
            browsemenu = 0: menuclick = 0: sel = 0
            IF filexi = 1 THEN SHELL _HIDE "del tempie.tmp"
            IF filexi = 1 THEN SHELL _HIDE "ren " + CHR$(34) + filename$ + CHR$(34) + " tempie.tmp"
            'check if renaming was successfull!
            IF filexist(currentpath$ + "tempie.tmp") OR filexi = 0 THEN
                OPEN filename$ FOR OUTPUT AS #1
                FOR lastline = highest TO 1 STEP -1
                    IF codetext(lastline) <> "" THEN EXIT FOR
                NEXT
                FOR currentsaveline = 0 TO lastline
                    PRINT #1, codetext(currentsaveline)
                NEXT
                CLOSE #1
                SHELL CHR$(34) + qb64path$ + "qb64.exe" + CHR$(34) + " -c " + filename$
                IF filexi = 1 THEN SHELL _HIDE "del " + CHR$(34) + filename$ + CHR$(34)
                FOR iasjij = LEN(filename$) TO 1 STEP -1
                    IF MID$(filename$, iasjij, 1) = "\" THEN EXIT FOR
                NEXT
                IF filexi = 1 THEN SHELL _HIDE "ren " + CHR$(34) + currentpath$ + "tempie.tmp" + CHR$(34) + " " + CHR$(34) + MID$(filename$, iasjij + 1) + CHR$(34)
                SHELL CHR$(34) + qb64path$ + MID$(filename$, iasjij + 1, ((LEN(filename$) - 3) - (iasjij + 1))) + ".exe" + CHR$(34)
            ELSE
                rete = msgokonly("Cannot compile!", "Renaming Unsuccessfull!", 10, 10, 50, 5)
            END IF
        END IF
        IF doitem = 4 THEN
            browsemenu = 0: menuclick = 0: sel = 0
            IF filexi = 1 THEN SHELL _HIDE "del tempie.tmp"
            IF filexi = 1 THEN SHELL _HIDE "ren " + CHR$(34) + filename$ + CHR$(34) + " tempie.tmp"
            'check if renaming was successfull!
            IF filexist(currentpath$ + "tempie.tmp") OR filexi = 0 THEN
                OPEN filename$ FOR OUTPUT AS #1
                FOR lastline = highest TO 1 STEP -1
                    IF codetext(lastline) <> "" THEN EXIT FOR
                NEXT
                FOR currentsaveline = 0 TO lastline
                    PRINT #1, codetext(currentsaveline)
                NEXT
                CLOSE #1
                SHELL CHR$(34) + qb64path$ + "qb64.exe" + CHR$(34) + " -c " + filename$
                IF filexi = 1 THEN SHELL _HIDE "del " + CHR$(34) + filename$ + CHR$(34)
                FOR iasjij = LEN(filename$) TO 1 STEP -1
                    IF MID$(filename$, iasjij, 1) = "\" THEN EXIT FOR
                NEXT
                IF filexi = 1 THEN SHELL _HIDE "ren " + CHR$(34) + currentpath$ + "tempie.tmp" + CHR$(34) + " " + CHR$(34) + MID$(filename$, iasjij + 1) + CHR$(34)
                SHELL _DONTWAIT CHR$(34) + qb64path$ + MID$(filename$, iasjij + 1, ((LEN(filename$) - 3) - (iasjij + 1))) + ".exe" + CHR$(34)
            ELSE
                rete = msgokonly("Cannot compile!", "Renaming Unsuccessfull!", 10, 10, 50, 5)
            END IF
        END IF
        IF doitem = 5 THEN
            browsemenu = 0: menuclick = 0: sel = 0
            IF filexi = 1 THEN SHELL _HIDE "del tempie.tmp"
            IF filexi = 1 THEN SHELL _HIDE "ren " + CHR$(34) + filename$ + CHR$(34) + " tempie.tmp"
            'check if renaming was successfull!
            IF filexist(currentpath$ + "tempie.tmp") OR filexi = 0 THEN
                OPEN filename$ FOR OUTPUT AS #1
                FOR lastline = highest TO 1 STEP -1
                    IF codetext(lastline) <> "" THEN EXIT FOR
                NEXT
                FOR currentsaveline = 0 TO lastline
                    PRINT #1, codetext(currentsaveline)
                NEXT
                CLOSE #1
                SHELL CHR$(34) + qb64path$ + "qb64.exe -c" + CHR$(34) + " " + filename$
                IF filexi = 1 THEN SHELL _HIDE "del " + CHR$(34) + filename$ + CHR$(34)
                FOR iasjij = LEN(filename$) TO 1 STEP -1
                    IF MID$(filename$, iasjij, 1) = "\" THEN EXIT FOR
                NEXT
                IF filexi = 1 THEN SHELL _HIDE "ren " + CHR$(34) + currentpath$ + "tempie.tmp" + CHR$(34) + " " + CHR$(34) + MID$(filename$, iasjij + 1) + CHR$(34)
            ELSE
                rete = msgokonly("Cannot compile!", "Renaming Unsuccessfull!", 10, 10, 50, 5)
            END IF
        END IF
        IF doitem = 7 THEN
            browsemenu = 0: menuclick = 0: sel = 0
            SHELL _DONTWAIT CHR$(34) + qb64path$ + "qb64.exe" + CHR$(34)
        END IF
        IF doitem = 8 THEN
            browsemenu = 0: menuclick = 0: sel = 0
            SHELL _DONTWAIT CHR$(34) + qb64path$ + "qb64.exe" + CHR$(34) + " " + filename$
        END IF
        IF doitem = 10 THEN
            browsemenu = 0: menuclick = 0: sel = 0
            errorcheck = 1: founderror$ = "": cherline = 0
        END IF

    END IF

    IF browsemenu = 7 THEN
        doitem = createmenu(helpmenu(), 2, screenw - 6, sel2, xmouse, ymouse, bmouse, INKEY$)
        IF doitem = 1 THEN
            browsemenu = 0: menuclick = 0: sel = 0
            help = 1: startx = 0: endx = 0: starty = 0: endy = 0: selinfo$ = "": IF keyhelp = 1 AND helpfound = 1 THEN keyhelp = 0: tfh = gobackh: tfy = gobacky: curpos = curpos - 4: onetimekeyhelp = 0: foundsyntax = 0
        END IF

        IF doitem = 2 THEN
            ' syntax help
            browsemenu = 0: menuclick = 0: sel = 0
            IF help = 1 AND nohelp = 0 THEN
                'keyhelp cancels help
                help = 0
                section$ = "Index"
                IF prevtfy <> 0 THEN curpos = curpos - (20 - prevtfy): tfh = tfh + (20 - prevtfy): tfy = tfy - (20 - prevtfy)
            END IF
            startx = 0: endx = 0: starty = 0: endy = 0: selinfo$ = ""

            IF codetext(curpos - tfy + yrel - 1) <> "" AND LEN(codetext(curpos - tfy + yrel - 1)) >= curx - tfx + xrel - 1 THEN
                'go back to find the beginning of the word
                presentx = (curx - tfx + xrel - 1) + 1 ' (strings start at index 1)
                presenty = curpos - tfy + yrel - 1
                presentchar$ = MID$(codetext(presenty), presentx, 1)
                IF presentchar$ <> "" THEN
                    skipchecking = 0
                    IF ((ASC(presentchar$) < 48 OR (ASC(presentchar$) > 57 AND ASC(presentchar$) < 65)) OR (ASC(presentchar$) > 90 AND ASC(presentchar$) < 97 AND ASC(presentchar$) <> 95) AND ASC(presentchar$) <> 36) OR ASC(presentchar$) > 122 THEN skipchecking = 1
                    IF skipchecking = 0 THEN
                        startsyntax = 0
                        endsyntax = 0
                        DO WHILE presentx > 1
                            presentx = presentx - 1
                            presentchar$ = MID$(codetext(presenty), presentx, 1)
                            IF ((ASC(presentchar$) < 48 OR (ASC(presentchar$) > 57 AND ASC(presentchar$) < 65)) OR (ASC(presentchar$) > 90 AND ASC(presentchar$) < 97 AND ASC(presentchar$) <> 95) AND ASC(presentchar$) <> 36) OR ASC(presentchar$) > 122 THEN startsyntax = presentx + 1: EXIT DO
                        LOOP
                        IF startsyntax <= 0 THEN startsyntax = 1: presentx = 1
                        DO WHILE presentx < LEN(codetext(presenty))
                            presentx = presentx + 1
                            presentchar$ = MID$(codetext(presenty), presentx, 1)
                            IF ((ASC(presentchar$) < 48 OR (ASC(presentchar$) > 57 AND ASC(presentchar$) < 65)) OR (ASC(presentchar$) > 90 AND ASC(presentchar$) < 97 AND ASC(presentchar$) <> 95) AND ASC(presentchar$) <> 36) OR ASC(presentchar$) > 122 THEN endsyntax = presentx - 1: EXIT DO
                        LOOP
                        skipdone = 0
                        IF startsyntax = endsyntax THEN skipdone = 1
                        IF skipdone = 0 THEN
                            IF endsyntax = 0 THEN endsyntax = LEN(codetext(presenty))
                            syntaxcheck$ = MID$(codetext(presenty), startsyntax, (endsyntax - startsyntax) + 1)
                            IF keyhelp = 0 AND tfy < 7 THEN gobackh = tfh: gobacky = tfy: gobackpos = curpos: tfh = tfh - (7 - tfy): tfy = 7: curpos = curpos + 4
                            keyhelp = 1
                            onetimekeyhelp = 0: foundsyntax = 0
                        END IF
                    END IF
                END IF
            END IF
        END IF
    END IF

    IF browsemenu = 8 THEN
        doitem = createmenu(optionsmenu(), 5, 34, sel2, xmouse, ymouse, bmouse, INKEY$)
        IF doitem = 1 THEN
            'set paths...
            browsemenu = 0: menuclick = 0: sel = 0
            thepath$ = setpaths$
            IF thepath$ <> "" THEN qb64path$ = thepath$
        END IF
        IF doitem = 2 THEN
            'set font
            browsemenu = 0: menuclick = 0: sel = 0
            IF fontheight = 0 THEN fontheight = 16 '16 is the default font height
            IF fontheight <> 0 THEN prevfonthi = fontheight
            prevuse = usefont
            fontie$ = setfont$
            IF usefont <> -1 THEN
                IF fontie$ <> "" THEN
                    previousfont$ = thefont$
                    thefont$ = fontie$
                    f& = _LOADFONT(thefont$, fontheight, "monospace")
                    'on error go back to previous font
                    IF f& = -1 THEN
                        ret = msgokonly("Font Error...", "Something went wrong with loading the font...", 10, 10, 45, 4)
                        thefont$ = previousfont$: fontheight = prevfonthi: usefont = prevuse
                    END IF

                    IF f& <> -1 AND usefont = 1 THEN _FONT f&
                END IF
            END IF
            IF usefont = -1 THEN usefont = prevuse: fontheight = prevfonthi
            IF usefont = 0 THEN _FONT 16
            IF usefont = 1 AND thefont$ <> "" THEN f& = _LOADFONT(thefont$, fontheight, "monospace"): _FONT f&

        END IF
        IF doitem = 3 THEN
            browsemenu = 0: menuclick = 0: sel = 0
            chform = formatset
            dummy = setformatting
            IF dummy = -1 THEN formatset = chform
        END IF

        IF doitem = 5 THEN
            'Update editor.cfg
            browsemenu = 0: menuclick = 0: sel = 0
            OPEN editorpath$ + "editor.cfg" FOR OUTPUT AS #1
            PRINT #1, "QB64 Path:"
            PRINT #1, qb64path$
            PRINT #1, "-"
            PRINT #1, "Formatting 1/0:"
            PRINT #1, formatset
            PRINT #1, "-"
            PRINT #1, "Use Font 1/0:"
            PRINT #1, usefont
            PRINT #1, "-"
            PRINT #1, "Font:"
            PRINT #1, thefont$
            PRINT #1, fontheight
            PRINT #1, "-"
            PRINT #1, "Background Color:"
            PRINT #1, bgcsetting
            PRINT #1, "-"
            PRINT #1, "Foreground Color:"
            PRINT #1, fgcsetting
            PRINT #1, "-"
            PRINT #1, "Position:"
            PRINT #1, tfx
            PRINT #1, tfy
            PRINT #1, tfw
            PRINT #1, tfh
            PRINT #1, "-"
            PRINT #1, "Window Size:"
            PRINT #1, screenw
            PRINT #1, screenh
            PRINT #1, "-"
            CLOSE #1
        END IF
    END IF

    IF doitem = -1 THEN menuclick = 0: browsemenu = 0: sel = 0: doitem = 0
    IF doitem = -2 THEN menuclick = 1: browsemenu = sel: doitem = 0
    IF doitem = -3 THEN
        IF browsemenu = 7 THEN browsemenu = 8: thekeysel = 1: sel = 8 ELSE IF browsemenu = 8 THEN browsemenu = 6: thekeysel = 1: sel = 6 ELSE IF browsemenu > 2 AND browsemenu <= 6 THEN browsemenu = browsemenu - 1: thekeysel = 1: sel = sel - 1 ELSE browsemenu = 7: thekeysel = 1: sel = 7
    END IF
    IF doitem = -4 THEN
        IF browsemenu = 6 THEN browsemenu = 8: thekeysel = 1: sel = 8 ELSE IF browsemenu = 8 THEN browsemenu = 7: thekeysel = 1: sel = 7 ELSE IF browsemenu < 6 THEN browsemenu = browsemenu + 1: thekeysel = 1: sel = sel + 1 ELSE browsemenu = 2: thekeyselect = 1: sel = 2
    END IF

    dontmenuthis:
    IF menuclick = 0 AND browsemenu = 0 AND verifyandchange = 0 THEN
        IF overrideinput = 0 THEN keyb$ = INKEY$ ELSE keyb$ = "|": waitrelease = 1: overrideinput = 0

        'keyboard input to textbox

        SELECT CASE keyb$
            CASE CHR$(0) + "H" 'up
                curpos = curpos - 1: changedline = curpos + 1 + yrel - 1
                IF SHIFT THEN
                    IF starty = 0 THEN starty = curpos + 1 + yrel - 1
                    IF starty > 0 THEN endy = curpos + yrel - 1
                ELSE
                    startx = 0: endx = 0: starty = 0: endy = 0: selinfo$ = ""
                END IF

            CASE CHR$(0) + "P" 'down
                curpos = curpos + 1: changedline = curpos - 1 + yrel - 1
                IF SHIFT THEN
                    IF starty = 0 THEN starty = curpos - 1 + yrel - 1
                    IF starty > 0 THEN endy = curpos + yrel - 1
                ELSE
                    startx = 0: endx = 0: starty = 0: endy = 0: selinfo$ = ""
                END IF

            CASE CHR$(0) + "K" 'left
                curx = curx - 1
                IF SHIFT THEN
                    IF startx = 0 THEN startx = (curx + 1) + (xrel - 1): IF starty = 0 THEN starty = curpos + yrel - 1: endy = curpos + yrel - 1
                    IF startx > 1 THEN endx = (curx - 1) + (xrel - 1)

                ELSE
                    startx = 0: endx = 0: starty = 0: endy = 0: selinfo$ = ""
                END IF

            CASE CHR$(0) + "M" 'right
                curx = curx + 1
                IF SHIFT THEN
                    IF startx = 0 THEN startx = (curx - 1) + (xrel - 1): IF starty = 0 THEN starty = curpos + yrel - 1: endy = curpos + yrel - 1
                    IF startx > 0 THEN endx = (curx - 1) + (xrel - 1)
                ELSE
                    startx = 0: endx = 0: starty = 0: endy = 0: selinfo$ = ""
                END IF

            CASE CHR$(9): edited = 1: codetext(curpos - tfy + yrel - 1) = MID$(codetext(curpos - tfy + yrel - 1), 1, (curx - 1 + xrel - 1) - 1) + "    " + MID$(codetext(curpos - tfy + yrel - 1), (curx - 1 + xrel - 1), LEN(codetext(curpos - tfy + yrel - 1))): curx = curx + 4: IF curx > tfx + tfw - 1 THEN xrel = xrel + (curx - (tfx + tfw - 1)): curx = tfx + tfw - 1
            CASE CHR$(27) 'ESC
                startx = 0: endx = 0: starty = 0: endy = 0: selinfo$ = ""
                IF keyhelp = 0 AND help = 0 AND changescreenclick = 0 THEN founderror$ = "": errorcheck = 0
                IF keyhelp = 1 AND help = 0 AND changescreenclick = 0 THEN keyhelp = 0: tfh = gobackh: tfy = gobacky: curpos = curpos - 4: onetimekeyhelp = 0: foundsyntax = 0
                IF help = 1 AND changescreenclick = 0 THEN
                    help = 0
                    section$ = "Index"
                    IF prevtfy <> 0 THEN curpos = curpos - (20 - prevtfy): tfh = tfh + (20 - prevtfy): tfy = tfy - (20 - prevtfy)
                END IF
                changescreenclick = 0

            CASE CHR$(0) + "R": IF mode = 0 THEN mode = 1 ELSE mode = 0 'Ins
            CASE CHR$(0) + "G" 'home
                IF SHIFT AND startx = 0 THEN startx = curx + xrel - 1: starty = curpos + yrel - 1: endy = curpos + yrel - 1
                curx = tfx: xrel = 1
                IF SHIFT THEN endx = curx + xrel - 1
                IF SHIFT = 0 THEN startx = 0: endx = 0: starty = 0: endy = 0: selinfo$ = ""

            CASE CHR$(0) + "O" 'end
                IF SHIFT AND startx = 0 THEN startx = curx + xrel - 1: starty = curpos + yrel - 1: endy = curpos + yrel - 1
                IF LEN(codetext(curpos - tfy + yrel - 1)) > tfw THEN curx = tfx + tfw - 1: xrel = (LEN(codetext(curpos - tfy + yrel - 1)) - tfw) + 1
                IF LEN(codetext(curpos - tfy + yrel - 1)) <= tfw THEN
                    curx = LEN(codetext(curpos - tfy + yrel - 1)) + (tfx - 1) - (xrel - 1)
                    IF curx < 0 THEN xrel = xrel + curx: xrel = xrel - 10: curx = 10
                    IF xrel < 1 THEN xrel = 1: curx = LEN(codetext(curpos - tfy + yrel - 1))
                END IF
                IF SHIFT THEN endx = curx + xrel - 1

            CASE CHR$(0) + "Q" 'pgdown
                changedline = curpos + yrel - 1
                IF SHIFT AND starty = 0 THEN starty = curpos + yrel - 1
                IF yrel + tfh - (tfh - (curpos - tfy)) < highest + 5 THEN
                    yrel = yrel + tfh - (tfh - (curpos - tfy)): curpos = tfy + tfh - 1
                ELSE

                    curpos = tfy + tfh - 1
                END IF

                endy = curpos + yrel - 1
                IF SHIFT = 0 THEN startx = 0: endx = 0: starty = 0: endy = 0: selinfo$ = ""

            CASE CHR$(0) + "I" 'pgup
                changedline = curpos + yrel - 1
                IF SHIFT AND starty = 0 THEN starty = curpos + yrel - 1

                IF yrel >= tfh THEN
                    yrel = yrel - (tfh - (curpos - 2)): curpos = tfy
                ELSE
                    yrel = 1
                    curpos = tfy
                END IF

                endy = curpos + yrel - 1
                IF SHIFT = 0 THEN startx = 0: endx = 0: starty = 0: endy = 0: selinfo$ = ""

            CASE CHR$(0) + "S"
                'del
                edited = 1
                IF starty > 0 AND starty = endy AND startx <= endx THEN codetext(curpos - tfy + yrel - 1) = MID$(codetext(curpos - tfy + yrel - 1), 1, (startx - (tfx - 1)) - 1) + MID$(codetext(curpos - tfy + yrel - 1), (endx - (tfx - 1)) + 1, LEN(codetext(curpos - tfy + yrel - 1))): curx = curx - (endx - startx + 1)
                IF starty > 0 AND starty = endy AND startx > endx THEN codetext(curpos - tfy + yrel - 1) = MID$(codetext(curpos - tfy + yrel - 1), 1, (endx - (tfx - 1)) - 1) + MID$(codetext(curpos - tfy + yrel - 1), (startx - (tfx - 1)), LEN(codetext(curpos - tfy + yrel - 1)))
                IF starty < endy THEN
                    curx = tfx: xrel = 1
                    mer = 0
                    FOR whala = (starty - tfy) TO (starty - tfy) + (endy - starty)
                        FOR whasa = (starty - tfy) TO highest
                            codetext(whasa) = codetext(whasa + 1)

                        NEXT
                        IF whala <= highest THEN mer = mer + 1
                    NEXT
                    highest = highest - mer
                    IF highest < 0 THEN highest = 0
                    curpos = curpos - (endy - starty)
                    IF curpos < tfy THEN yrel = yrel + (curpos - tfy): curpos = tfy
                END IF
                IF starty > endy THEN
                    curx = tfx: xrel = 1
                    mer = 0
                    FOR whala = (endy - tfy) TO (endy - tfy) + (starty - endy)
                        FOR whasa = (endy - tfy) TO highest
                            codetext(whasa) = codetext(whasa + 1)

                        NEXT
                        IF whala <= highest THEN mer = mer + 1
                    NEXT
                    highest = highest - mer
                    IF highest < 0 THEN highest = 0
                END IF

                IF starty = 0 THEN
                    IF curx - (tfx - 1) + xrel - 1 < LEN(codetext(curpos - tfy + yrel - 1)) OR LEN(codetext(curpos - tfy + yrel - 1)) = 1 THEN codetext(curpos - tfy + yrel - 1) = MID$(codetext(curpos - tfy + yrel - 1), 1, (curx - (tfx - 1) + xrel - 1) - 1) + MID$(codetext(curpos - tfy + yrel - 1), (curx - (tfx - 1) + xrel - 1) + 1, LEN(codetext(curpos - tfy + yrel - 1)))
                    IF curx - (tfx - 1) + xrel - 1 = 1 AND LEN(codetext(curpos - tfy + yrel - 1)) = 0 THEN
                        IF highest > curpos - tfy + yrel - 1 THEN
                            FOR g = curpos - tfy + yrel - 1 TO highest
                                codetext(g) = codetext(g + 1)
                            NEXT
                            highest = highest - 1
                        END IF
                    END IF
                END IF
                selinfo$ = "": startx = 0: endx = 0: starty = 0: endy = 0

            CASE CHR$(8)
                edited = 1
                'backspace
                startx = 0: endx = 0: starty = 0: startx = 0: selinfo$ = ""

                IF curx - (tfx - 1) + xrel - 1 >= 1 AND curx - (tfx - 1) + xrel - 1 <= LEN(codetext(curpos - tfy + yrel - 1)) THEN codetext(curpos - tfy + yrel - 1) = MID$(codetext(curpos - tfy + yrel - 1), 1, (curx - (tfx - 1) + xrel - 1) - 2) + MID$(codetext(curpos - tfy + yrel - 1), (curx - (tfx - 1) + xrel - 1), LEN(codetext(curpos - tfy + yrel - 1))): curx = curx - 1 ELSE IF curx - (tfx - 1) + xrel - 1 > LEN(codetext(curpos - tfy + yrel - 1)) THEN curx = curx - 1
                IF curx - (tfx - 1) + xrel - 1 = 0 AND curpos - tfy + yrel - 1 > 0 THEN
                    IF LEN(codetext((curpos - tfy + yrel - 1) - 1)) < 78 THEN curx = LEN(codetext((curpos - tfy + yrel - 1) - 1)) + (tfx - 1)
                    IF LEN(codetext((curpos - tfy + yrel - 1) - 1)) >= 78 THEN curx = (tfx + tfw - 1) - LEN(codetext(curpos - tfy + yrel - 1)): xrel = LEN(codetext((curpos - tfy + yrel - 1) - 1)) - ((tfx + tfw - 3) - LEN(codetext(curpos - tfy + yrel - 1)))
                    array = curpos - tfy + yrel - 1
                    IF MID$(codetext(array - 1), LEN(codetext(array - 1)), 1) = " " AND LEN(codetext(array)) > 0 THEN
                        codetext(array - 1) = MID$(codetext(array - 1), 1, LEN(codetext(array - 1)) - 1)
                    END IF
                    codetext((curpos - tfy + yrel - 1) - 1) = codetext((curpos - tfy + yrel - 1) - 1) + codetext(curpos - tfy + yrel - 1)
                    IF highest >= curpos - tfy + yrel - 1 THEN
                        FOR g = curpos - tfy + yrel - 1 TO highest
                            codetext(g) = codetext(g + 1)
                        NEXT
                        codetext(highest) = ""
                        highest = highest - 1
                        curpos = curpos - 1
                    ELSE
                        curpos = curpos - 1

                    END IF
                END IF


            CASE CHR$(10): IF help = 1 AND links >= linksel AND linksel <> 0 THEN section$ = linktext$(linksel): linksel = 0

            CASE CHR$(13)

                edited = 1
                changedline = curpos + yrel - 1
                IF highest >= (curpos - tfy + yrel - 1) THEN
                    FOR g = highest TO (curpos - tfy + yrel - 1) STEP -1
                        codetext(g + 1) = codetext(g)
                    NEXT
                    codetext((curpos - tfy + yrel - 1) + 1) = MID$(codetext((curpos - tfy + yrel - 1) + 1), (curx - (tfx - 1) + xrel - 1))
                    codetext(curpos - tfy + yrel - 1) = MID$(codetext(curpos - tfy + yrel - 1), 1, (curx - (tfx - 1) + xrel - 1))
                    highest = highest + 1
                    curpos = curpos + 1
                    curx = tfx: xrel = 1
                ELSE
                    curpos = curpos + 1
                    curx = tfx: xrel = 1
                    highest = highest + 1
                END IF



            CASE CHR$(24)
                'CTRL+X (cut)
                edited = 1
                IF selinfo$ <> "" THEN _CLIPBOARD$ = selinfo$
                IF starty > 0 AND starty = endy AND startx <= endx THEN codetext(curpos - tfy + yrel - 1) = MID$(codetext(curpos - tfy + yrel - 1), 1, (startx - (tfx - 1)) - 1) + MID$(codetext(curpos - tfy + yrel - 1), (endx - (tfx - 1)) + 1, LEN(codetext(curpos - tfy + yrel - 1))): curx = curx - (endx - startx + 1)
                IF starty > 0 AND starty = endy AND startx > endx THEN codetext(curpos - tfy + yrel - 1) = MID$(codetext(curpos - tfy + yrel - 1), 1, (endx - (tfx - 1)) - 1) + MID$(codetext(curpos - tfy + yrel - 1), (startx - (tfx - 1)), LEN(codetext(curpos - tfy + yrel - 1)))
                IF starty < endy THEN
                    curx = tfx: xrel = 1
                    mer = 0
                    FOR whala = (starty - tfy) TO (starty - tfy) + (endy - starty)
                        FOR whasa = (starty - tfy) TO highest
                            codetext(whasa) = codetext(whasa + 1)

                        NEXT
                        IF whala <= highest THEN mer = mer + 1
                    NEXT
                    highest = highest - mer
                    IF highest < 0 THEN highest = 0
                    curpos = curpos - (endy - starty)
                    IF curpos < tfy THEN yrel = yrel + (curpos - tfy): curpos = tfy
                END IF
                IF starty > endy THEN
                    curx = tfy: xrel = 1
                    mer = 0
                    FOR whala = (endy - tfy) TO (endy - tfy) + (starty - endy)
                        FOR whasa = (endy - tfy) TO highest
                            codetext(whasa) = codetext(whasa + 1)

                        NEXT
                        IF whala <= highest THEN mer = mer + 1
                    NEXT
                    highest = highest - mer
                    IF highest < 0 THEN highest = 0
                END IF


                selinfo$ = "": startx = 0: endx = 0: starty = 0: endy = 0
            CASE CHR$(3), CHR$(0) + CHR$(146): IF selinfo$ <> "" THEN _CLIPBOARD$ = selinfo$
            CASE CHR$(22)
                'CTRL+V (paste) - first delete selection if it exists.
                IF starty > 0 AND starty = endy AND startx <= endx THEN codetext(curpos - tfy + yrel - 1) = MID$(codetext(curpos - tfy + yrel - 1), 1, (startx - (tfx - 1)) - 1) + MID$(codetext(curpos - tfy + yrel - 1), (endx - (tfx - 1)) + 1, LEN(codetext(curpos - tfy + yrel - 1))): curx = curx - (endx - startx + 1)
                IF starty > 0 AND starty = endy AND startx > endx THEN codetext(curpos - tfy + yrel - 1) = MID$(codetext(curpos - tfy + yrel - 1), 1, (endx - (tfx - 1)) - 1) + MID$(codetext(curpos - tfy + yrel - 1), (startx - (tfx - 1)), LEN(codetext(curpos - tfy + yrel - 1)))
                IF starty < endy THEN
                    curx = tfx: xrel = 1
                    mer = 0
                    FOR whala = (starty - tfy) TO (starty - tfy) + (endy - starty)
                        FOR whasa = (starty - tfy) TO highest
                            codetext(whasa) = codetext(whasa + 1)

                        NEXT
                        IF whala <= highest THEN mer = mer + 1
                    NEXT
                    highest = highest - mer
                    IF highest < 0 THEN highest = 0
                    curpos = curpos - (endy - starty)
                    IF curpos < tfy THEN yrel = yrel + (curpos - tfy): curpos = tfy
                END IF
                IF starty > endy THEN
                    curx = tfx: xrel = 1
                    mer = 0
                    FOR whala = (endy - tfy) TO (endy - tfy) + (starty - endy)
                        FOR whasa = (endy - tfy) TO highest
                            codetext(whasa) = codetext(whasa + 1)

                        NEXT
                        IF whala <= highest THEN mer = mer + 1
                    NEXT
                    highest = highest - mer
                    IF highest < 0 THEN highest = 0
                END IF

                pasteit = 1: action = 1
            CASE CHR$(0) + CHR$(3)
            CASE CHR$(30)
            CASE CHR$(0) + CHR$(61)
                'F3 - search/search again
                IF find$ = "" THEN find$ = searchname$(0, 0)
                IF find$ <> "" THEN
                    searchx = 1 + curx - tfx + xrel - 1: searchy = curpos - tfy + yrel - 1
                    IF curallmod = 1 THEN
                        startmody = 0
                        endmody = highest + 5
                    END IF
                    IF curallmod = 0 THEN
                        checkingmody = searchy
                        DO
                            IF checkingmody <= 0 THEN checkingmody = 0: EXIT DO
                            IF firstcheckcurrent = 0 THEN firstcheckcurrent = 1: IF LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 4))) = "sub " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 9))) = "function " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 8))) = "end sub " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 13))) = "end function " THEN EXIT DO
                            checkingmody = checkingmody - 1
                            IF LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 4))) = "sub " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 9))) = "function " THEN EXIT DO
                            IF LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 8))) = "end sub " OR LCASE$(LTRIM$(MID$(codetext(checkingmody), 1, 13))) = "end function " THEN checkingmody = checkingmody + 1: EXIT DO
                        LOOP UNTIL checkingmody = 0
                        startmody = checkingmody
                        checkingendy = searchy
                        DO
                            checkingendy = checkingendy + 1
                            IF checkingendy >= highest + 5 THEN checkingendy = highest + 5: EXIT DO
                            IF LCASE$(LTRIM$(MID$(codetext(checkingendy), 1, 4))) = "sub " OR LCASE$(LTRIM$(MID$(codetext(checkingendy), 1, 9))) = "function " THEN checkingendy = checkingendy - 1: EXIT DO
                            IF LCASE$(LTRIM$(MID$(codetext(checkingendy), 1, 8))) = "end sub " OR LCASE$(LTRIM$(MID$(codetext(checkingendy), 1, 13))) = "end function " THEN checkingendy = checkingendy - 1: EXIT DO
                        LOOP UNTIL checkingendy = highest + 5
                        endmody = checkingendy
                    END IF
                    currentsx = searchx + 1
                    FOR currentsy = searchy TO endmody
                        IF casesensitive = 1 THEN posin = INSTR(currentsx, codetext(currentsy), find$)
                        IF casesensitive = 0 THEN posin = INSTR(currentsx, LCASE$(codetext(currentsy)), LCASE$(find$))
                        IF posin = 0 THEN currentsx = 1
                        IF posin <> 0 THEN foundsearchstring = 1: GOTO foundsearchagain
                    NEXT
                    FOR currentsy = startmody TO searchy
                        IF casesensitive = 1 THEN posin = INSTR(currentsx, codetext(currentsy), find$)
                        IF casesensitive = 0 THEN posin = INSTR(currentsx, LCASE$(codetext(currentsy)), LCASE$(find$))
                        IF posin = 0 THEN currentsx = 1
                        IF posin <> 0 THEN foundsearchstring = 1: GOTO foundsearchagain
                    NEXT

                    foundsearchagain:
                    IF foundsearchstring = 1 THEN
                        yrel = 1 + (ABS(currentsy - 7 > 0) * (currentsy - 7))
                        IF yrel = 1 THEN curpos = currentsy + 3 + (tfy - 3)
                        IF yrel > 1 THEN curpos = 10 + (tfy - 3)
                        xrel = 1 + (ABS(posin - 38 > 0) * (posin - 38))
                        IF xrel = 1 THEN curx = posin + 1 + (tfx - 2)
                        IF xrel > 1 THEN curx = 39
                        selinfo$ = find$: startx = curx + LEN(find$) + (xrel - 1): endx = curx + (xrel - 1): starty = curpos + yrel - 1: endy = curpos + yrel - 1
                    END IF
                    IF foundsearchstring = 0 THEN
                        rete = msgokonly("Search Complete", "Didn't find search string", 10, 10, 28, 5)

                    END IF
                    foundsearchstring = 0
                END IF
            CASE CHR$(0) + CHR$(59)
                'keyword help (F1)
                IF changescreenclick = 0 THEN
                    startx = 0: endx = 0: starty = 0: endy = 0: selinfo$ = ""
                    IF help = 1 AND nohelp = 0 THEN
                        'keyhelp cancels help
                        help = 0
                        section$ = "Index"
                        IF prevtfy <> 0 THEN curpos = curpos - (20 - prevtfy): tfh = tfh + (20 - prevtfy): tfy = tfy - (20 - prevtfy)
                    END IF


                    IF codetext(curpos - tfy + yrel - 1) <> "" AND LEN(codetext(curpos - tfy + yrel - 1)) >= curx - tfx + xrel - 1 THEN
                        'go back to find the beginning of the word
                        presentx = (curx - tfx + xrel - 1) + 1 ' (strings start at index 1)
                        presenty = curpos - tfy + yrel - 1
                        presentchar$ = MID$(codetext(presenty), presentx, 1)
                        IF presentchar$ <> "" THEN
                            skipchecking = 0
                            IF ((ASC(presentchar$) < 48 OR (ASC(presentchar$) > 57 AND ASC(presentchar$) < 65)) OR (ASC(presentchar$) > 90 AND ASC(presentchar$) < 97 AND ASC(presentchar$) <> 95) AND ASC(presentchar$) <> 36) OR ASC(presentchar$) > 122 THEN skipchecking = 1
                            IF skipchecking = 0 THEN
                                startsyntax = 0
                                endsyntax = 0
                                DO WHILE presentx > 1
                                    presentx = presentx - 1
                                    presentchar$ = MID$(codetext(presenty), presentx, 1)
                                    IF ((ASC(presentchar$) < 48 OR (ASC(presentchar$) > 57 AND ASC(presentchar$) < 65)) OR (ASC(presentchar$) > 90 AND ASC(presentchar$) < 97 AND ASC(presentchar$) <> 95) AND ASC(presentchar$) <> 36) OR ASC(presentchar$) > 122 THEN startsyntax = presentx + 1: EXIT DO
                                LOOP
                                IF startsyntax <= 0 THEN startsyntax = 1: presentx = 1
                                DO WHILE presentx < LEN(codetext(presenty))
                                    presentx = presentx + 1
                                    presentchar$ = MID$(codetext(presenty), presentx, 1)
                                    IF ((ASC(presentchar$) < 48 OR (ASC(presentchar$) > 57 AND ASC(presentchar$) < 65)) OR (ASC(presentchar$) > 90 AND ASC(presentchar$) < 97 AND ASC(presentchar$) <> 95) AND ASC(presentchar$) <> 36) OR ASC(presentchar$) > 122 THEN endsyntax = presentx - 1: EXIT DO
                                LOOP
                                skipdone = 0
                                IF startsyntax = endsyntax THEN skipdone = 1
                                IF skipdone = 0 THEN
                                    IF endsyntax = 0 THEN endsyntax = LEN(codetext(presenty))
                                    syntaxcheck$ = MID$(codetext(presenty), startsyntax, (endsyntax - startsyntax) + 1)
                                    IF keyhelp = 0 AND tfy < 7 THEN gobackh = tfh: gobacky = tfy: gobackpos = curpos: tfh = tfh - (7 - tfy): tfy = 7: curpos = curpos + 4
                                    keyhelp = 1
                                    onetimekeyhelp = 0: foundsyntax = 0
                                END IF
                            END IF
                        END IF
                    END IF
                END IF
            CASE CHR$(0) + CHR$(84): IF changescreenclick = 0 THEN help = 1: startx = 0: endx = 0: starty = 0: endy = 0: selinfo$ = "": IF keyhelp = 1 AND helpfound = 1 THEN keyhelp = 0: tfh = gobackh: tfy = gobacky: curpos = curpos - 4: onetimekeyhelp = 0: foundsyntax = 0

            CASE CHR$(0) + CHR$(63) 'F5 - run
                'check if filename already exists first.
                IF _FULLSCREEN THEN
                    _AUTODISPLAY
                    _FULLSCREEN _OFF
                    _DISPLAY
                    rete = msgokonly("Fullscreen must be off.", "Otherwise it will freeze...", 10, 10, 50, 5)
                END IF

                filexi = 0
                dummy$ = ""
                SHELL _HIDE "dir/b " + CHR$(34) + filename$ + CHR$(34) + " > tempie.tmp"
                OPEN "tempie.tmp" FOR INPUT AS #1
                IF LOF(1) THEN
                    INPUT #1, dummy$
                END IF
                CLOSE #1
                KILL "tempie.tmp"
                IF dummy$ <> "" THEN filexi = 1

                IF filexi = 1 THEN SHELL _HIDE "del tempie.tmp"
                IF filexi = 1 THEN SHELL _HIDE "ren " + CHR$(34) + filename$ + CHR$(34) + " tempie.tmp"
                'check if renaming was successfull!
                IF filexist(currentpath$ + "tempie.tmp") OR filexi = 0 THEN
                    OPEN filename$ FOR OUTPUT AS #1
                    FOR lastline = highest TO 1 STEP -1
                        IF codetext(lastline) <> "" THEN EXIT FOR
                    NEXT
                    FOR currentsaveline = 0 TO lastline
                        PRINT #1, codetext(currentsaveline)
                    NEXT
                    CLOSE #1
                    SHELL CHR$(34) + qb64path$ + "qb64.exe" + CHR$(34) + " -c " + filename$
                    IF filexi = 1 THEN SHELL _HIDE "del " + CHR$(34) + filename$ + CHR$(34)
                    FOR iasjij = LEN(filename$) TO 1 STEP -1
                        IF MID$(filename$, iasjij, 1) = "\" THEN EXIT FOR
                    NEXT
                    IF filexi = 1 THEN SHELL _HIDE "ren " + CHR$(34) + currentpath$ + "tempie.tmp" + CHR$(34) + " " + CHR$(34) + MID$(filename$, iasjij + 1) + CHR$(34)
                    SHELL CHR$(34) + qb64path$ + MID$(filename$, iasjij + 1, ((LEN(filename$) - 3) - (iasjij + 1))) + ".exe" + CHR$(34)
                ELSE
                    rete = msgokonly("Cannot compile!", "Renaming Unsuccessfull!" + currentpath$ + "-" + filepath$, 10, 10, 50, 5)
                END IF



            CASE CHR$(0) + CHR$(64): errorcheck = 1: founderror$ = "": erchline = 0 'F6

            CASE CHR$(0) + CHR$(89): IF lineoferror <> -1 THEN gotocodeline lineoferror

            CASE CHR$(0) + CHR$(141)
                'ctrl + up
                linksel = linksel - 1: IF linksel <= 0 THEN linksel = links
            CASE CHR$(0) + CHR$(145)
                'ctrl + down
                linksel = linksel + 1: IF linksel > links THEN linksel = 0
            CASE CHR$(0) + CHR$(115)
                'ctrl + left
                linksel = linksel - 1: IF linksel <= 0 THEN linksel = links
            CASE CHR$(0) + CHR$(116)
                'ctrl + right
                linksel = linksel + 1: IF linksel > links THEN linksel = 0
            CASE ""
            CASE ELSE


                IF keyb$ = CHR$(0) + "{" THEN keyb$ = "$": waitrelease = 1
                IF keyb$ = CHR$(0) + CHR$(121) THEN keyb$ = "@": waitrelease = 1
                IF keyb$ = CHR$(0) + CHR$(122) THEN keyb$ = "": waitrelease = 1 'pound
                IF keyb$ = CHR$(0) + CHR$(126) THEN keyb$ = "{": waitrelease = 1 '<
                IF keyb$ = CHR$(0) + CHR$(127) THEN keyb$ = "[": waitrelease = 1 'left bracket
                IF keyb$ = CHR$(0) + CHR$(128) THEN keyb$ = "]": waitrelease = 1 'right bracket
                IF keyb$ = CHR$(0) + CHR$(129) THEN keyb$ = "}": waitrelease = 1 '>
                IF keyb$ = CHR$(0) + CHR$(130) THEN keyb$ = "\": waitrelease = 1 'slash
                IF keyb$ = CHR$(0) + CHR$(27) THEN keyb$ = "~": waitrelease = 1 'tilde
                IF ASC(keyb$) <> 0 THEN
                    edited = 1
                    IF starty > 0 AND starty = endy AND startx <= endx THEN codetext(curpos - tfy + yrel - 1) = MID$(codetext(curpos - tfy + yrel - 1), 1, (startx - (tfx - 1)) - 1) + MID$(codetext(curpos - tfy + yrel - 1), (endx - (tfx - 1)) + 1, LEN(codetext(curpos - tfy + yrel - 1))): curx = curx - (endx - startx + 1)
                    IF starty > 0 AND starty = endy AND startx > endx THEN codetext(curpos - tfy + yrel - 1) = MID$(codetext(curpos - tfy + yrel - 1), 1, (endx - (tfx - 1)) - 1) + MID$(codetext(curpos - tfy + yrel - 1), (startx - (tfx - 1)), LEN(codetext(curpos - tfy + yrel - 1)))
                    IF starty < endy THEN
                        mer = 0
                        FOR whala = (starty - tfy) TO (starty - tfy) + (endy - starty)
                            FOR whasa = (starty - tfy) TO highest
                                codetext(whasa) = codetext(whasa + 1)

                            NEXT
                            IF whala <= highest THEN mer = mer + 1
                        NEXT
                        highest = highest - mer
                        IF highest < 0 THEN highest = 0
                        curpos = curpos - (endy - starty)
                        IF curpos < tfy THEN yrel = yrel + (curpos - tfy): curpos = tfy
                    END IF
                    IF starty > endy THEN
                        mer = 0
                        FOR whala = (endy - tfy) TO (endy - tfy) + (starty - endy)
                            FOR whasa = (endy - tfy) TO highest
                                codetext(whasa) = codetext(whasa + 1)

                            NEXT
                            IF whala <= highest THEN mer = mer + 1
                        NEXT
                        highest = highest - mer
                        IF highest < 0 THEN highest = 0
                    END IF

                    selinfo$ = "": startx = 0: endx = 0: starty = 0: endy = 0
                    IF curpos - tfy + yrel - 1 > highest THEN highest = curpos - tfy + yrel - 1
                    IF curx - (tfx - 1) + xrel - 1 > LEN(codetext(curpos - tfy + yrel - 1)) THEN codetext(curpos - tfy + yrel - 1) = codetext(curpos - tfy + yrel - 1) + SPACE$((curx - (tfx - 1) + xrel - 1) - LEN(codetext(curpos - tfy + yrel - 1)) + xrel - 1)
                    IF mode = 0 THEN codetext(curpos - tfy + yrel - 1) = MID$(codetext(curpos - tfy + yrel - 1), 1, (curx - tfx) + (xrel - 1)) + keyb$ + MID$(codetext(curpos - tfy + yrel - 1), (curx - (tfx - 1)) + (xrel - 1), LEN(codetext(curpos - tfy + yrel - 1))): curx = curx + 1
                    IF mode = 1 THEN MID$(codetext(curpos - tfy + yrel - 1), curx - (tfx - 1) + xrel - 1, 1) = keyb$: curx = curx + 1: codetext(curpos - tfy + yrel - 1) = codetext(curpos - tfy + yrel - 1) + " "
                END IF
        END SELECT
    END IF
END IF




IF yrel < 1 THEN yrel = 1
IF xrel < 1 THEN xrel = 1
IF startx > endx THEN endx = curx + (xrel - 1)
IF changedline <> -1 THEN changed$ = STR$(changedline)
IF pasteit = 1 THEN
    selinfo$ = "": startx = 0: endx = 0: starty = 0: endy = 0
    'let's paste the contents of the clipboard.
    xxx = xxx + 1

    char$ = MID$(_CLIPBOARD$, xxx, 1)
    IF char$ = CHR$(13) THEN

        IF highest >= (curpos - tfy + yrel - 1) THEN
            FOR g = highest TO (curpos - tfy + yrel - 1) STEP -1
                codetext(g + 1) = codetext(g)
            NEXT
            codetext((curpos - tfy + yrel - 1) + 1) = MID$(codetext((curpos - tfy + yrel - 1) + 1), (curx - (tfx - 1) + xrel - 1))
            codetext(curpos - tfy + yrel - 1) = MID$(codetext(curpos - tfy + yrel - 1), 1, (curx - (tfx - 1) + xrel - 1))
            highest = highest + 1
            curpos = curpos + 1
            curx = tfx: xrel = 1
        ELSE
            curpos = curpos + 1
            curx = tfx: xrel = 1
            highest = highest + 1
        END IF

    END IF

    IF char$ <> CHR$(10) AND char$ <> CHR$(13) THEN
        IF curpos - tfy + yrel - 1 > highest THEN highest = curpos - tfy + yrel - 1
        IF curx - (tfx - 1) + xrel - 1 > LEN(codetext(curpos - tfy + yrel - 1)) THEN codetext(curpos - tfy + yrel - 1) = codetext(curpos - tfy + yrel - 1) + SPACE$((curx - (tfx - 1) + xrel - 1) - LEN(codetext(curpos - tfy + yrel - 1)) + xrel - 1)
        codetext(curpos - tfy + yrel - 1) = MID$(codetext(curpos - tfy + yrel - 1), 1, (curx - tfx) + (xrel - 1)) + char$ + MID$(codetext(curpos - tfy + yrel - 1), (curx - (tfx - 1)) + (xrel - 1), LEN(codetext(curpos - tfy + yrel - 1))): curx = curx + 1
    END IF

    IF xxx >= LEN(_CLIPBOARD$) THEN pasteit = 0: xxx = 0: IF formatset = 1 THEN runformat = 1
END IF

IF starty = 0 THEN moretoup = 0: moretoleft = 0

IF curx > tfx + tfw - 1 THEN
    '79
    curx = tfx + tfw - 1: xrel = xrel + 1
END IF

IF curx < tfx THEN
    curx = tfx
    IF xrel > 1 THEN
        xrel = xrel - 1
    END IF
END IF

IF curpos > tfy + tfh - 1 THEN
    '19
    curpos = tfy + tfh - 1
    IF yrel + curpos < highest + tfh THEN
        yrel = yrel + 1
    END IF
END IF

IF curpos < tfy THEN
    curpos = tfy
    IF yrel > 1 THEN
        yrel = yrel - 1
    END IF
END IF





'Formatting:
IF changedline >= 0 AND formatset = 1 THEN
    'comment
    'quotes(60)
    'ordinary(60)


    comment = ""
    ERASE quotes
    ERASE ordinary
    order$ = ""
    look = 0
    numquote = 0
    numordi = 0
    ordi = 0
    quote = 0
    quo = 0
    ord = 0
    sps = 0
    IF (changedline - tfy < 0) THEN changedline = changedline + (tfy + 1)

    IF changedline - tfy < 0 THEN PRINT "ERROR changedline - tfy = "; changedline - tfy: PRINT "changedline = "; changedline: PRINT "tfy = "; tfy: _DISPLAY: END
    IF LEN(codetext(changedline - tfy)) > 0 THEN
        DO
            look = look + 1
            blook = 0

            IF MID$(codetext(changedline - tfy), look, 1) = CHR$(34) AND quote = 0 THEN quote = 1: order$ = order$ + "q": numquote = numquote + 1: ordi = 0: blook = look

            IF quote = 1 THEN
                DO
                    quotes(numquote) = quotes(numquote) + MID$(codetext(changedline - tfy), look, 1)
                    IF MID$(codetext(changedline - tfy), look, 1) = CHR$(34) AND look <> blook THEN quote = 0: ordi = 0: EXIT DO
                    IF look >= LEN(codetext(changedline - tfy)) THEN EXIT DO
                    look = look + 1
                LOOP
            END IF
            IF look >= LEN(codetext(changedline - tfy)) THEN EXIT DO

            IF quote = 0 AND (MID$(codetext(changedline - tfy), look, 1) = "'" OR UCASE$(MID$(codetext(changedline - tfy), look, 5)) = " REM ") OR UCASE$(MID$(codetext(changedline - tfy), look, 5)) = ":REM " OR (UCASE$(MID$(codetext(changedline - tfy), look, 4)) = "REM " AND look = 1) OR (UCASE$(MID$(codetext(changedline - tfy), look, 4)) = "REM:" AND look = 1) THEN


                sps = 0
                FOR sp = look TO 1 STEP -1
                    IF MID$(codetext(changedline - tfy), sp, 1) = " " AND sp <> look THEN sps = sps + 1
                    IF MID$(codetext(changedline - tfy), sp, 1) <> " " AND sp <> look THEN EXIT FOR
                NEXT
                IF MID$(codetext(changedline - tfy), look, 1) = ":" THEN order$ = order$ + "o": numordi = numordi + 1: ordinary(numordi) = ":": look = look + 1
                comment = SPACE$(sps) + RTRIM$((MID$(codetext(changedline - tfy), look))): order$ = order$ + "c": EXIT DO






            END IF

            IF quote = 0 AND ordi = 0 THEN ordi = 1: order$ = order$ + "o": numordi = numordi + 1
            IF quote = 0 AND ordi = 1 THEN
                IF MID$(codetext(changedline - tfy), look, 1) <> CHR$(34) THEN ordinary(numordi) = ordinary(numordi) + MID$(codetext(changedline - tfy), look, 1)
            END IF
        LOOP UNTIL look > LEN(codetext(changedline - tfy))
        ordinary(numordi) = RTRIM$(ordinary(numordi))
    END IF

    codetext(changedline - tfy) = ""
    ininfo$ = order$
    IF order$ <> "" THEN
        FOR look = 1 TO LEN(order$)
            IF MID$(order$, look, 1) = "o" THEN
                ord = ord + 1
                IF ord <= numordi THEN
                    'here is the actual formatting!
                    IF ord = 1 THEN ordinary(ord) = formatmultispace$(ordinary(ord), 1)
                    IF ord > 1 THEN ordinary(ord) = formatmultispace$(ordinary(ord), 0)
                    ordinary(ord) = formatcommaop$(ordinary(ord))
                    ordinary(ord) = formatparanteses$(ordinary(ord))
                    ordinary(ord) = formatcommaop$(ordinary(ord)) 'formatcommaop$ is run twice...
                    ordinary(ord) = formatremovecomma$(ordinary(ord))
                    ordinary(ord) = formatkeywords$(ordinary(ord), numkey, keyword(), keytype())
                    ordinary(ord) = formatremovestuff$(ordinary(ord))
                    IF ord = 1 THEN ordinary(ord) = formatmultispace$(ordinary(ord), 1) 'formatmultispace$ is run twice...
                    IF ord > 1 THEN ordinary(ord) = formatmultispace$(ordinary(ord), 0)
                    IF MID$(codetext(changedline - tfy), LEN(codetext(changedline - tfy)), 1) = CHR$(34) AND MID$(ordinary(ord), 1, 1) = "+" THEN ordinary(ord) = " " + ordinary(ord)
                    codetext(changedline - tfy) = codetext(changedline - tfy) + ordinary(ord)
                END IF
            END IF
            IF MID$(order$, look, 1) = "q" THEN
                quo = quo + 1
                IF quo <= numquote THEN
                    codetext(changedline - tfy) = RTRIM$(codetext(changedline - tfy))
                    IF MID$(codetext(changedline - tfy), LEN(codetext(changedline - tfy))) <> "(" THEN codetext(changedline - tfy) = codetext(changedline - tfy) + " " + RTRIM$(quotes(quo)) ELSE codetext(changedline - tfy) = codetext(changedline - tfy) + RTRIM$(quotes(quo))
                END IF
            END IF
            IF MID$(order$, look, 1) = "c" THEN
                FOR cosp = 1 TO LEN(comment)
                    IF MID$(comment, cosp, 1) <> " " THEN EXIT FOR
                NEXT
                IF MID$(LCASE$(comment), cosp, 3) = "rem" THEN MID$(comment, cosp, 3) = "REM"
                IF cosp = 1 AND LEN(ordinary(ord)) >= 1 THEN
                    IF MID$(ordinary(ord), LEN(ordinary(ord)), 1) = ":" THEN comment = " " + comment
                END IF

                codetext(changedline - tfy) = codetext(changedline - tfy) + comment: EXIT FOR
            END IF

        NEXT
        IF MID$(RTRIM$(codetext(changedline - tfy)), LEN(codetext(changedline - tfy)), 1) <> CHR$(10) THEN codetext(changedline - tfy) = RTRIM$(codetext(changedline - tfy)) + CHR$(32)
    END IF



    changedline = -1
END IF


GOTO 1


onetime:
IF edited = 1 THEN
    undocount = undocount + 1
    IF undocount > 50 THEN undocount = 1
    undo(0, undocount) = "Element;" + STR$(undocount) + " around line;" + STR$(curpos - tfy + yrel)
    FOR undopos = 1 TO 10
        undo(undopos, undocount) = ""
        IF ((curpos - tfy + yrel - 1) - 5) + undopos >= 0 THEN
            IF ((curpos - tfy + yrel - 1) - 5) + undopos > highest THEN EXIT FOR
            undo(undopos, undocount) = codetext(((curpos - tfy + yrel - 1) - 5) + undopos) + "  '" + STR$(((curpos - tfy + yrel) - 5) + undopos)
        END IF
    NEXT
    undopos = undopos + 1
    undo(undopos, undocount) = "'---end of code---"
END IF
RETURN


errorhandle:
COLOR 4, 0
LOCATE 10, 10: PRINT "A ERROR HAS OCCURED!"
LOCATE 11, 10: PRINT "Continue? Y/N"
_DISPLAY
DO

    SELECT CASE kebd$
        CASE "y", "Y": RESUME NEXT
        CASE "n", "N": SYSTEM
        CASE CHR$(27): SYSTEM
        CASE CHR$(13): RESUME NEXT
    END SELECT

LOOP



'the keywords and the type of keyword
DATA "_ALPHA", "(function)", "_ALPHA32", "(function)", "_AUTODISPLAY", "(statement)", "_BACKGROUNDCOLOR", "(function)", "_BIT", "(statement)", "_BLEND", "(statement)", "_BLEND", "(function)", "_BLUE", "(function)", "_BLUE32", "(function)", "_BYTE", "(statement)"
DATA "_CLEARCOLOR", "(statement)", "_CLEARCOLOR", "(function)", "_CLIP", "(statement)", "_CLIPBOARD$", "(function)", "_CLIPBOARD$", "(statement)", "_CONNECTED", "(function)", "_CONNECTIONADDRESS", "(function)", "_COPYIMAGE", "(function)", "_COPYPALETTE", "(statement)", "_CV", "(function)"
DATA "_DEFAULTCOLOR", "(function)", "_DEFINE", "(statement)", "_DELAY", "(statement)", "_DEST", "(statement)", "_DEST", "(function)", "_DISPLAY", "(statement)", "_DISPLAY", "(function)", "_DONTBLEND", "(statement)", "_DONTWAIT", "(statement)", "_ERRORLINE", "(function)", "_EXIT", "(function)"
DATA "_FLOAT", "(statement)", "_FONT", "(statement)", "_FONT", "(function)", "_FONTHEIGHT", "(function)", "_FONTWIDTH", "(function)", "_FREEFONT", "(statement)", "_FREEIMAGE", "(statement)", "_FREETIMER", "(function)", "_FULLSCREEN", "(function)", "_FULLSCREEN", "(statement)"
DATA "_GREEN", "(function)", "_GREEN32", "(function)", "_HEIGHT", "(function)", "_HIDE", "(statement)", "_ICON", "(statement)", "_INTEGER64", "(statement)", "_LIMIT", "(statement)", "_LOADFONT", "(function)", "_LOADIMAGE", "(function)", "_MK$", "(function)", "_MOUSEBUTTON", "(function)"
DATA "_MOUSEHIDE", "(statement)", "_MOUSEINPUT", "(function)", "_MOUSESHOW", "(statement)", "_MOUSEWHEEL", "(function)", "_MOUSEX", "(function)", "_MOUSEY", "(function)", "_NEWIMAGE", "(function)", "_OPENCLIENT", "(function)", "_OPENCONNECTION", "(function)", "_OPENHOST", "(function)"
DATA "_PALETTECOLOR", "(statement)", "_PALETTECOLOR", "(function)", "_PIXELSIZE", "(function)", "_PRESERVE", "(statement)", "_PRINTMODE", "(statement)", "_PRINTMODE", "(function)", "_PRINTSTRING", "(statement)", "_PRINTWIDTH", "(function)", "_PUTIMAGE", "(statement)", "_RED", "(function)", "_RED32", "(function)"
DATA "_RGB", "(function)", "_RGB32", "(function)", "_RGBA", "(function)", "_RGBA32", "(function)", "_ROUND", "(function)", "_SCREENCLICK", "(statement)", "_SCREENIMAGE", "(function)", "_SCREENPRINT", "(statement)", "_SETALPHA", "(statement)", "_SNDBAL", "(statement)", "_SNDCLOSE", "(statement)", "_SNDCOPY", "(function)", "_SNDGETPOS", "(function)"
DATA "_SNDLEN", "(function)", "_SNDLIMIT", "(statement)", "_SNDLOOP", "(statement)", "_SNDOPEN", "(function)", "_SNDPAUSE", "(statement)", "_SNDPAUSED", "(function)", "_SNDPLAY", "(statement)", "_SNDPLAYCOPY", "(statement)", "_SNDPLAYFILE", "(statement)", "_SNDPLAYING", "(function)"
DATA "_SNDSETPOS", "(statement)", "_SNDSTOP", "(statement)", "_SNDVOL", "(statement)", "_SOURCE", "(statement)", "_SOURCE", "(function)", "_TITLE", "(statement)", "_UNSIGNED", "(statement)", "_WIDTH", "(function)", "ABS", "(function)", "ABSOLUTE", "(statement)"
DATA "ACCESS", "(statement)", "ALIAS", "(statement)", "AND", "(statement)", "AND", "(statement)", "ANY", "(statement)", "APPEND", "(statement)", "AS", "(statement)", "ASC", "(function)", "ATN", "(function)", "BASE", "(statement)"
DATA "BEEP", "(statement)", "BINARY", "(statement)", "BLOAD", "(statement)", "BSAVE", "(statement)", "BYVAL", "(statement)", "CALL", "(statement)", "CALL ABSOLUTE", "(statement)", "CALLS", "(statement)", "CASE", "(statement)", "CASE ELSE", "(statement)"
DATA "CDBL", "(function)", "CDECL", "(statement)", "CHAIN", "(statement)", "CHDIR", "(statement)", "CHR$", "(function)", "CINT", "(function)", "CIRCLE", "(statement)", "CLEAR", "(statement)", "CLNG", "(function)", "CLOSE", "(statement)"
DATA "CLS", "(statement)", "COLOR", "(statement)", "COM", "(statement)", "COMMAND$", "(function)", "COMMON", "(statement)", "COMMON SHARED", "(statement)", "CONST", "(statement)", "COS", "(function)", "CSNG", "(function)", "CSRLIN", "(function)"
DATA "CVD", "(function)", "CVDMBF", "(function)", "CVI", "(function)", "CVL", "(function)", "CVS", "(function)", "CVSMBF", "(function)", "DATA", "(statement)", "DATE$", "(function)", "DATE$", "(statement)", "DECLARE", "(statement)"
DATA "DECLARE", "(statement)", "DEF FN", "(statement)", "DEF SEG", "(statement)", "DEFDBL", "(statement)", "DEFINT", "(statement)", "DEFLNG", "(statement)", "DEFSNG", "(statement)", "DEFSTR", "(statement)", "DIM", "(statement)", "DO", "(statement)"
DATA "DOUBLE", "(statement)", "DRAW", "(statement)", "$DYNAMIC", "(statement)", "ELSE", "(statement)", "ELSEIF", "(statement)", "END", "(statement)", "END FUNCTION", "(statement)", "END IF", "(statement)", "END SELECT", "(statement)", "END SUB", "(statement)"
DATA "END TYPE", "(statement)", "ENVIRON", "(statement)", "ENVIRON$", "(function)", "EOF", "(function)", "EQV", "(statement)", "ERASE", "(statement)", "ERDEV", "(function)", "ERDEV$", "(function)", "ERL", "(function)", "ERR", "(function)"
DATA "ERROR", "(statement)", "EXIT", "(statement)", "EXIT DEF", "(statement)", "EXIT DO", "(statement)", "EXIT FOR", "(statement)", "EXIT FUNCTION", "(statement)", "EXIT SUB", "(statement)", "EXP", "(function)", "FIELD", "(statement)", "FILEATTR", "(function)"
DATA "FILES", "(statement)", "FIX", "(function)", "FOR", "(statement)", "FRE", "(function)", "FREEFILE", "(function)", "FUNCTION", "(statement)", "GET", "(statement)", "GET", "(statement)", "GET", "(statement)", "GOSUB", "(statement)"
DATA "GOTO", "(statement)", "HEX$", "(function)", "IF", "(statement)", "IMP", "(statement)", "$INCLUDE", "(statement)", "INKEY$", "(function)", "INP", "(function)", "INPUT", "(statement)", "INPUT", "(statement)", "INPUT", "(statement)"
DATA "INPUT", "(statement)", "INPUT$", "(function)", "INSTR", "(function)", "INT", "(function)", "INTEGER", "(statement)", "INTERRUPT", "(statement)", "INTERRUPTX", "(statement)", "IOCTL", "(statement)", "IOCTL$", "(function)", "IS", "(statement)"
DATA "KEY", "(statement)", "KEY", "(statement)", "KILL", "(statement)", "LBOUND", "(function)", "LCASE$", "(function)", "LEFT$", "(function)", "LEN", "(function)", "LET", "(statement)", "LINE", "(statement)", "LINE INPUT", "(statement)"
DATA "LINE INPUT", "(statement)", "LIST", "(statement)", "LOC", "(function)", "LOCAL", "(statement)", "LOCATE", "(statement)", "LOCK", "(statement)", "LOF", "(function)", "LOG", "(function)", "LONG", "(statement)", "LOOP", "(statement)"
DATA "LPOS", "(function)", "LPRINT", "(statement)", "LPRINT USING", "(statement)", "LSET", "(statement)", "LTRIM$", "(function)", "MID$", "(function)", "MID$", "(statement)", "MKD$", "(function)", "MKDIR", "(statement)", "MKDMBF$", "(function)"
DATA "MKI$", "(function)", "MKL$", "(function)", "MKS$", "(function)", "MKSMBF$", "(function)", "MOD", "(statement)", "NAME", "(statement)", "NEXT", "(statement)", "NOT", "(statement)", "OCT$", "(function)", "OFF", "(statement)"
DATA "ON", "(statement)", "ON COM", "(statement)", "ON ERROR", "(statement)", "ON KEY", "(statement)", "ON PEN", "(statement)", "ON PLAY", "(statement)", "ON STRIG", "(statement)", "ON TIMER", "(statement)", "ON UEVENT", "(statement)", "ON", "(statement)"
DATA "OPEN", "(statement)", "OPEN COM", "(statement)", "OPTION BASE", "(statement)", "OR", "(statement)", "OR", "(statement)", "OUT", "(statement)", "OUTPUT", "(statement)", "PAINT", "(statement)", "PALETTE", "(statement)", "PCOPY", "(statement)"
DATA "PEEK", "(function)", "PEN", "(function)", "PEN", "(statement)", "PLAY", "(function)", "PLAY", "(statement)", "PMAP", "(function)", "POINT", "(function)", "POKE", "(statement)", "POS", "(function)", "PRESET", "(statement)"
DATA "PRINT", "(statement)", "PRINT", "(statement)", "PRINT", "(statement)", "PRINT USING", "(statement)", "PRINT USING", "(statement)", "PSET", "(statement)", "PUT", "(statement)", "PUT", "(statement)", "PUT", "(statement)", "RANDOM", "(statement)"
DATA "RANDOMIZE", "(statement)", "READ", "(statement)", "REDIM", "(statement)", "REM", "(statement)", "RESET", "(statement)", "RESTORE", "(statement)", "RESUME", "(statement)", "RETURN", "(statement)", "RIGHT$", "(function)", "RMDIR", "(statement)"
DATA "RND", "(function)", "RSET", "(statement)", "RTRIM$", "(function)", "RUN", "(statement)", "SADD", "(function)", "SCREEN", "(function)", "SCREEN", "(statement)", "SEEK", "(function)", "SEEK", "(statement)", "SELECT CASE", "(statement)"
DATA "SETMEM", "(function)", "SGN", "(function)", "SHARED", "(statement)", "SHELL", "(statement)", "SIGNAL", "(statement)", "SIN", "(function)", "SINGLE", "(statement)", "SLEEP", "(statement)", "SOUND", "(statement)", "SPACE$", "(function)"
DATA "SPC", "(function)", "SQR", "(function)", "STATIC", "(statement)", "$STATIC", "(statement)", "STEP", "(statement)", "STICK", "(function)", "STOP", "(statement)", "STR$", "(function)", "STRIG", "(function)", "STRIG", "(statement)"
DATA "STRING", "(statement)", "STRING$", "(function)", "SUB", "(statement)", "SWAP", "(statement)", "SYSTEM", "(statement)", "TAB", "(function)", "TAN", "(function)", "THEN", "(statement)", "TIME$", "(function)", "TIME$", "(statement)"
DATA "TIMER", "(function)", "TIMER", "(statement)", "TO", "(statement)", "TROFF", "(statement)", "TRON", "(statement)", "TYPE", "(statement)", "UBOUND", "(function)", "UCASE$", "(function)", "UEVENT", "(statement)", "UNLOCK", "(statement)"
DATA "UNTIL", "(statement)", "VAL", "(function)", "VARPTR", "(function)", "VARPTR$", "(function)", "VARSEG", "(function)", "VIEW", "(statement)", "VIEW PRINT", "(statement)", "WAIT", "(statement)", "WEND", "(statement)", "WHILE", "(statement)"
DATA "WHILE", "(statement)", "WIDTH", "(statement)", "WINDOW", "(statement)", "WRITE", "(statement)", "WRITE", "(statement)", "XOR", "(statement)", -1, -1


'the function and subs...

SUB gotocodeline (theline)
'assuming 1 is first line
yrel = 1 + (ABS((theline - 1) - 7 > 0) * ((theline - 1) - 7))
IF yrel = 1 THEN curpos = (theline - 1) + tfy
IF yrel > 1 THEN curpos = 10
xpos = tfx
xrel = 1
END SUB


FUNCTION file2array (filur$, array$())

OPEN filur$ FOR BINARY AS #1
IF LOF(1) THEN
    l = LOF(1)
    file$ = SPACE$(l)
    GET #1, , file$
    IF RIGHT$(file$, 1) = CHR$(26) THEN file$ = LEFT$(file$, LEN(file$) - 1)
END IF
CLOSE #1
' the whole file is now in file$ (minus chr$(26))

IF LEN(file$) THEN
    DO
        po = po + 1
        IF po > l THEN EXIT DO 'reached the length of the file

        curbyte$ = MID$(file$, po, 1)
        cur2byte$ = MID$(file$, po, 2)

        IF (cur2byte$ = CHR$(10) + CHR$(13)) OR (cur2byte$ = CHR$(13) + CHR$(10)) THEN array$(n) = array$(n) + " ": n = n + 1: skip = 1: nextline = 1: po = po + 1
        IF nextline = 0 AND skip = 0 AND (curbyte$ = CHR$(10) OR curbyte$ = CHR$(13)) THEN array$(n) = array$(n) + " ": n = n + 1: skip = 1
        IF skip = 0 AND curbyte$ = CHR$(9) THEN MID$(file$, po, 1) = " ": curbyte$ = "    "
        IF skip = 0 THEN array$(n) = array$(n) + curbyte$
        skip = 0
        nextline = 0
    LOOP
ELSE
    file2array = -1
    EXIT FUNCTION
END IF

file2array = n


END FUNCTION



FUNCTION extractpath$ (filepath$)
IF LEN(filepath$) > 0 THEN
    FOR epp = LEN(filepath$) TO 1 STEP -1
        IF MID$(filepath$, epp, 1) = "\" THEN EXIT FOR
    NEXT
    extractpath$ = MID$(filepath$, 1, epp)
    IF epp = 1 THEN extractpath$ = ""
END IF
END FUNCTION


FUNCTION filexist (filepath$)
dummy$ = ""
SHELL _HIDE "dir/b " + CHR$(34) + filepath$ + CHR$(34) + " > tempexist.tmp"
OPEN "tempexist.tmp" FOR INPUT AS #1
IF LOF(1) THEN
    INPUT #1, dummy$
END IF
CLOSE #1
KILL "tempexist.tmp"
IF dummy$ <> "" THEN filexist = -1: EXIT FUNCTION ELSE filexist = 0: EXIT FUNCTION
END FUNCTION



FUNCTION msgokonly (thetitle$, information$, xing, ying, wide, hehe)

IF ying + 1 + hehe > _HEIGHT THEN ying = 2
IF xing + 1 + wide > _WIDTH THEN xing = 2

IF ying + 1 + hehe > _HEIGHT THEN SOUND 500, .1: EXIT FUNCTION
IF xing + 1 + wide > _WIDTH THEN SOUND 500, .1: EXIT FUNCTION


DO

    exittype = _EXIT
    IF exittype = 1 OR exittype = 3 THEN
        IF edited = 0 THEN
            SYSTEM
        ELSE
            retcode = msgbox("Are you sure?", "Code has been changed since the latest save, are you sure you want to quit?", 1, 22, 6)
            IF retcode = 1 THEN
                SYSTEM
            END IF
        END IF
    END IF


    'titlebar
    COLOR 7, 0
    LOCATE ying - 1, xing - 1: PRINT SPACE$(wide + 2)
    LOCATE ying - 1, (xing - 1) + INT(((wide + 2) - LEN(thetitle$)) / 2): PRINT thetitle$

    'frame
    COLOR 0, 7
    LOCATE ying, xing - 1: PRINT CHR$(218) + STRING$(wide, 196) + CHR$(191)

    FOR it = 1 TO hehe
        LOCATE ying + it, xing - 1: PRINT CHR$(179)
        LOCATE ying + it, xing: PRINT SPACE$(wide)
        LOCATE ying + it, xing + wide: PRINT CHR$(179)
        IF it = CINT(hehe / 2) THEN LOCATE ying + it - 1, xing + INT((wide - LEN(information$)) / 2): PRINT information$
        IF it = hehe - 1 THEN LOCATE ying + it, xing - 1: PRINT CHR$(195)
        IF it = hehe - 1 THEN LOCATE ying + it, xing + wide: PRINT CHR$(180)
        IF (ying + it = ymusen) AND (xmusen >= xing + INT((wide - 4) / 2)) AND (xmusen <= xing + INT((wide - 4) / 2) + 3) THEN COLOR 7, 0: overok = 1 ELSE COLOR 0, 7: overok = 0
        IF it = hehe THEN LOCATE ying + it, xing + INT((wide - 4) / 2): PRINT "<OK>"
        COLOR 0, 7
    NEXT
    LOCATE ying + hehe - 1, xing: PRINT STRING$(wide, 196)
    'here is where the OK CANCEL should be but is put in the FOR...NEXT loop above instead...
    LOCATE ying + hehe + 1, xing - 1: PRINT CHR$(192) + STRING$(wide, 196) + CHR$(217)

    'keyboard input
    kbd$ = INKEY$
    SELECT CASE kbd$
        CASE CHR$(13): msgokonly = -1: EXIT FUNCTION
        CASE CHR$(27): msgokonly = 0: EXIT FUNCTION
    END SELECT

    'mouse input
    DO WHILE _MOUSEINPUT
        ymusen = CINT(_MOUSEY)
        xmusen = CINT(_MOUSEX)
        bmusen = _MOUSEBUTTON(1)
    LOOP
    IF overok = 1 AND bmusen = 0 THEN waitforok = 1
    IF overok = 1 AND bmusen = -1 AND waitforok = 1 THEN msgokonly = -1: EXIT FUNCTION
    IF overok = 0 AND bmusen = 0 THEN waitforok = 0

    _LIMIT 60
    IF _FULLSCREEN THEN

        IF xmusen > 0 AND ymusen > 0 AND xmusen <= _WIDTH AND ymusen <= _HEIGHT THEN
            LOCATE ymusen, xmusen, 1, 1, 8
        END IF
    END IF

    _DISPLAY
    'PCOPY 1, 0

LOOP
END FUNCTION


FUNCTION setfont$

'f& = _LOADFONT(ENVIRON$("windir") + "\fonts\" + thefont$, fontheight, "monospace"): _FONT f&
IF thefont$ <> "" THEN inputted$ = thefont$
inputted2$ = STR$(fontheight)

'init
DIM scrarray(20 * 70)
xing = 20
ying = 7
wide = 30
hehe = 12

IF ying + 1 + hehe > _HEIGHT THEN ying = 2
IF xing + 1 + wide > _WIDTH THEN xing = 2

IF ying + 1 + hehe > _HEIGHT THEN SOUND 500, .1: usefont = -1: EXIT FUNCTION
IF xing + 1 + wide > _WIDTH THEN SOUND 500, .1: usefont = -1: EXIT FUNCTION


texbx = 2
texby = 4
texbdec = 6
DO
    exittype = _EXIT
    IF exittype = 1 OR exittype = 3 THEN
        IF edited = 0 THEN
            SYSTEM
        ELSE
            retcode = msgbox("Are you sure?", "Code has been changed since the latest save, are you sure you want to quit?", 1, 22, 6)
            IF retcode = 1 THEN
                SYSTEM
            END IF
        END IF
    END IF

    'titlebar
    COLOR 7, 0
    LOCATE ying - 1, xing - 1: PRINT SPACE$(wide + 2)
    LOCATE ying - 1, (xing - 1) + INT(((wide + 2) - LEN("Set Font")) / 2): PRINT "Set Font"

    'frame
    COLOR 0, 7
    LOCATE ying, xing - 1: PRINT CHR$(218) + STRING$(wide, 196) + CHR$(191)

    FOR it = 1 TO hehe
        LOCATE ying + it, xing - 1: PRINT CHR$(179)
        LOCATE ying + it, xing: PRINT SPACE$(wide)
        LOCATE ying + it, xing + wide: PRINT CHR$(179)
        IF it = hehe - 1 THEN LOCATE ying + it, xing - 1: PRINT CHR$(195)
        IF it = hehe - 1 THEN LOCATE ying + it, xing + wide: PRINT CHR$(180)
        IF (ying + it = ymusen) AND (xmusen >= xing + INT((wide - 16) / 2)) AND (xmusen <= xing + INT((wide - 16) / 2) + 3) THEN COLOR 7, 0: overok = 1 ELSE COLOR 0, 7: overok = 0
        IF it = hehe THEN LOCATE ying + it, xing + INT((wide - 16) / 2): PRINT "<OK>"
        IF ying + it = ymusen AND xmusen >= xing + INT((wide - 16) / 2) + 8 AND xmusen <= xing + INT((wide - 16) / 2) + 15 THEN COLOR 7, 0: overcancel = 1 ELSE COLOR 0, 7: overcancel = 0
        IF it = hehe THEN LOCATE ying + it, xing + INT((wide - 16) / 2) + 8: PRINT "<Cancel>"
        COLOR 0, 7
    NEXT
    LOCATE ying + hehe - 1, xing: PRINT STRING$(wide, 196)
    'here is where the OK CANCEL should be but is put in the FOR...NEXT loop above instead...
    LOCATE ying + hehe + 1, xing - 1: PRINT CHR$(192) + STRING$(wide, 196) + CHR$(217)
    IF usefont = 0 THEN LOCATE ying + 1, xing: PRINT "[ ] Use custom font"
    IF usefont = 1 THEN LOCATE ying + 1, xing: PRINT "[X] Use custom font"
    'textbox
    LOCATE ying + texby - 1, xing: PRINT "Font filename:"
    LOCATE ying + texby, xing: PRINT CHR$(218) + STRING$((wide - 2) - texbdec, 196) + CHR$(191)
    LOCATE ying + texby + 1, xing: PRINT CHR$(179)
    IF focus = 0 THEN textch$ = inputted$ + "_" ELSE textch$ = inputted$
    LOCATE ying + texby + 1, xing + 1: PRINT MID$(textch$, 1 + ((ABS(LEN(textch$) > ((wide - 2) - texbdec))) * (LEN(textch$) - ((wide - 2) - texbdec))), (wide - 2) - texbdec)
    LOCATE ying + texby + 1, (xing + wide - 1) - texbdec: PRINT CHR$(179)
    LOCATE ying + texby + 2, xing: PRINT CHR$(192) + STRING$((wide - 2) - texbdec, 196) + CHR$(217)
    'textbox2
    LOCATE ying + texby + 3, xing: PRINT "Row Height:"
    LOCATE ying + texby + 4, xing: PRINT CHR$(218) + STRING$((wide - 2) - texbdec, 196) + CHR$(191)
    LOCATE ying + texby + 5, xing: PRINT CHR$(179)
    IF focus = 1 THEN textch2$ = inputted2$ + "_" ELSE textch2$ = inputted2$
    LOCATE ying + texby + 5, xing + 1: PRINT MID$(textch2$, 1 + ((ABS(LEN(textch2$) > ((wide - 2) - texbdec))) * (LEN(textch2$) - ((wide - 2) - texbdec))), (wide - 2) - texbdec)
    LOCATE ying + texby + 5, (xing + wide - 1) - texbdec: PRINT CHR$(179)
    LOCATE ying + texby + 6, xing: PRINT CHR$(192) + STRING$((wide - 2) - texbdec, 196) + CHR$(217)

    IF ymusen = ying + texby + 1 AND bmusen = -1 AND xmusen < xing + 1 + ((wide - 1) - texbdec) THEN focus = 0
    IF ymusen = ying + texby + 5 AND bmusen = -1 THEN focus = 1

    IF ymusen = ying + texby + 1 AND xmusen >= xing + 1 + ((wide - 1) - texbdec) AND xmusen <= xing + 1 + ((wide - 1) - texbdec) + 5 THEN overpathfind = 1 ELSE overpathfind = 0
    IF overpathfind = 0 THEN LOCATE ying + texby + 1, xing + 1 + ((wide - 1) - texbdec): PRINT "[...]"
    IF overpathfind = 1 THEN COLOR 7, 0: LOCATE ying + texby + 1, xing + 1 + ((wide - 1) - texbdec): PRINT "[...]": COLOR 0, 7

    'keyboard input
    kbd$ = INKEY$
    SELECT CASE kbd$
        CASE CHR$(8)
            IF focus = 0 THEN IF inputted$ <> "" THEN inputted$ = MID$(inputted$, 1, LEN(inputted$) - 1)
            IF focus = 1 THEN IF inputted2$ <> "" THEN inputted2$ = MID$(inputted2$, 1, LEN(inputted2$) - 1)
        CASE CHR$(13): setfont$ = inputted$: fontheight = VAL(inputted2$): EXIT FUNCTION
        CASE CHR$(27): setfont$ = "": usefont = -1: EXIT FUNCTION
        CASE CHR$(9): IF focus = 0 THEN focus = 1 ELSE focus = 0
        CASE CHR$(0) + "K": usefont = 0
        CASE CHR$(0) + "M": usefont = 1
        CASE ""
        CASE ELSE
            IF focus = 0 THEN IF ASC(kbd$) > 31 THEN inputted$ = inputted$ + kbd$
            IF focus = 1 THEN IF (ASC(kbd$) = 32) OR (ASC(kbd$) > 47 AND ASC(kbd$) < 58) THEN inputted2$ = inputted2$ + kbd$
    END SELECT

    'mouse input
    DO WHILE _MOUSEINPUT
        ymusen = CINT(_MOUSEY)
        xmusen = CINT(_MOUSEX)
        bmusen = _MOUSEBUTTON(1)
    LOOP
    IF ymusen = ying + 1 AND xmusen = xing + 1 AND bmusen = -1 THEN waitforuse = 1
    IF ymusen <> ying + 1 OR xmusen <> xing + 1 THEN waitforuse = 0
    IF ymusen = ying + 1 AND xmusen = xing + 1 AND waitforuse = 1 AND bmusen = 0 THEN IF usefont = 0 THEN usefont = 1: waitforuse = 0 ELSE usefont = 0: waitforuse = 0

    IF overok = 1 AND bmusen = 0 THEN waitforok = 1
    IF overok = 1 AND bmusen = -1 AND waitforok = 1 THEN setfont$ = inputted$: fontheight = VAL(inputted2$): EXIT FUNCTION
    IF overok = 0 AND bmusen = 0 THEN waitforok = 0
    IF overcancel = 1 AND bmusen = 0 THEN waitforcancel = 1
    IF overcancel = 1 AND bmusen = -1 AND waitforcancel = 1 THEN setfont$ = "": usefont = -1: EXIT FUNCTION
    IF overcancel = 0 AND bmusen = 0 THEN waitforcancel = 0
    IF overpathfind = 1 AND bmusen = 0 THEN waitforpathfind = 1
    IF overpathfind = 1 AND bmusen = -1 AND waitforpathfind = 1 THEN

        temp$ = ""
        kl = 0
        IF _WIDTH > 60 AND _HEIGHT > 18 THEN
            FOR klx = 19 TO 60
                FOR kly = 6 TO 18
                    kl = kl + 1
                    scrarray(kl) = SCREEN(kly, klx)
                NEXT
            NEXT
        END IF
        temp$ = openfile$("Locate Font", "*.ttf", ENVIRON$("windir") + "\fonts\")
        IF temp$ <> "" THEN
            inputted$ = temp$
        END IF
        temp$ = ""
        overpathfind = 0
        waitforpathfind = 0
        xmusen = 0
        bmusen = 0
        ymusen = 0
        kl = 0
        IF _WIDTH > 60 AND _HEIGHT > 18 THEN
            FOR klx = 19 TO 60
                FOR kly = 6 TO 18
                    IF kly >= 6 AND kly <= 8 THEN COLOR 0, 7 ELSE COLOR fgcsetting, bgcsetting
                    kl = kl + 1
                    LOCATE kly, klx: PRINT CHR$(scrarray(kl))
                NEXT
            NEXT
        END IF
    END IF

    IF overpathfind = 0 AND bmusen = 0 THEN waitforpathfind = 0
    _LIMIT 60
    IF _FULLSCREEN THEN

        IF xmusen > 0 AND ymusen > 0 AND xmusen <= _WIDTH AND ymusen <= _HEIGHT THEN
            LOCATE ymusen, xmusen, 1, 1, 8
        END IF
    END IF

    _DISPLAY
    'IF _WIDTH = 80 AND _HEIGHT = 25 THEN PCOPY 1, 0 ELSE PCOPY 0, 1



LOOP
END FUNCTION





FUNCTION setformatting
xing = 20
ying = 5
wide = 30
hehe = 7

IF ying + 1 + hehe > _HEIGHT THEN ying = 2
IF xing + 1 + wide > _WIDTH THEN xing = 2

IF ying + 1 + hehe > _HEIGHT THEN SOUND 500, .1: EXIT FUNCTION
IF xing + 1 + wide > _WIDTH THEN SOUND 500, .1: EXIT FUNCTION


texbx = 2
texby = 3
texbdec = 6
DO
    exittype = _EXIT
    IF exittype = 1 OR exittype = 3 THEN
        IF edited = 0 THEN
            SYSTEM
        ELSE
            retcode = msgbox("Are you sure?", "Code has been changed since the latest save, are you sure you want to quit?", 1, 22, 6)
            IF retcode = 1 THEN
                SYSTEM
            END IF
        END IF
    END IF

    'titlebar
    COLOR 7, 0
    LOCATE ying - 1, xing - 1: PRINT SPACE$(wide + 2)
    LOCATE ying - 1, (xing - 1) + INT(((wide + 2) - LEN("Set Formatting")) / 2): PRINT "Set Formatting"

    'frame
    COLOR 0, 7
    LOCATE ying, xing - 1: PRINT CHR$(218) + STRING$(wide, 196) + CHR$(191)

    FOR it = 1 TO hehe
        LOCATE ying + it, xing - 1: PRINT CHR$(179)
        LOCATE ying + it, xing: PRINT SPACE$(wide)
        LOCATE ying + it, xing + wide: PRINT CHR$(179)
        IF it = hehe - 1 THEN LOCATE ying + it, xing - 1: PRINT CHR$(195)
        IF it = hehe - 1 THEN LOCATE ying + it, xing + wide: PRINT CHR$(180)
        IF (ying + it = ymusen) AND (xmusen >= xing + INT((wide - 16) / 2)) AND (xmusen <= xing + INT((wide - 16) / 2) + 3) THEN COLOR 7, 0: overok = 1 ELSE COLOR 0, 7: overok = 0
        IF it = hehe THEN LOCATE ying + it, xing + INT((wide - 16) / 2): PRINT "<OK>"
        IF ying + it = ymusen AND xmusen >= xing + INT((wide - 16) / 2) + 8 AND xmusen <= xing + INT((wide - 16) / 2) + 15 THEN COLOR 7, 0: overcancel = 1 ELSE COLOR 0, 7: overcancel = 0
        IF it = hehe THEN LOCATE ying + it, xing + INT((wide - 16) / 2) + 8: PRINT "<Cancel>"
        COLOR 0, 7
    NEXT
    LOCATE ying + hehe - 1, xing: PRINT STRING$(wide, 196)
    'here is where the OK CANCEL should be but is put in the FOR...NEXT loop above instead...
    LOCATE ying + hehe + 1, xing - 1: PRINT CHR$(192) + STRING$(wide, 196) + CHR$(217)

    LOCATE ying + texby - 1, xing: PRINT "Formatting:"
    IF formatset = 1 THEN
        LOCATE ying + texby, xing: PRINT "(*) ON"
        LOCATE ying + texby + 1, xing: PRINT "( ) OFF"
    END IF
    IF formatset = 0 THEN
        LOCATE ying + texby, xing: PRINT "( ) ON"
        LOCATE ying + texby + 1, xing: PRINT "(*) OFF"
    END IF



    'keyboard input
    kbd$ = INKEY$
    SELECT CASE kbd$
        CASE CHR$(0) + "H": formatset = 1
        CASE CHR$(0) + "P": formatset = 0
        CASE CHR$(13): setformatting = formatset: EXIT FUNCTION
        CASE CHR$(27): setformatting = -1: EXIT FUNCTION
    END SELECT
    DO WHILE _MOUSEINPUT
        ymusen = CINT(_MOUSEY)
        xmusen = CINT(_MOUSEX)
        bmusen = _MOUSEBUTTON(1)
    LOOP
    IF overok = 1 AND bmusen = 0 THEN waitforok = 1
    IF overok = 1 AND bmusen = -1 AND waitforok = 1 THEN setformatting = formatset: EXIT FUNCTION
    IF overok = 0 AND bmusen = 0 THEN waitforok = 0
    IF overcancel = 1 AND bmusen = 0 THEN waitforcancel = 1
    IF overcancel = 1 AND bmusen = -1 AND waitforcancel = 1 THEN setformatting = -1: EXIT FUNCTION
    IF overcancel = 0 AND bmusen = 0 THEN waitforcancel = 0
    IF ymusen = ying + texby AND bmusen = -1 THEN formatset = 1
    IF ymusen = ying + texby + 1 AND bmusen = -1 THEN formatset = 0
    IF _FULLSCREEN THEN

        IF xmusen > 0 AND ymusen > 0 AND xmusen <= _WIDTH AND ymusen <= _HEIGHT THEN
            LOCATE ymusen, xmusen, 1, 1, 8
        END IF
    END IF

    _DISPLAY

LOOP





END FUNCTION



FUNCTION setpaths$
'init
DIM scrarray(20 * 70)
xing = 20
ying = 5
wide = 30
hehe = 7
texbx = 2
texby = 3
texbdec = 6

IF ying + 1 + hehe > _HEIGHT THEN ying = 2
IF xing + 1 + wide > _WIDTH THEN xing = 2

IF ying + 1 + hehe > _HEIGHT THEN SOUND 500, .1: EXIT FUNCTION
IF xing + 1 + wide > _WIDTH THEN SOUND 500, .1: EXIT FUNCTION


DO
    exittype = _EXIT
    IF exittype = 1 OR exittype = 3 THEN
        IF edited = 0 THEN
            SYSTEM
        ELSE
            retcode = msgbox("Are you sure?", "Code has been changed since the latest save, are you sure you want to quit?", 1, 22, 6)
            IF retcode = 1 THEN
                SYSTEM
            END IF
        END IF
    END IF

    'titlebar
    COLOR 7, 0
    LOCATE ying - 1, xing - 1: PRINT SPACE$(wide + 2)
    LOCATE ying - 1, (xing - 1) + INT(((wide + 2) - LEN("Set Paths")) / 2): PRINT "Set Paths"

    'frame
    COLOR 0, 7
    LOCATE ying, xing - 1: PRINT CHR$(218) + STRING$(wide, 196) + CHR$(191)

    FOR it = 1 TO hehe
        LOCATE ying + it, xing - 1: PRINT CHR$(179)
        LOCATE ying + it, xing: PRINT SPACE$(wide)
        LOCATE ying + it, xing + wide: PRINT CHR$(179)
        IF it = hehe - 1 THEN LOCATE ying + it, xing - 1: PRINT CHR$(195)
        IF it = hehe - 1 THEN LOCATE ying + it, xing + wide: PRINT CHR$(180)
        IF (ying + it = ymusen) AND (xmusen >= xing + INT((wide - 16) / 2)) AND (xmusen <= xing + INT((wide - 16) / 2) + 3) THEN COLOR 7, 0: overok = 1 ELSE COLOR 0, 7: overok = 0
        IF it = hehe THEN LOCATE ying + it, xing + INT((wide - 16) / 2): PRINT "<OK>"
        IF ying + it = ymusen AND xmusen >= xing + INT((wide - 16) / 2) + 8 AND xmusen <= xing + INT((wide - 16) / 2) + 15 THEN COLOR 7, 0: overcancel = 1 ELSE COLOR 0, 7: overcancel = 0
        IF it = hehe THEN LOCATE ying + it, xing + INT((wide - 16) / 2) + 8: PRINT "<Cancel>"
        COLOR 0, 7
    NEXT
    LOCATE ying + hehe - 1, xing: PRINT STRING$(wide, 196)
    'here is where the OK CANCEL should be but is put in the FOR...NEXT loop above instead...
    LOCATE ying + hehe + 1, xing - 1: PRINT CHR$(192) + STRING$(wide, 196) + CHR$(217)


    'textbox
    LOCATE ying + texby - 1, xing: PRINT "Path to QB64.EXE:"
    LOCATE ying + texby, xing: PRINT CHR$(218) + STRING$((wide - 2) - texbdec, 196) + CHR$(191)
    LOCATE ying + texby + 1, xing: PRINT CHR$(179)
    textch$ = inputted$ + "_"
    LOCATE ying + texby + 1, xing + 1: PRINT MID$(textch$, 1 + ((ABS(LEN(textch$) > ((wide - 2) - texbdec))) * (LEN(textch$) - ((wide - 2) - texbdec))), (wide - 2) - texbdec)
    LOCATE ying + texby + 1, (xing + wide - 1) - texbdec: PRINT CHR$(179)
    LOCATE ying + texby + 2, xing: PRINT CHR$(192) + STRING$((wide - 2) - texbdec, 196) + CHR$(217)
    IF ymusen = ying + texby + 1 AND xmusen >= xing + 1 + ((wide - 1) - texbdec) AND xmusen <= xing + 1 + ((wide - 1) - texbdec) + 5 THEN overpathfind = 1 ELSE overpathfind = 0
    IF overpathfind = 0 THEN LOCATE ying + texby + 1, xing + 1 + ((wide - 1) - texbdec): PRINT "[...]"
    IF overpathfind = 1 THEN COLOR 7, 0: LOCATE ying + texby + 1, xing + 1 + ((wide - 1) - texbdec): PRINT "[...]": COLOR 0, 7

    'keyboard input
    kbd$ = INKEY$
    SELECT CASE kbd$
        CASE CHR$(8)
            IF inputted$ <> "" THEN inputted$ = MID$(inputted$, 1, LEN(inputted$) - 1)
        CASE CHR$(13): setpaths$ = inputted$: EXIT FUNCTION
        CASE CHR$(27): setpaths$ = "": EXIT FUNCTION
        CASE ""
        CASE ELSE
            IF ASC(kbd$) > 31 THEN inputted$ = inputted$ + kbd$
    END SELECT

    'mouse input
    DO WHILE _MOUSEINPUT
        ymusen = CINT(_MOUSEY)
        xmusen = CINT(_MOUSEX)
        bmusen = _MOUSEBUTTON(1)
    LOOP
    IF overok = 1 AND bmusen = 0 THEN waitforok = 1
    IF overok = 1 AND bmusen = -1 AND waitforok = 1 THEN setpaths$ = inputted$: EXIT FUNCTION
    IF overok = 0 AND bmusen = 0 THEN waitforok = 0
    IF overcancel = 1 AND bmusen = 0 THEN waitforcancel = 1
    IF overcancel = 1 AND bmusen = -1 AND waitforcancel = 1 THEN setpaths$ = "": EXIT FUNCTION
    IF overcancel = 0 AND bmusen = 0 THEN waitforcancel = 0
    IF overpathfind = 1 AND bmusen = 0 THEN waitforpathfind = 1
    IF overpathfind = 1 AND bmusen = -1 AND waitforpathfind = 1 THEN
        temp$ = ""
        kl = 0
        IF _WIDTH > 60 AND _HEIGHT > 18 THEN
            FOR klx = 19 TO 60
                FOR kly = 6 TO 18
                    kl = kl + 1
                    scrarray(kl) = SCREEN(kly, klx)
                NEXT
            NEXT
        END IF
        temp$ = openfile$("Locate QB64.EXE", "*.exe", "")
        IF temp$ <> "" THEN
            okidiko = LEN(temp$)
            DO
                IF MID$(temp$, okidiko, 1) = "\" THEN temp$ = MID$(temp$, 1, okidiko): EXIT DO
                okidiko = okidiko - 1: IF okidiko <= 1 THEN EXIT DO
            LOOP
            inputted$ = temp$
        END IF
        temp$ = ""
        overpathfind = 0
        waitforpathfind = 0
        xmusen = 0
        bmusen = 0
        ymusen = 0
        kl = 0
        IF _WIDTH > 60 AND _HEIGHT > 18 THEN
            FOR klx = 19 TO 60
                FOR kly = 6 TO 18
                    IF kly >= 6 AND kly <= 8 THEN COLOR 0, 7 ELSE COLOR fgcsetting, bgcsetting
                    kl = kl + 1
                    LOCATE kly, klx: PRINT CHR$(scrarray(kl))
                NEXT
            NEXT
        END IF
    END IF

    IF overpathfind = 0 AND bmusen = 0 THEN waitforpathfind = 0
    _LIMIT 60
    IF _FULLSCREEN THEN

        IF xmusen > 0 AND ymusen > 0 AND xmusen <= _WIDTH AND ymusen <= _HEIGHT THEN
            LOCATE ymusen, xmusen, 1, 1, 8
        END IF
    END IF

    _DISPLAY
    'IF _WIDTH = 80 AND _HEIGHT = 25 THEN PCOPY 1, 0 ELSE PCOPY 0, 1


LOOP
END FUNCTION

FUNCTION changename$ (casesensitive, curallmod, verify, changeto$)
xing = 20
ying = 5
wide = 30
hehe = 17

IF ying + 1 + hehe > _HEIGHT THEN ying = 2
IF xing + 1 + wide > _WIDTH THEN xing = 2

IF ying + 1 + hehe > _HEIGHT THEN SOUND 500, .1: EXIT FUNCTION
IF xing + 1 + wide > _WIDTH THEN SOUND 500, .1: EXIT FUNCTION


DO
    exittype = _EXIT
    IF exittype = 1 OR exittype = 3 THEN
        IF edited = 0 THEN
            SYSTEM
        ELSE
            retcode = msgbox("Are you sure?", "Code has been changed since the latest save, are you sure you want to quit?", 1, 22, 6)
            IF retcode = 1 THEN
                SYSTEM
            END IF
        END IF
    END IF

    COLOR 7, 0
    LOCATE ying - 1, xing - 1: PRINT SPACE$(wide + 2)
    LOCATE ying - 1, (xing - 1) + INT(((wide + 2) - LEN("Change")) / 2): PRINT "Change"
    COLOR 0, 7
    'top frame
    LOCATE ying, xing - 1: PRINT CHR$(218) + STRING$(wide, 196) + CHR$(191)

    FOR it = 1 TO hehe
        LOCATE ying + it, xing - 1: PRINT CHR$(179)
        LOCATE ying + it, xing: PRINT SPACE$(wide)
        LOCATE ying + it, xing + wide: PRINT CHR$(179)
        IF it = hehe - 1 THEN LOCATE ying + it, xing - 1: PRINT CHR$(195)
        IF it = hehe - 1 THEN LOCATE ying + it, xing + wide: PRINT CHR$(180)
        IF (ying + it = ymusen) AND (xmusen >= xing + INT((wide - 16) / 2)) AND (xmusen <= xing + INT((wide - 16) / 2) + 3) THEN COLOR 7, 0: overok = 1 ELSE COLOR 0, 7: overok = 0
        IF it = hehe THEN LOCATE ying + it, xing + INT((wide - 16) / 2): PRINT "<OK>"
        IF ying + it = ymusen AND xmusen >= xing + INT((wide - 16) / 2) + 8 AND xmusen <= xing + INT((wide - 16) / 2) + 15 THEN COLOR 7, 0: overcancel = 1 ELSE COLOR 0, 7: overcancel = 0
        IF it = hehe THEN LOCATE ying + it, xing + INT((wide - 16) / 2) + 8: PRINT "<Cancel>"
        COLOR 0, 7
    NEXT
    LOCATE ying + hehe - 1, xing: PRINT STRING$(wide, 196)
    'textbox
    LOCATE ying + 1, (xing - 1) + INT(((wide + 2) - LEN("Change what?")) / 2): PRINT "Change what?"
    LOCATE ying + 2, xing: PRINT CHR$(218) + STRING$(wide - 2, 196) + CHR$(191)
    LOCATE ying + 3, xing: PRINT CHR$(179)
    IF focus = 0 THEN textch$ = inputted$ + "_" ELSE textch$ = inputted$
    LOCATE ying + 3, xing + 1: PRINT MID$(textch$, 1 + ((ABS(LEN(textch$) > (wide - 2))) * (LEN(textch$) - (wide - 2))), wide - 2)
    LOCATE ying + 3, xing + wide - 1: PRINT CHR$(179)
    LOCATE ying + 4, xing: PRINT CHR$(192) + STRING$(wide - 2, 196) + CHR$(217)
    'choice
    LOCATE ying + 5, xing: PRINT "( ) Current Module"
    LOCATE ying + 6, xing: PRINT "( ) All Modules"
    IF curallmod = 0 THEN LOCATE ying + 5, xing + 1: PRINT CHR$(254)
    IF curallmod = 1 THEN LOCATE ying + 6, xing + 1: PRINT CHR$(254)
    'X
    LOCATE ying + 8, xing: PRINT "[ ] Match Upper/Lower Case"
    IF casesensitive = 1 THEN LOCATE ying + 8, xing + 1: PRINT "X"
    'change to...
    LOCATE ying + 9, xing - 1: PRINT CHR$(195) + STRING$(wide, 196) + CHR$(180) 'upper frame
    LOCATE ying + 10, (xing - 1) + INT(((wide + 2) - LEN("Change to:")) / 2): PRINT "Change to:"
    'textbox2
    LOCATE ying + 11, xing: PRINT CHR$(218) + STRING$(wide - 2, 196) + CHR$(191)
    LOCATE ying + 12, xing: PRINT CHR$(179)
    IF focus = 1 THEN textch2$ = inputted2$ + "_" ELSE textch2$ = inputted2$
    LOCATE ying + 12, xing + 1: PRINT MID$(textch2$, 1 + ((ABS(LEN(textch2$) > (wide - 2))) * (LEN(textch2$) - (wide - 2))), wide - 2)
    LOCATE ying + 12, xing + wide - 1: PRINT CHR$(179)
    LOCATE ying + 13, xing: PRINT CHR$(192) + STRING$(wide - 2, 196) + CHR$(217)
    LOCATE ying + 15, xing: PRINT "[ ] Verify Each Find"
    IF verify = 1 THEN LOCATE ying + 15, xing + 1: PRINT "X"
    'lower frame
    LOCATE ying + hehe + 1, xing - 1: PRINT CHR$(192) + STRING$(wide, 196) + CHR$(217)
    _LIMIT 60
    IF _FULLSCREEN THEN

        IF xmusen > 0 AND ymusen > 0 AND xmusen <= _WIDTH AND ymusen <= _HEIGHT THEN
            LOCATE ymusen, xmusen, 1, 1, 8
        END IF
    END IF

    _DISPLAY
    'IF _WIDTH = 80 AND _HEIGHT = 25 THEN PCOPY 1, 0 ELSE PCOPY 0, 1

    kbd$ = INKEY$
    SELECT CASE kbd$
        CASE CHR$(0) + "H": IF focus = 0 THEN curallmod = 0
        CASE CHR$(0) + "P": IF focus = 0 THEN curallmod = 1
        CASE CHR$(0) + "K": IF focus = 0 THEN casesensitive = 0 ELSE verify = 0
        CASE CHR$(0) + "M": IF focus = 0 THEN casesensitive = 1 ELSE verify = 1
        CASE CHR$(8)
            IF focus = 0 THEN
                IF inputted$ <> "" THEN inputted$ = MID$(inputted$, 1, LEN(inputted$) - 1)
            END IF
            IF focus = 1 THEN
                IF inputted2$ <> "" THEN inputted2$ = MID$(inputted2$, 1, LEN(inputted2$) - 1)
            END IF
        CASE CHR$(9): IF focus = 0 THEN focus = 1 ELSE focus = 0
        CASE CHR$(13): changeto$ = inputted2$: changename$ = inputted$: EXIT FUNCTION
        CASE CHR$(27): changeto$ = "": changename$ = "": EXIT FUNCTION
        CASE ""
        CASE ELSE
            IF ASC(kbd$) > 31 AND focus = 0 THEN inputted$ = inputted$ + kbd$
            IF ASC(kbd$) > 31 AND focus = 1 THEN inputted2$ = inputted2$ + kbd$
    END SELECT

    DO WHILE _MOUSEINPUT
        ymusen = CINT(_MOUSEY)
        xmusen = CINT(_MOUSEX)
        bmusen = _MOUSEBUTTON(1)
    LOOP

    IF ymusen = ying + 5 AND xmusen = xing + 1 AND bmusen = -1 THEN curallmod = 0: focus = 0
    IF ymusen = ying + 6 AND xmusen = xing + 1 AND bmusen = -1 THEN curallmod = 1: focus = 0
    IF ymusen = ying + 8 AND xmusen = xing + 1 AND bmusen = -1 THEN waitforcase = 1
    IF ymusen = ying + 8 AND xmusen = xing + 1 AND bmusen = 0 AND waitforcase = 1 THEN
        IF casesensitive = 1 THEN casesensitive = 0 ELSE casesensitive = 1
        focus = 0
        waitforcase = 0
    END IF
    IF ymusen <> ying + 8 OR xmusen <> xing + 1 AND bmusen = 0 THEN waitforcase = 0

    IF ymusen = ying + 3 AND bmusen = -1 THEN focus = 0
    IF ymusen = ying + 12 AND bmusen = -1 THEN focus = 1

    IF ymusen = ying + 15 AND xmusen = xing + 1 AND bmusen = -1 THEN waitforveri = 1
    IF ymusen = ying + 15 AND xmusen = xing + 1 AND bmusen = 0 AND waitforveri = 1 THEN
        IF verify = 1 THEN verify = 0 ELSE verify = 1
        focus = 1
        waitforveri = 0
    END IF
    IF ymusen <> ying + 15 OR xmusen <> xing + 1 AND bmusen = 0 THEN waitforveri = 0

    IF overok = 1 AND bmusen = 0 THEN waitforok = 1
    IF overok = 1 AND bmusen = -1 AND waitforok = 1 THEN changeto$ = inputted2$: changename$ = inputted$: EXIT FUNCTION
    IF overok = 0 AND bmusen = 0 THEN waitforok = 0
    IF overcancel = 1 AND bmusen = 0 THEN waitforcancel = 1
    IF overcancel = 1 AND bmusen = -1 AND waitforcancel = 1 THEN changeto$ = "": changename$ = "": EXIT FUNCTION
    IF overcancel = 0 AND bmusen = 0 THEN waitforcancel = 0
LOOP

END FUNCTION

FUNCTION searchname$ (casesensitive, curallmod)

xing = 20
ying = 7
wide = 30
hehe = 10

IF ying + 1 + hehe > _HEIGHT THEN ying = 2
IF xing + 1 + wide > _WIDTH THEN xing = 2

IF ying + 1 + hehe > _HEIGHT THEN SOUND 500, .1: EXIT FUNCTION
IF xing + 1 + wide > _WIDTH THEN SOUND 500, .1: EXIT FUNCTION


DO
    exittype = _EXIT
    IF exittype = 1 OR exittype = 3 THEN
        IF edited = 0 THEN
            SYSTEM
        ELSE
            retcode = msgbox("Are you sure?", "Code has been changed since the latest save, are you sure you want to quit?", 1, 22, 6)
            IF retcode = 1 THEN
                SYSTEM
            END IF
        END IF
    END IF

    COLOR 7, 0
    LOCATE ying - 1, xing - 1: PRINT SPACE$(wide + 2)
    LOCATE ying - 1, (xing - 1) + INT(((wide + 2) - LEN("Find")) / 2): PRINT "Find"
    COLOR 0, 7
    'top frame
    LOCATE ying, xing - 1: PRINT CHR$(218) + STRING$(wide, 196) + CHR$(191)

    FOR it = 1 TO hehe
        LOCATE ying + it, xing - 1: PRINT CHR$(179)
        LOCATE ying + it, xing: PRINT SPACE$(wide)
        LOCATE ying + it, xing + wide: PRINT CHR$(179)
        IF it = hehe - 1 THEN LOCATE ying + it, xing - 1: PRINT CHR$(195)
        IF it = hehe - 1 THEN LOCATE ying + it, xing + wide: PRINT CHR$(180)
        IF (ying + it = ymusen) AND (xmusen >= xing + INT((wide - 16) / 2)) AND (xmusen <= xing + INT((wide - 16) / 2) + 3) THEN COLOR 7, 0: overok = 1 ELSE COLOR 0, 7: overok = 0
        IF it = hehe THEN LOCATE ying + it, xing + INT((wide - 16) / 2): PRINT "<OK>"
        IF ying + it = ymusen AND xmusen >= xing + INT((wide - 16) / 2) + 8 AND xmusen <= xing + INT((wide - 16) / 2) + 15 THEN COLOR 7, 0: overcancel = 1 ELSE COLOR 0, 7: overcancel = 0
        IF it = hehe THEN LOCATE ying + it, xing + INT((wide - 16) / 2) + 8: PRINT "<Cancel>"
        COLOR 0, 7
    NEXT
    LOCATE ying + hehe - 1, xing: PRINT STRING$(wide, 196)
    'textbox
    LOCATE ying + 1, (xing - 1) + INT(((wide + 2) - LEN("Find what?")) / 2): PRINT "Find what?"
    LOCATE ying + 2, xing: PRINT CHR$(218) + STRING$(wide - 2, 196) + CHR$(191)
    LOCATE ying + 3, xing: PRINT CHR$(179)
    textch$ = inputted$ + "_"
    LOCATE ying + 3, xing + 1: PRINT MID$(textch$, 1 + ((ABS(LEN(textch$) > (wide - 2))) * (LEN(textch$) - (wide - 2))), wide - 2)
    LOCATE ying + 3, xing + wide - 1: PRINT CHR$(179)
    LOCATE ying + 4, xing: PRINT CHR$(192) + STRING$(wide - 2, 196) + CHR$(217)
    'choice
    LOCATE ying + 5, xing: PRINT "( ) Current module"
    LOCATE ying + 6, xing: PRINT "( ) All modules"
    IF curallmod = 0 THEN LOCATE ying + 5, xing + 1: PRINT CHR$(254)
    IF curallmod = 1 THEN LOCATE ying + 6, xing + 1: PRINT CHR$(254)
    'X
    LOCATE ying + 8, xing: PRINT "[ ] Match Upper/Lower Case"
    IF casesensitive = 1 THEN LOCATE ying + 8, xing + 1: PRINT "X"
    'lower frame
    LOCATE ying + hehe + 1, xing - 1: PRINT CHR$(192) + STRING$(wide, 196) + CHR$(217)
    _LIMIT 60
    IF _FULLSCREEN THEN

        IF xmusen > 0 AND ymusen > 0 AND xmusen <= _WIDTH AND ymusen <= _HEIGHT THEN
            LOCATE ymusen, xmusen, 1, 1, 8
        END IF
    END IF

    _DISPLAY
    'IF _WIDTH = 80 AND _HEIGHT = 25 THEN PCOPY 1, 0 ELSE PCOPY 0, 1

    kbd$ = INKEY$
    SELECT CASE kbd$
        CASE CHR$(0) + "H": curallmod = 0
        CASE CHR$(0) + "P": curallmod = 1
        CASE CHR$(0) + "K": casesensitive = 0
        CASE CHR$(0) + "M": casesensitive = 1
        CASE CHR$(8): IF inputted$ <> "" THEN inputted$ = MID$(inputted$, 1, LEN(inputted$) - 1)
        CASE CHR$(13): searchname$ = inputted$: EXIT FUNCTION
        CASE CHR$(27): searchname$ = "": EXIT FUNCTION
        CASE ""
        CASE ELSE
            IF ASC(kbd$) > 31 THEN inputted$ = inputted$ + kbd$
    END SELECT

    DO WHILE _MOUSEINPUT
        ymusen = CINT(_MOUSEY)
        xmusen = CINT(_MOUSEX)
        bmusen = _MOUSEBUTTON(1)
    LOOP

    IF ymusen = ying + 5 AND xmusen = xing + 1 AND bmusen = -1 THEN curallmod = 0
    IF ymusen = ying + 6 AND xmusen = xing + 1 AND bmusen = -1 THEN curallmod = 1
    IF ymusen = ying + 8 AND xmusen = xing + 1 AND bmusen = -1 THEN waitforcase = 1
    IF ymusen = ying + 8 AND xmusen = xing + 1 AND bmusen = 0 AND waitforcase = 1 THEN
        IF casesensitive = 1 THEN casesensitive = 0 ELSE casesensitive = 1
        waitforcase = 0
    END IF
    IF ymusen <> ying + 8 OR xmusen <> xing + 1 AND bmusen = 0 THEN waitforcase = 0
    IF overok = 1 AND bmusen = 0 THEN waitforok = 1
    IF overok = 1 AND bmusen = -1 AND waitforok = 1 THEN searchname$ = inputted$: EXIT FUNCTION
    IF overok = 0 AND bmusen = 0 THEN waitforok = 0
    IF overcancel = 1 AND bmusen = 0 THEN waitforcancel = 1
    IF overcancel = 1 AND bmusen = -1 AND waitforcancel = 1 THEN searchname$ = "": EXIT FUNCTION
    IF overcancel = 0 AND bmusen = 0 THEN waitforcancel = 0
LOOP

END FUNCTION


FUNCTION viewsubs

DIM textlist(255) AS STRING
DIM subpos(255) AS INTEGER
numlist = 1
textlist(numlist) = "Main"
subpos(numlist) = -1
FOR posi = 0 TO highest + 5
    IF UCASE$(MID$(LTRIM$(codetext(posi)), 1, 4)) = "SUB " THEN
        numlist = numlist + 1
        textlist(numlist) = codetext(posi)
        subpos(numlist) = posi
    END IF
NEXT

FOR posi = 0 TO highest + 5
    IF UCASE$(MID$(LTRIM$(codetext(posi)), 1, 9)) = "FUNCTION " THEN
        numlist = numlist + 1
        textlist(numlist) = codetext(posi)
        subpos(numlist) = posi
    END IF
NEXT

xing = 4
ying = 4
wide = 74
hehe = 16

IF ying + 1 + hehe > _HEIGHT THEN ying = 2
IF xing + 1 + wide > _WIDTH THEN xing = 2

IF ying + 1 + hehe > _HEIGHT THEN hehe = 8
IF xing + 1 + wide > _WIDTH THEN wide = 49

IF ying + 1 + hehe > _HEIGHT THEN SOUND 500, .1: EXIT FUNCTION
IF xing + 1 + wide > _WIDTH THEN SOUND 500, .1: EXIT FUNCTION


DO
    exittype = _EXIT
    IF exittype = 1 OR exittype = 3 THEN
        IF edited = 0 THEN
            SYSTEM
        ELSE
            retcode = msgbox("Are you sure?", "Code has been changed since the latest save, are you sure you want to quit?", 1, 22, 6)
            IF retcode = 1 THEN
                SYSTEM
            END IF
        END IF
    END IF

    COLOR 7, 0
    LOCATE ying - 1, xing - 1: PRINT SPACE$(wide + 2)
    LOCATE ying - 1, (xing - 1) + INT(((wide + 2) - LEN("Subs and Functions")) / 2): PRINT "Subs and Functions"
    COLOR 0, 7
    LOCATE ying, xing - 1: PRINT CHR$(218) + STRING$(wide, 196) + CHR$(191)

    FOR it = 1 TO hehe
        LOCATE ying + it, xing - 1: PRINT CHR$(179)
        LOCATE ying + it, xing: PRINT SPACE$(wide)
        LOCATE ying + it, xing + wide: PRINT CHR$(179)
        IF it = hehe - 1 THEN LOCATE ying + it, xing - 1: PRINT CHR$(195)
        IF it = hehe - 1 THEN LOCATE ying + it, xing + wide: PRINT CHR$(180)
        IF (ying + it = ymusen) AND (xmusen >= xing + INT((wide - 16) / 2)) AND (xmusen <= xing + INT((wide - 16) / 2) + 3) THEN COLOR 7, 0: overok = 1 ELSE COLOR 0, 7: overok = 0
        IF it = hehe THEN LOCATE ying + it, xing + INT((wide - 16) / 2): PRINT "<OK>"
        IF ying + it = ymusen AND xmusen >= xing + INT((wide - 16) / 2) + 8 AND xmusen <= xing + INT((wide - 16) / 2) + 15 THEN COLOR 7, 0: overcancel = 1 ELSE COLOR 0, 7: overcancel = 0
        IF it = hehe THEN LOCATE ying + it, xing + INT((wide - 16) / 2) + 8: PRINT "<Cancel>"
        COLOR 0, 7
    NEXT
    LOCATE ying + hehe - 1, xing: PRINT STRING$(wide, 196)
    FOR it = 1 TO hehe - 2
        IF it + scrollie = aselect THEN COLOR 7, 0 ELSE COLOR 0, 7
        IF LEN(textlist(it + scrollie)) > wide - 2 THEN LOCATE ying + it, xing: PRINT MID$(textlist(it + scrollie), 1, wide - 5) + "..." ELSE LOCATE ying + it, xing: PRINT textlist(it + scrollie)
    NEXT
    COLOR 0, 7
    LOCATE ying + hehe + 1, xing - 1: PRINT CHR$(192) + STRING$(wide, 196) + CHR$(217)

    _LIMIT 60
    IF _FULLSCREEN THEN

        IF xmusen > 0 AND ymusen > 0 AND xmusen <= _WIDTH AND ymusen <= _HEIGHT THEN
            LOCATE ymusen, xmusen, 1, 1, 8
        END IF
    END IF

    _DISPLAY
    'IF _WIDTH = 80 AND _HEIGHT = 25 THEN PCOPY 1, 0 ELSE PCOPY 0, 1
    kbd$ = INKEY$
    SELECT CASE kbd$
        CASE CHR$(27): viewsubs = 0: EXIT DO
        CASE CHR$(13): viewsubs = subpos(aselect): EXIT DO
        CASE CHR$(0) + "H": IF aselect > 1 THEN aselect = aselect - 1
        CASE CHR$(0) + "P": IF aselect < numlist THEN aselect = aselect + 1
    END SELECT
    DO WHILE _MOUSEINPUT
        ymusen = CINT(_MOUSEY)
        xmusen = CINT(_MOUSEX)
        bmusen = _MOUSEBUTTON(1)
    LOOP
    IF xmusen >= xing AND xmusen <= xing + wide AND ymusen >= ying AND ymusen <= ying + hehe - 1 AND bmusen = -1 THEN aselect = (ymusen - ying) + scrollie
    IF aselect < 1 THEN aselect = 0
    IF aselect > numlist THEN aselect = numlist
    IF aselect > hehe - 2 + scrollie THEN scrollie = aselect - (hehe - 2)
    IF aselect < scrollie + 1 AND aselect <> 0 THEN scrollie = aselect - 1
    IF overok = 1 AND bmusen = 0 THEN ok = 1
    IF overcancel = 1 AND bmusen = 0 THEN cancel = 1
    IF ok = 1 AND overok = 1 AND bmusen = -1 THEN viewsubs = subpos(aselect): EXIT DO
    IF cancel = 1 AND overcancel = 1 AND bmusen = -1 THEN viewsubs = 0: EXIT DO
    IF ok = 1 AND overok = 0 THEN ok = 0
    IF cancel = 1 AND overcancel = 0 THEN cancel = 0

LOOP
END FUNCTION



FUNCTION savefile$ (title AS STRING, currentfile$)
DIM thefiles(255) AS STRING
DIM thedirectories(255) AS STRING
xdir = 1
ydir = 2
xfil = 19
yfil = 2
filwid = 20
dirwid = 16
filhei = 6
dirhei = 6
widthe = 40
height = 13
lentit = LEN(title)
xposit = 40 - INT(widthe / 2)
yposit = 12 - INT(height / 2)
filemess$ = "Filename: "
textbx = 2 + LEN(filemess$)
textby = yfil + filhei + 2
textbl = (widthe - LEN(filemess$)) - 2

IF xposit + 1 + widthe > _WIDTH THEN SOUND 500, .1: EXIT FUNCTION
IF yposit + 1 + height > _HEIGHT THEN SOUND 500, .1: EXIT FUNCTION

FOR namepos = LEN(currentfile$) TO 1 STEP -1
    IF MID$(currentfile$, namepos, 1) = "\" THEN namepos = namepos + 1: EXIT FOR
NEXT
curname$ = MID$(currentfile$, namepos)

thedirectories(1) = "<..>"
filespec$ = "*.bas"

redos:
title = MID$(title, 1, lentit) + " (" + UCASE$(filespec$) + ")"

SHELL _HIDE "cd > temp.tmp"
OPEN "temp.tmp" FOR INPUT AS #1
INPUT #1, pat$
CLOSE #1
KILL "temp.tmp"
SHELL _HIDE "dir/a-d/b " + filespec$ + " > temp.tmp"
OPEN "temp.tmp" FOR INPUT AS #1
filer = 0
DO UNTIL EOF(1)
    filer = filer + 1
    LINE INPUT #1, thefiles(filer)
    IF thefiles(filer) = "temp.tmp" THEN filer = filer - 1
LOOP
CLOSE #1
KILL "temp.tmp"
SHELL _HIDE "dir/ad/b > temp.tmp"
OPEN "temp.tmp" FOR INPUT AS #1
dires = 1
DO UNTIL EOF(1)
    dires = dires + 1
    LINE INPUT #1, thedirectories(dires)
LOOP
CLOSE #1
KILL "temp.tmp"





refreshs:
IF MID$(pat$, LEN(pat$), 1) <> "\" THEN pat$ = pat$ + "\"
currentfile$ = pat$ + curname$


COLOR 7, 0
LOCATE yposit - 1, xposit - 1: PRINT SPACE$(widthe + 2)
LOCATE yposit - 1, (xposit - 1) + INT(((widthe + 2) - LEN(title)) / 2): PRINT title
COLOR 0, 7
LOCATE yposit, xposit - 1: PRINT CHR$(218) + STRING$(widthe, 196) + CHR$(191)
FOR it = 1 TO height
    LOCATE yposit + it, xposit - 1: PRINT CHR$(179)
    LOCATE yposit + it, xposit: PRINT SPACE$(widthe)
    LOCATE yposit + it, xposit + widthe: PRINT CHR$(179)
    IF it = height AND filespec$ = "*.bas" THEN LOCATE yposit + it, xposit + INT((widthe - 16) / 2): PRINT "<OK>    <Cancel>    <*.*>"
    IF it = height AND filespec$ = "*.*" THEN LOCATE yposit + it, xposit + INT((widthe - 16) / 2): PRINT "<OK>    <Cancel>    <*.BAS>"
NEXT
LOCATE yposit + height + 1, xposit - 1: PRINT CHR$(192) + STRING$(widthe, 196) + CHR$(217)
'directory box
IF filebrowse = 1 OR filebrowse = 3 THEN
    LOCATE yposit + ydir, xposit - 1 + xdir: PRINT CHR$(218) + STRING$(dirwid, 196) + CHR$(191)
    FOR it = 1 TO dirhei
        LOCATE yposit + it + ydir, xposit + xdir - 1: PRINT CHR$(179)
        LOCATE yposit + it + ydir, xposit + xdir: PRINT SPACE$(dirwid)
        LOCATE yposit + it + ydir, xposit + xdir + dirwid: PRINT CHR$(179)
    NEXT
    LOCATE yposit + ydir + dirhei + 1, xposit - 1 + xdir: PRINT CHR$(192) + STRING$(dirwid, 196) + CHR$(217)
END IF
IF filebrowse = 0 THEN
    LOCATE yposit + ydir, xposit - 1 + xdir: PRINT CHR$(201) + STRING$(dirwid, 205) + CHR$(187)
    FOR it = 1 TO dirhei
        LOCATE yposit + it + ydir, xposit + xdir - 1: PRINT CHR$(186)
        LOCATE yposit + it + ydir, xposit + xdir: PRINT SPACE$(dirwid)
        LOCATE yposit + it + ydir, xposit + xdir + dirwid: PRINT CHR$(186)
    NEXT
    LOCATE yposit + ydir + dirhei + 1, xposit - 1 + xdir: PRINT CHR$(200) + STRING$(dirwid, 205) + CHR$(188)
END IF

'files box
IF filebrowse = 0 OR filebrowse = 3 THEN
    LOCATE yposit + yfil, xposit - 1 + xfil: PRINT CHR$(218) + STRING$(filwid, 196) + CHR$(191)
    FOR it = 1 TO filhei
        LOCATE yposit + it + yfil, xposit + xfil - 1: PRINT CHR$(179)
        LOCATE yposit + it + yfil, xposit + xfil: PRINT SPACE$(filwid)
        LOCATE yposit + it + yfil, xposit + xfil + filwid: PRINT CHR$(179)
    NEXT
    LOCATE yposit + yfil + filhei + 1, xposit - 1 + xfil: PRINT CHR$(192) + STRING$(filwid, 196) + CHR$(217)
END IF
IF filebrowse = 1 THEN
    LOCATE yposit + yfil, xposit - 1 + xfil: PRINT CHR$(201) + STRING$(filwid, 205) + CHR$(187)
    FOR it = 1 TO filhei
        LOCATE yposit + it + yfil, xposit + xfil - 1: PRINT CHR$(186)
        LOCATE yposit + it + yfil, xposit + xfil: PRINT SPACE$(filwid)
        LOCATE yposit + it + yfil, xposit + xfil + filwid: PRINT CHR$(186)
    NEXT
    LOCATE yposit + yfil + filhei + 1, xposit - 1 + xfil: PRINT CHR$(200) + STRING$(filwid, 205) + CHR$(188)
END IF

'text box
IF filebrowse <> 3 THEN
    LOCATE yposit + textby + 1, xposit + 1: PRINT filemess$

    LOCATE yposit + textby, xposit + textbx - 1: PRINT CHR$(218) + STRING$(textbl - 1, 196) + CHR$(191)
    LOCATE yposit + textby + 1, xposit + textbx - 1: PRINT CHR$(179)
    LOCATE yposit + textby + 1, xposit + textbx: PRINT SPACE$(textbl - 1)
    LOCATE yposit + textby + 1, xposit + textbx + textbl - 1: PRINT CHR$(179)
    LOCATE yposit + textby + 2, xposit + textbx - 1: PRINT CHR$(192) + STRING$(textbl - 1, 196) + CHR$(217)

END IF

IF filebrowse = 3 THEN
    LOCATE yposit + textby + 1, xposit + 1: PRINT filemess$

    LOCATE yposit + textby, xposit + textbx - 1: PRINT CHR$(201) + STRING$(textbl - 1, 205) + CHR$(187)
    LOCATE yposit + textby + 1, xposit + textbx - 1: PRINT CHR$(186)
    LOCATE yposit + textby + 1, xposit + textbx: PRINT SPACE$(textbl - 1)
    LOCATE yposit + textby + 1, xposit + textbx + textbl - 1: PRINT CHR$(186)
    LOCATE yposit + textby + 2, xposit + textbx - 1: PRINT CHR$(200) + STRING$(textbl - 1, 205) + CHR$(188)
END IF


LOCATE yposit + textby + 1, xposit + textbx + 1

IF LEN(curname$) <= 24 THEN PRINT curname$; "_"
IF LEN(curname$) > 24 THEN PRINT MID$(curname$, LEN(curname$) - 24); "_"

LOCATE yposit + 1, xposit: PRINT SPACE$(widthe)

IF selectedfile = 1 THEN currentfile$ = pat$ + thefiles(selfil): curname$ = thefiles(selfil): selectedfile = 0
LOCATE yposit + 1, xposit + 1: PRINT MID$(currentfile$, 1, widthe - 1)
FOR dir = 1 TO dires
    IF dir <= dirhei THEN
        IF dir + reld = seldir THEN COLOR 7, 0 ELSE COLOR 0, 7
        LOCATE yposit + ydir + dir, xposit + xdir + 1: PRINT MID$(thedirectories(dir + reld), 1, dirwid - 2)
    END IF
NEXT

COLOR 0, 7


IF dires > dirhei THEN
    LOCATE yposit + ydir + 1, xposit + xdir + dirwid - 1: PRINT CHR$(24)
    LOCATE yposit + ydir + dirhei, xposit + xdir + dirwid - 1: PRINT CHR$(25)
END IF



IF filer > 0 THEN
    FOR fil = 1 TO filer
        IF fil <= filhei THEN
            IF fil + relf = selfil THEN COLOR 7, 0 ELSE COLOR 0, 7
            LOCATE yposit + yfil + fil, xposit + xfil + 1: PRINT MID$(thefiles(fil + relf), 1, filwid - 2)
        END IF
    NEXT
END IF
COLOR 0, 7

IF filer > filhei THEN
    LOCATE yposit + yfil + 1, xposit + xfil + filwid - 1: PRINT CHR$(24)
    LOCATE yposit + yfil + filhei, xposit + xfil + filwid - 1: PRINT CHR$(25)

END IF


DO
    exittype = _EXIT
    IF exittype = 1 OR exittype = 3 THEN
        IF edited = 0 THEN
            SYSTEM
        ELSE
            retcode = msgbox("Are you sure?", "Code has been changed since the latest save, are you sure you want to quit?", 1, 22, 6)
            IF retcode = 1 THEN
                SYSTEM
            ELSE
                GOTO refreshs
            END IF
        END IF
    END IF

    IF _FULLSCREEN THEN

        IF musix > 0 AND musiy > 0 AND musix <= _WIDTH AND musiy <= _HEIGHT THEN
            LOCATE musiy, musix, 1, 1, 8
        END IF
    END IF

    _DISPLAY
    _LIMIT 30
    'IF _WIDTH = 80 AND _HEIGHT = 25 THEN PCOPY 1, 0 ELSE PCOPY 0, 1
    keyb$ = INKEY$
    SELECT CASE keyb$
        CASE CHR$(0) + "H"
            IF filebrowse = 0 THEN

                IF seldir > 1 THEN seldir = seldir - 1
                IF reld > seldir - 1 THEN reld = seldir - 1
                IF reld < seldir - 6 THEN reld = seldir - 6
                IF seldir < 1 THEN seldir = 1
                GOTO refreshs

            END IF

            IF filebrowse = 1 THEN
                IF selfil > 1 THEN selfil = selfil - 1
                IF relf > selfil - 1 THEN relf = selfil - 1
                IF relf < selfil - 6 THEN relf = selfil - 6
                IF selfil < 1 THEN selfil = 1
                selectedfile = 1: curname$ = thefiles(selfil)
                GOTO refreshs

            END IF

        CASE CHR$(0) + "P"
            IF filebrowse = 0 THEN
                IF seldir < dires THEN seldir = seldir + 1
                IF reld > seldir - 1 THEN reld = seldir - 1
                IF reld < seldir - 6 THEN reld = seldir - 6
                IF seldir > dires THEN seldir = dires
                GOTO refreshs
            END IF
            IF filebrowse = 1 THEN
                IF selfil < filer THEN selfil = selfil + 1
                IF relf > selfil - 1 THEN relf = selfil - 1
                IF relf < selfil - 6 THEN relf = selfil - 6
                IF selfil > filer THEN selfil = filer
                selectedfile = 1: curname$ = thefiles(selfil)
                GOTO refreshs

            END IF

        CASE CHR$(0) + "K"
        CASE CHR$(0) + "M"
        CASE CHR$(9): IF filebrowse = 0 THEN filebrowse = 1: GOTO refreshs ELSE filebrowse = 0: GOTO refreshs
        CASE CHR$(27): savefile$ = "": EXIT FUNCTION
        CASE CHR$(13)
            IF filebrowse = 0 THEN
                IF seldir = 1 THEN CHDIR "..\": GOTO redos
                IF seldir > 1 THEN CHDIR thedirectories(seldir): GOTO redos
            END IF

            IF filebrowse = 1 OR filebrowse = 3 THEN
                IF filespec$ = "*.bas" AND LCASE$(RIGHT$(currentfile$, 4)) <> ".bas" THEN currentfile$ = currentfile$ + ".bas"
                savefile$ = currentfile$
                EXIT FUNCTION

            END IF
        CASE CHR$(8): curname$ = MID$(curname$, 1, LEN(curname$) - 1): filebrowse = 3: GOTO refreshs
        CASE ""
        CASE ELSE
            curname$ = curname$ + keyb$: filebrowse = 3: GOTO refreshs
    END SELECT


    DO WHILE _MOUSEINPUT
        musix = CINT(_MOUSEX)
        musiy = CINT(_MOUSEY)
        music = _MOUSEBUTTON(1)
    LOOP
    IF music = 0 AND firstclick = 1 THEN nextclick = 1
    button1x = xposit + INT((widthe - 16) / 2) + 1
    button2x = xposit + INT((widthe - 16) / 2) + 9
    button3x = xposit + INT((widthe - 16) / 2) + 21
    button1x2 = xposit + INT((widthe - 16) / 2) + 2
    button2x2 = xposit + INT((widthe - 16) / 2) + 14
    buttonsy = yposit + height
    IF filespec$ = "*.bas" THEN button3x2 = xposit + INT((widthe - 16) / 2) + 23
    IF filespec$ = "*.*" THEN button3x2 = xposit + INT((widthe - 16) / 2) + 25

    IF music = 0 AND (musix < button1x OR musix > button1x2 OR musiy <> buttonsy) THEN clickedonbutton1 = 0
    IF music = 0 AND (musix < button2x OR musix > button2x2 OR musiy <> buttonsy) THEN clickedonbutton2 = 0
    IF music = 0 AND (musix < button3x OR musix > button3x2 OR musiy <> buttonsy) THEN clickedonbutton3 = 0
    IF musiy = buttonsy AND musix >= button1x AND musix <= button1x2 THEN
        COLOR 7, 0
        FOR xselnt = button1x TO button1x2
            LOCATE buttonsy, xselnt: PRINT CHR$(SCREEN(buttonsy, xselnt))
        NEXT
        COLOR 0, 7
        IF music = 0 AND clickedonbutton1 = 1 THEN
            IF filespec$ = "*.bas" AND LCASE$(RIGHT$(currentfile$, 4)) <> ".bas" THEN currentfile$ = currentfile$ + ".bas"
            savefile$ = currentfile$: EXIT FUNCTION

        END IF
    ELSE
        FOR xselnt = button1x TO button1x2
            LOCATE buttonsy, xselnt: PRINT CHR$(SCREEN(buttonsy, xselnt))
        NEXT

    END IF
    IF musiy = buttonsy AND musix >= button2x AND musix <= button2x2 THEN
        COLOR 7, 0
        FOR xselnt = button2x TO button2x2
            LOCATE buttonsy, xselnt: PRINT CHR$(SCREEN(buttonsy, xselnt))
        NEXT
        COLOR 0, 7
        IF music = 0 AND clickedonbutton2 = 1 THEN
            savefile$ = "": EXIT FUNCTION
        END IF
    ELSE
        FOR xselnt = button2x TO button2x2
            LOCATE buttonsy, xselnt: PRINT CHR$(SCREEN(buttonsy, xselnt))
        NEXT

    END IF
    IF musiy = buttonsy AND musix >= button3x AND musix <= button3x2 THEN
        COLOR 7, 0
        FOR xselnt = button3x TO button3x2
            LOCATE buttonsy, xselnt: PRINT CHR$(SCREEN(buttonsy, xselnt))
        NEXT
        COLOR 0, 7
        IF music = 0 AND clickedonbutton3 = 1 THEN
            IF filespec$ = "*.*" THEN filespec$ = "*.bas" ELSE filespec$ = "*.*"
            clickedonbutton3 = 0
            GOTO redos
        END IF
    ELSE
        FOR xselnt = button3x TO button3x2
            LOCATE buttonsy, xselnt: PRINT CHR$(SCREEN(buttonsy, xselnt))
        NEXT

    END IF




    IF music THEN
        IF musiy = buttonsy AND musix >= button1x AND musix <= button1x2 THEN
            clickedonbutton1 = 1
        ELSE
            clickedonbutton1 = 0
        END IF
        IF musiy = buttonsy AND musix >= button2x AND musix <= button2x2 THEN
            clickedonbutton2 = 1
        ELSE
            clickedonbutton2 = 0
        END IF
        IF musiy = buttonsy AND musix >= button3x AND musix <= button3x2 THEN
            clickedonbutton3 = 1
        ELSE
            clickedonbutton3 = 0
        END IF


        IF musix >= xposit + xdir + 1 AND musix <= xposit + xdir + 1 + dirwid - 3 THEN
            IF musiy >= yposit + ydir + 1 AND musiy <= yposit + ydir + dirhei THEN
                filebrowse = 0
                IF (musiy - (yposit + ydir)) + reld <= dires THEN
                    IF tid = 0 AND nextclick = 0 THEN tid = TIMER: firstclick = 1: befdir = (musiy - (yposit + ydir)) + reld
                    IF TIMER > tid + .3 THEN firstclick = 0: nextclick = 0: tid = 0: tid2 = 0
                    IF tid2 = 0 AND nextclick = 1 THEN tid2 = TIMER: firstclick = 0
                    IF tid2 <= tid + .3 AND nextclick = 1 AND befdir = (musiy - (yposit + ydir)) + reld THEN
                        tid = 0
                        tid2 = 0
                        firstclick = 0
                        nextclick = 0
                        reld = 0
                        relf = 0
                        seldir = 1
                        selfil = 0
                        'doubleclick
                        selecteddirectory = 1
                        IF befdir = 1 THEN CHDIR "..\": GOTO redos
                        IF befdir > 1 THEN CHDIR thedirectories(befdir): GOTO redos
                        END
                    END IF
                    IF tid2 > tid + .3 THEN tid = 0: tid2 = 0
                    seldir = (musiy - (yposit + ydir)) + reld: GOTO refreshs
                END IF
            END IF
        END IF
        IF musix >= xposit + xfil + 1 AND musix <= xposit + xfil + 1 + filwid - 3 THEN
            IF musiy >= yposit + yfil + 1 AND musiy <= yposit + yfil + filhei THEN
                filebrowse = 1
                IF (musiy - (yposit + yfil)) + relf <= filer THEN
                    IF tid = 0 AND nextclick = 0 THEN tid = TIMER: firstclick = 1: beffil = (musiy - (yposit + yfil)) + relf
                    IF TIMER > tid + .3 THEN firstclick = 0: nextclick = 0: tid = 0: tid2 = 0
                    IF tid2 = 0 AND nextclick = 1 THEN tid2 = TIMER: firstclick = 0
                    IF tid2 <= tid + .3 AND nextclick = 1 AND beffil = (musiy - (yposit + ydir)) + relf THEN
                        tid = 0
                        tid2 = 0
                        'doubleclick
                        IF filespec$ = "*.bas" AND LCASE$(RIGHT$(thefiles(beffil), 4)) <> ".bas" THEN extext$ = ".bas" ELSE extext$ = ""
                        IF MID$(pat$, LEN(pat$), 1) <> "\" THEN
                            savefile$ = pat$ + "\" + thefiles(beffil) + extext$: EXIT FUNCTION
                        ELSE
                            savefile$ = pat$ + thefiles(beffil) + extext$: EXIT FUNCTION

                        END IF
                    END IF
                    IF tid2 > tid + .3 THEN tid = 0: tid2 = 0

                    selfil = (musiy - (yposit + yfil)) + relf: selectedfile = 1: filebrowse = 1: GOTO refreshs
                END IF
            END IF
        END IF
        IF musiy = yposit + textby + 1 AND musix >= xposit + textbx + 1 AND musix <= xposit + textbx + 1 + 24 THEN
            filebrowse = 3: GOTO refreshs
        END IF

        IF filer > filhei THEN
            IF musix = (xposit + xfil + 1 + filwid - 2) AND musiy = yposit + yfil + 1 THEN
                IF relf > 0 THEN relf = relf - 1: GOTO refreshs
            END IF
            IF musix = (xposit + xfil + 1 + filwid - 2) AND musiy = yposit + yfil + filhei THEN
                IF relf < filer - filhei THEN relf = relf + 1: GOTO refreshs
            END IF
        END IF
        IF dires > dirhei THEN
            IF musix = (xposit + xdir + 1 + dirwid - 2) AND musiy = yposit + ydir + 1 THEN
                IF reld > 0 THEN reld = reld - 1: GOTO refreshs
            END IF
            IF musix = (xposit + xdir + 1 + dirwid - 2) AND musiy = yposit + ydir + dirhei THEN
                IF reld < dires - dirhei THEN reld = reld + 1: GOTO refreshs
            END IF

        END IF

    END IF


LOOP

END FUNCTION



FUNCTION openfile$ (title AS STRING, filespec$, defaultpath$)
DIM thefiles(5000) AS STRING
DIM thedirectories(5000) AS STRING
xdir = 1
ydir = 2
xfil = 19
yfil = 2
filwid = 20
dirwid = 16
filhei = 6
dirhei = 6
widthe = 40
height = 10
lentit = LEN(title)
xposit = 40 - INT(widthe / 2)
yposit = 12 - INT(height / 2)

IF xposit + 1 + widthe > _WIDTH THEN SOUND 500, .1: EXIT FUNCTION
IF yposit + 1 + height > _HEIGHT THEN SOUND 500, .1: EXIT FUNCTION

thedirectories(1) = "<..>"
IF filespec$ = "" THEN filespec$ = "*.bas"



redo:
title = MID$(title, 1, lentit) + " (" + UCASE$(filespec$) + ")"
SHELL _HIDE "cd > temp.tmp"
OPEN "temp.tmp" FOR INPUT AS #1
INPUT #1, pat$
CLOSE #1
KILL "temp.tmp"
IF defaultpath$ <> "" THEN pat$ = defaultpath$: CHDIR defaultpath$

SHELL _HIDE "dir/a-d/b " + filespec$ + " > temp.tmp"
OPEN "temp.tmp" FOR INPUT AS #1
filer = 0
DO UNTIL EOF(1)
    filer = filer + 1
    LINE INPUT #1, thefiles(filer)
    IF thefiles(filer) = "temp.tmp" THEN filer = filer - 1
LOOP
CLOSE #1
KILL "temp.tmp"
SHELL _HIDE "dir/ad/b > temp.tmp"
OPEN "temp.tmp" FOR INPUT AS #1
dires = 1
DO UNTIL EOF(1)
    dires = dires + 1
    LINE INPUT #1, thedirectories(dires)
LOOP
CLOSE #1
KILL "temp.tmp"

refresh:

COLOR 7, 0
LOCATE yposit - 1, xposit - 1: PRINT SPACE$(widthe + 2)
LOCATE yposit - 1, (xposit - 1) + INT(((widthe + 2) - LEN(title)) / 2): PRINT title
COLOR 0, 7
LOCATE yposit, xposit - 1: PRINT CHR$(218) + STRING$(widthe, 196) + CHR$(191)
FOR it = 1 TO height
    LOCATE yposit + it, xposit - 1: PRINT CHR$(179)
    LOCATE yposit + it, xposit: PRINT SPACE$(widthe)
    LOCATE yposit + it, xposit + widthe: PRINT CHR$(179)
    IF it = height AND filespec$ = "*.bas" THEN LOCATE yposit + it, xposit + INT((widthe - 16) / 2): PRINT "<OK>    <Cancel>    <*.*>"
    IF it = height AND filespec$ = "*.*" THEN LOCATE yposit + it, xposit + INT((widthe - 16) / 2): PRINT "<OK>    <Cancel>    <*.BAS>"
    IF it = height AND filespec$ <> "*.bas" AND filespec$ <> "*.*" THEN LOCATE yposit + it, xposit + INT((widthe - 16) / 2): PRINT "<OK>    <Cancel>           "
NEXT
LOCATE yposit + height + 1, xposit - 1: PRINT CHR$(192) + STRING$(widthe, 196) + CHR$(217)

'218 - 201
'196 - 205
'191 - 187
'192 - 200
'217 - 188
'179 - 186

'directory box
IF thefocus = 0 THEN
    LOCATE yposit + ydir, xposit - 1 + xdir: PRINT CHR$(218) + STRING$(dirwid, 196) + CHR$(191)
    FOR it = 1 TO dirhei
        LOCATE yposit + it + ydir, xposit + xdir - 1: PRINT CHR$(179)
        LOCATE yposit + it + ydir, xposit + xdir: PRINT SPACE$(dirwid)
        LOCATE yposit + it + ydir, xposit + xdir + dirwid: PRINT CHR$(179)
    NEXT
    LOCATE yposit + ydir + dirhei + 1, xposit - 1 + xdir: PRINT CHR$(192) + STRING$(dirwid, 196) + CHR$(217)
END IF
IF thefocus = 1 THEN
    LOCATE yposit + ydir, xposit - 1 + xdir: PRINT CHR$(201) + STRING$(dirwid, 205) + CHR$(187)
    FOR it = 1 TO dirhei
        LOCATE yposit + it + ydir, xposit + xdir - 1: PRINT CHR$(186)
        LOCATE yposit + it + ydir, xposit + xdir: PRINT SPACE$(dirwid)
        LOCATE yposit + it + ydir, xposit + xdir + dirwid: PRINT CHR$(186)
    NEXT
    LOCATE yposit + ydir + dirhei + 1, xposit - 1 + xdir: PRINT CHR$(200) + STRING$(dirwid, 205) + CHR$(188)
END IF

'218 - 201
'196 - 205
'191 - 187
'192 - 200
'217 - 188
'179 - 186


'files box
IF thefocus = 1 THEN
    LOCATE yposit + yfil, xposit - 1 + xfil: PRINT CHR$(218) + STRING$(filwid, 196) + CHR$(191)
    FOR it = 1 TO filhei
        LOCATE yposit + it + yfil, xposit + xfil - 1: PRINT CHR$(179)
        LOCATE yposit + it + yfil, xposit + xfil: PRINT SPACE$(filwid)
        LOCATE yposit + it + yfil, xposit + xfil + filwid: PRINT CHR$(179)
    NEXT
    LOCATE yposit + yfil + filhei + 1, xposit - 1 + xfil: PRINT CHR$(192) + STRING$(filwid, 196) + CHR$(217)
END IF
IF thefocus = 0 THEN
    LOCATE yposit + yfil, xposit - 1 + xfil: PRINT CHR$(201) + STRING$(filwid, 205) + CHR$(187)
    FOR it = 1 TO filhei
        LOCATE yposit + it + yfil, xposit + xfil - 1: PRINT CHR$(186)
        LOCATE yposit + it + yfil, xposit + xfil: PRINT SPACE$(filwid)
        LOCATE yposit + it + yfil, xposit + xfil + filwid: PRINT CHR$(186)
    NEXT
    LOCATE yposit + yfil + filhei + 1, xposit - 1 + xfil: PRINT CHR$(200) + STRING$(filwid, 205) + CHR$(188)
END IF



LOCATE yposit + 1, xposit: PRINT SPACE$(widthe)
IF MID$(pat$, LEN(pat$), 1) <> "\" THEN LOCATE yposit + 1, xposit + 1: PRINT MID$(pat$ + "\" + thefiles(selfil), 1, widthe - 1) ELSE LOCATE yposit + 1, xposit + 1: PRINT MID$(pat$ + thefiles(selfil), 1, widthe - 1)

FOR dir = 1 TO dires
    IF dir <= dirhei THEN
        IF dir + reld = seldir THEN COLOR 7, 0 ELSE COLOR 0, 7
        LOCATE yposit + ydir + dir, xposit + xdir + 1: PRINT MID$(thedirectories(dir + reld), 1, dirwid - 2)
    END IF
NEXT

COLOR 0, 7



IF dires > dirhei THEN
    LOCATE yposit + ydir + 1, xposit + xdir + dirwid - 1: PRINT CHR$(24)
    LOCATE yposit + ydir + dirhei, xposit + xdir + dirwid - 1: PRINT CHR$(25)
END IF



IF filer > 0 THEN
    FOR fil = 1 TO filer
        IF fil <= filhei THEN
            IF fil + relf = selfil THEN COLOR 7, 0 ELSE COLOR 0, 7
            LOCATE yposit + yfil + fil, xposit + xfil + 1: PRINT MID$(thefiles(fil + relf), 1, filwid - 2)
        END IF
    NEXT
END IF
COLOR 0, 7

IF filer > filhei THEN
    LOCATE yposit + yfil + 1, xposit + xfil + filwid - 1: PRINT CHR$(24)
    LOCATE yposit + yfil + filhei, xposit + xfil + filwid - 1: PRINT CHR$(25)

END IF


DO
    exittype = _EXIT
    IF exittype = 1 OR exittype = 3 THEN
        IF edited = 0 THEN
            SYSTEM
        ELSE
            retcode = msgbox("Are you sure?", "Code has been changed since the latest save, are you sure you want to quit?", 1, 22, 6)
            IF retcode = 1 THEN
                SYSTEM
            ELSE
                GOTO refresh
            END IF
        END IF
    END IF
    IF _FULLSCREEN THEN

        IF musix > 0 AND musiy > 0 AND musix <= _WIDTH AND musiy <= _HEIGHT THEN
            LOCATE musiy, musix, 1, 1, 8
        END IF
    END IF

    _DISPLAY
    _LIMIT 30
    'IF _WIDTH = 80 AND _HEIGHT = 25 THEN PCOPY 1, 0 ELSE PCOPY 0, 1

    DO WHILE _MOUSEINPUT
        musix = CINT(_MOUSEX)
        musiy = CINT(_MOUSEY)
        music = _MOUSEBUTTON(1)
    LOOP
    IF music = 0 AND firstclick = 1 THEN nextclick = 1
    button1x = xposit + INT((widthe - 16) / 2) + 1
    button2x = xposit + INT((widthe - 16) / 2) + 9
    button3x = xposit + INT((widthe - 16) / 2) + 21
    button1x2 = xposit + INT((widthe - 16) / 2) + 2
    button2x2 = xposit + INT((widthe - 16) / 2) + 14
    buttonsy = yposit + height
    IF filespec$ = "*.bas" THEN button3x2 = xposit + INT((widthe - 16) / 2) + 23
    IF filespec$ = "*.*" THEN button3x2 = xposit + INT((widthe - 16) / 2) + 25

    IF music = 0 AND (musix < button1x OR musix > button1x2 OR musiy <> buttonsy) THEN clickedonbutton1 = 0
    IF music = 0 AND (musix < button2x OR musix > button2x2 OR musiy <> buttonsy) THEN clickedonbutton2 = 0
    IF music = 0 AND (musix < button3x OR musix > button3x2 OR musiy <> buttonsy) THEN clickedonbutton3 = 0
    IF musiy = buttonsy AND musix >= button1x AND musix <= button1x2 THEN
        COLOR 7, 0
        FOR xselnt = button1x TO button1x2
            LOCATE buttonsy, xselnt: PRINT CHR$(SCREEN(buttonsy, xselnt))
        NEXT
        COLOR 0, 7
        IF music = 0 AND clickedonbutton1 = 1 THEN
            IF selfil > 0 THEN
                IF MID$(pat$, LEN(pat$), 1) <> "\" THEN openfile$ = pat$ + "\" + thefiles(selfil): EXIT FUNCTION ELSE openfile$ = pat$ + thefiles(selfil): EXIT FUNCTION
            END IF
        END IF
    ELSE
        FOR xselnt = button1x TO button1x2
            LOCATE buttonsy, xselnt: PRINT CHR$(SCREEN(buttonsy, xselnt))
        NEXT

    END IF
    IF musiy = buttonsy AND musix >= button2x AND musix <= button2x2 THEN
        COLOR 7, 0
        FOR xselnt = button2x TO button2x2
            LOCATE buttonsy, xselnt: PRINT CHR$(SCREEN(buttonsy, xselnt))
        NEXT
        COLOR 0, 7
        IF music = 0 AND clickedonbutton2 = 1 THEN
            openfile$ = "": EXIT FUNCTION
        END IF
    ELSE
        FOR xselnt = button2x TO button2x2
            LOCATE buttonsy, xselnt: PRINT CHR$(SCREEN(buttonsy, xselnt))
        NEXT

    END IF
    IF musiy = buttonsy AND musix >= button3x AND musix <= button3x2 THEN
        COLOR 7, 0
        FOR xselnt = button3x TO button3x2
            LOCATE buttonsy, xselnt: PRINT CHR$(SCREEN(buttonsy, xselnt))
        NEXT
        COLOR 0, 7
        IF music = 0 AND clickedonbutton3 = 1 THEN
            IF filespec$ = "*.*" THEN filespec$ = "*.bas" ELSE filespec$ = "*.*"
            clickedonbutton3 = 0
            GOTO redo
        END IF
    ELSE
        FOR xselnt = button3x TO button3x2
            LOCATE buttonsy, xselnt: PRINT CHR$(SCREEN(buttonsy, xselnt))
        NEXT

    END IF




    IF music THEN
        IF musiy = buttonsy AND musix >= button1x AND musix <= button1x2 THEN
            clickedonbutton1 = 1
        ELSE
            clickedonbutton1 = 0
        END IF
        IF musiy = buttonsy AND musix >= button2x AND musix <= button2x2 THEN
            clickedonbutton2 = 1
        ELSE
            clickedonbutton2 = 0
        END IF
        IF musiy = buttonsy AND musix >= button3x AND musix <= button3x2 THEN
            clickedonbutton3 = 1
        ELSE
            clickedonbutton3 = 0
        END IF


        IF musix >= xposit + xdir + 1 AND musix <= xposit + xdir + 1 + dirwid - 3 THEN
            IF musiy >= yposit + ydir + 1 AND musiy <= yposit + ydir + dirhei THEN
                thefocus = 1
                IF (musiy - (yposit + ydir)) + reld <= dires THEN
                    IF tid = 0 AND nextclick = 0 THEN tid = TIMER: firstclick = 1: befdir = (musiy - (yposit + ydir)) + reld
                    IF TIMER > tid + .3 THEN firstclick = 0: nextclick = 0: tid = 0: tid2 = 0
                    IF tid2 = 0 AND nextclick = 1 THEN tid2 = TIMER: firstclick = 0
                    IF tid2 <= tid + .3 AND nextclick = 1 AND befdir = (musiy - (yposit + ydir)) + reld THEN
                        tid = 0
                        tid2 = 0
                        firstclick = 0
                        nextclick = 0
                        reld = 0
                        relf = 0
                        seldir = 1
                        selfil = 0
                        'doubleclick
                        IF befdir = 1 THEN CHDIR "..\": GOTO redo
                        IF befdir > 1 THEN CHDIR thedirectories(befdir): GOTO redo
                        END
                    END IF
                    IF tid2 > tid + .3 THEN tid = 0: tid2 = 0
                    seldir = (musiy - (yposit + ydir)) + reld: GOTO refresh
                END IF
            END IF
        END IF
        IF musix >= xposit + xfil + 1 AND musix <= xposit + xfil + 1 + filwid - 3 THEN
            IF musiy >= yposit + yfil + 1 AND musiy <= yposit + yfil + filhei THEN
                thefocus = 0
                IF (musiy - (yposit + yfil)) + relf <= filer THEN
                    IF tid = 0 AND nextclick = 0 THEN tid = TIMER: firstclick = 1: beffil = (musiy - (yposit + yfil)) + relf
                    IF TIMER > tid + .3 THEN firstclick = 0: nextclick = 0: tid = 0: tid2 = 0
                    IF tid2 = 0 AND nextclick = 1 THEN tid2 = TIMER: firstclick = 0
                    IF tid2 <= tid + .3 AND nextclick = 1 AND beffil = (musiy - (yposit + ydir)) + relf THEN
                        tid = 0
                        tid2 = 0
                        'doubleclick

                        IF filespec$ = "*.bas" AND LCASE$(RIGHT$(thefiles(beffil), 4)) <> ".bas" THEN extext$ = ".bas" ELSE extext$ = ""
                        IF MID$(pat$, LEN(pat$), 1) <> "\" THEN
                            openfile$ = pat$ + "\" + thefiles(beffil) + extext$: EXIT FUNCTION
                        ELSE
                            openfile$ = pat$ + thefiles(beffil) + extext$: EXIT FUNCTION
                        END IF

                    END IF
                    IF tid2 > tid + .3 THEN tid = 0: tid2 = 0

                    selfil = (musiy - (yposit + yfil)) + relf: GOTO refresh
                END IF
            END IF
        END IF
        IF filer > filhei THEN
            IF musix = (xposit + xfil + 1 + filwid - 2) AND musiy = yposit + yfil + 1 THEN
                IF selfil > 0 THEN selfil = selfil - 1: thefocus = 0
                IF selfil > 0 THEN
                    IF selfil < relf + 1 THEN relf = selfil - 1
                END IF
                GOTO refresh
            END IF
            IF musix = (xposit + xfil + 1 + filwid - 2) AND musiy = yposit + yfil + filhei THEN
                IF selfil < filer THEN selfil = selfil + 1: thefocus = 0
                IF selfil > filhei + relf THEN relf = selfil - filhei
                GOTO refresh
            END IF
        END IF
        IF dires > dirhei THEN
            IF musix = (xposit + xdir + 1 + dirwid - 2) AND musiy = yposit + ydir + 1 THEN
                IF seldir > 1 THEN seldir = seldir - 1: thefocus = 1
                IF seldir < reld + 1 THEN reld = seldir - 1
                GOTO refresh
            END IF
            IF musix = (xposit + xdir + 1 + dirwid - 2) AND musiy = yposit + ydir + dirhei THEN
                IF seldir < dires THEN seldir = seldir + 1: thefocus = 1
                IF seldir > dirhei + reld THEN reld = seldir - dirhei
                GOTO refresh
            END IF

        END IF

    END IF

    IF selfil > 0 THEN
        IF selfil < relf + 1 THEN relf = selfil - 1: GOTO refresh
        IF selfil > filhei + relf THEN relf = selfil - filhei: GOTO refresh
    END IF
    IF seldir > 0 THEN
        IF seldir < reld + 1 THEN reld = seldir - 1: GOTO refresh
        IF seldir > dirhei + reld THEN reld = seldir - dirhei: GOTO refresh
    END IF

    kbd$ = INKEY$
    SELECT CASE kbd$
        CASE CHR$(0) + "H"
            IF thefocus = 0 THEN
                selfil = selfil - 1
                IF selfil < 0 THEN selfil = 0
                IF selfil > 0 THEN
                    IF selfil < relf + 1 THEN relf = selfil - 1
                END IF
                GOTO refresh
            END IF
            IF thefocus = 1 THEN
                seldir = seldir - 1
                IF seldir < 1 THEN seldir = 1
                IF seldir < reld + 1 THEN reld = seldir - 1
                GOTO refresh
            END IF

        CASE CHR$(0) + "P"
            IF thefocus = 0 THEN
                selfil = selfil + 1
                IF selfil > filer THEN selfil = filer
                IF selfil > filhei + relf THEN relf = selfil - filhei
                GOTO refresh
            END IF
            IF thefocus = 1 THEN
                seldir = seldir + 1
                IF seldir > dires THEN seldir = dires
                IF seldir > dirhei + reld THEN reld = seldir - dirhei
                GOTO refresh
            END IF


        CASE CHR$(9): IF thefocus = 0 THEN thefocus = 1: GOTO refresh ELSE thefocus = 0: GOTO refresh

        CASE CHR$(13)
            IF thefocus = 0 THEN
                'exit with file
                IF selfil > 0 AND selfil <= filer THEN

                    IF MID$(pat$, LEN(pat$), 1) <> "\" THEN
                        IF filespec$ = "*.bas" AND LCASE$(RIGHT$(thefiles(selfil), 4)) <> ".bas" THEN extext$ = ".bas" ELSE extext$ = ""
                        openfile$ = pat$ + "\" + thefiles(selfil) + extext$: EXIT FUNCTION
                    ELSE
                        openfile$ = pat$ + thefiles(selfil) + extext$: EXIT FUNCTION
                    END IF
                END IF
            END IF

            IF thefocus = 1 THEN
                'change dir
                IF seldir = 1 THEN CHDIR "..\": reld = 0: relf = 0: selfil = 0: GOTO redo
                IF seldir > 1 AND seldir <= dires THEN CHDIR thedirectories(seldir): seldir = 1: reld = 0: relf = 0: selfil = 0: GOTO redo
            END IF

        CASE CHR$(27)
            'cancel
            openfile$ = "": EXIT FUNCTION

        CASE ""

        CASE ELSE
            IF ASC(kbd$) > 32 THEN
                IF focus = 0 THEN
                    IF selfil < filer THEN
                        FOR kollfil = selfil + 1 TO filer
                            IF LCASE$(MID$(thefiles(kollfil), 1, 1)) = kbd$ THEN selfil = kollfil: GOTO refresh
                        NEXT
                    END IF
                    IF selfil > 0 THEN
                        FOR kollfil = 1 TO selfil
                            IF LCASE$(MID$(thefiles(kollfil), 1, 1)) = kbd$ THEN selfil = kollfil: GOTO refresh
                        NEXT
                    END IF
                END IF
                IF focus = 1 THEN
                    IF seldir < dires THEN
                        FOR kolldir = seldir + 1 TO dires
                            IF LCASE$(MID$(thedirectories(kollfil), 1, 1)) = kbd$ THEN seldir = kolldir: GOTO refresh
                        NEXT
                    END IF
                    IF seldir > 0 THEN
                        FOR kolldir = 1 TO seldir
                            IF LCASE$(MID$(thedirectories(kollfil), 1, 1)) = kbd$ THEN seldir = kolldir: GOTO refresh
                        NEXT
                    END IF
                END IF
            END IF
    END SELECT

    IF selfil > 0 THEN
        IF selfil < relf + 1 THEN relf = selfil - 1: GOTO refresh
        IF selfil > filhei + relf THEN relf = selfil - filhei: GOTO refresh
    END IF
    IF seldir > 0 THEN
        IF seldir < reld + 1 THEN reld = seldir - 1: GOTO refresh
        IF seldir > dirhei + reld THEN reld = seldir - dirhei: GOTO refresh
    END IF
    'isn't really needed, just making sure (and it could be useful for additions to this function).
    IF selfil = 0 THEN relf = 0
    IF seldir = 0 THEN reld = 0

LOOP

END FUNCTION



FUNCTION msgbox (title AS STRING, text AS STRING, options, widthe, height)

xposit = 40 - INT(widthe / 2)
yposit = 12 - INT(height / 2)

IF xposit + 1 + widthe > _WIDTH THEN SOUND 500, .1: EXIT FUNCTION
IF yposit + 1 + height > _HEIGHT THEN SOUND 500, .1: EXIT FUNCTION


COLOR 7, 0
LOCATE yposit - 1, xposit - 1: PRINT SPACE$(widthe + 2)
LOCATE yposit - 1, (xposit - 1) + INT(((widthe + 2) - LEN(title)) / 2): PRINT title
COLOR 0, 7
LOCATE yposit, xposit - 1: PRINT CHR$(218) + STRING$(widthe, 196) + CHR$(191)
FOR it = 1 TO height
    LOCATE yposit + it, xposit - 1: PRINT CHR$(179)
    LOCATE yposit + it, xposit: PRINT SPACE$(widthe)
    IF (it - 1) * (widthe) <= LEN(text) THEN LOCATE yposit + it, xposit: PRINT LTRIM$(MID$(text, ((it - 1) * (widthe)) + 1, widthe))
    LOCATE yposit + it, xposit + widthe: PRINT CHR$(179)
    IF options = 1 THEN
        IF it = height THEN LOCATE yposit + it, xposit + INT((widthe - 12) / 2): PRINT "<Yes>   <No>"
    END IF

NEXT
LOCATE yposit + height + 1, xposit - 1: PRINT CHR$(192) + STRING$(widthe, 196) + CHR$(217)

IF _FULLSCREEN THEN

    IF xmus > 0 AND ymus > 0 AND xmus <= _WIDTH AND ymus <= _HEIGHT THEN
        LOCATE ymus, xmus, 1, 1, 8
    END IF
END IF


_DISPLAY
'IF _WIDTH = 80 AND _HEIGHT = 25 THEN PCOPY 1, 0 ELSE PCOPY 0, 1

IF options = 1 THEN
    xbutton1 = xposit + INT((widthe - 12) / 2): ybutton1 = yposit + height
    xbutton2 = xposit + INT((widthe - 12) / 2) + 8: ybutton2 = ybutton1
END IF

DO
    exittype = _EXIT
    IF exittype = 1 OR exittype = 3 THEN
        IF edited = 0 THEN
            SYSTEM
        ELSE
            retcode = msgbox("Are you sure?", "Code has been changed since the latest save, are you sure you want to quit?", 1, 22, 6)
            IF retcode = 1 THEN
                SYSTEM
            END IF
        END IF
    END IF

    _LIMIT 60

    kbd$ = INKEY$
    SELECT CASE kbd$
        CASE CHR$(13): msgbox = 1: EXIT DO
        CASE CHR$(27): msgbox = 2: EXIT DO
    END SELECT


    DO WHILE _MOUSEINPUT
        xmus = CINT(_MOUSEX)
        ymus = CINT(_MOUSEY)
        cmus = _MOUSEBUTTON(1)
    LOOP
    IF options = 1 THEN
        COLOR 0, 7
        FOR thexlo = 1 TO 12
            LOCATE ybutton1, xbutton1 + thexlo: PRINT CHR$(SCREEN(ybutton1, xbutton1 + thexlo))
        NEXT

        IF ymus = ybutton1 AND xmus >= xbutton1 AND xmus <= xbutton1 + 4 THEN
            FOR thexlo = 1 TO 3
                COLOR 7, 0
                LOCATE ybutton1, xbutton1 + thexlo: PRINT CHR$(SCREEN(ybutton1, xbutton1 + thexlo))
            NEXT
            IF cmus THEN buttonclick1 = 1
            IF cmus = 0 AND buttonclick1 = 1 THEN release1 = 1
            IF release1 = 1 THEN msgbox = 1: EXIT DO
        ELSE
            buttonclick1 = 0: release1 = 0
        END IF
        IF ymus = ybutton2 AND xmus >= xbutton2 AND xmus <= xbutton2 + 3 THEN
            FOR thexlo = 1 TO 2
                COLOR 7, 0
                LOCATE ybutton2, xbutton2 + thexlo: PRINT CHR$(SCREEN(ybutton2, xbutton2 + thexlo))
            NEXT
            IF cmus THEN buttonclick2 = 1
            IF cmus = 0 AND buttonclick2 = 1 THEN release2 = 1
            IF release2 = 1 THEN msgbox = 2: EXIT DO
        ELSE
            buttonclick2 = 0: release2 = 0
        END IF


    END IF
    IF _FULLSCREEN THEN

        IF xmus > 0 AND ymus > 0 AND xmus <= _WIDTH AND ymus <= _HEIGHT THEN
            LOCATE ymusen, xmusen, 1, 1, 8
        END IF
    END IF

    _DISPLAY
    'IF _WIDTH = 80 AND _HEIGHT = 25 THEN PCOPY 1, 0 ELSE PCOPY 0, 1
LOOP UNTIL retval <> 0



END FUNCTION


FUNCTION formatremovecomma$ (text AS STRING)
DO
    lol = lol + 1
    remove = 1
    IF MID$(text, lol, 2) = " ," AND MID$(text, lol - 1, 1) <> "," AND MID$(text, lol - 1, 1) <> ";" THEN
        IF lol > 2 THEN text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove) ELSE text = LTRIM$(text)
        IF lol > 2 THEN lol = lol - 1
    END IF
LOOP UNTIL lol >= LEN(text)

'and while we're at it add a space before the first "(" in a sub, declare or function

IF LCASE$(MID$(LTRIM$(text), 1, 9)) = "function " OR LCASE$(MID$(LTRIM$(text), 1, 4)) = "sub " OR LCASE$(MID$(LTRIM$(text), 1, 8)) = "declare " THEN
    paraloc = INSTR(1, text, "(")
    IF paraloc THEN
        IF MID$(text, paraloc - 1, 1) <> " " THEN text = MID$(text, 1, paraloc - 1) + " " + MID$(text, paraloc)
    END IF

END IF

formatremovecomma$ = text


END FUNCTION



FUNCTION createmenu (menuarray() AS STRING, items, xpo, selecteditem, mux, muy, muc, okey$)
bcurx = POS(1)
bcury = CSRLIN

FOR it = 1 TO items
    IF leng < LEN(menuarray(it)) THEN leng = LEN(menuarray(it))
NEXT
IF xpo + leng + 1 > _WIDTH THEN xpo = _WIDTH - (leng + 1)
IF xpo - 1 < 1 THEN xpo = 2

IF ((muy > 1 AND muy < 2 + items + 1) AND mux >= xpo - 1 AND mux <= xpo + leng) AND muc THEN releasemouse = 1

IF muy > 2 AND muy <= 2 + items AND mux > xpo AND mux < xpo + leng THEN
    selecteditem = muy - 2
    IF muc AND (releasemouse = 1) THEN selrelease = 1
    IF selrelease = 1 AND muc = 0 THEN createmenu = selecteditem: selrelease = 0

ELSE
    selecteditem = thekeysel
    selrelease = 0
END IF

IF (muy = 1) AND muc THEN
    createmenu = -2
    thekeysel = 1
END IF



IF muc = 0 THEN releasemouse = 0

IF ((muy > 3 + items) OR (mux < xpo - 1) OR (mux > xpo + leng)) AND (muc AND (muy > 1)) AND releasemouse = 0 THEN
    createmenu = -1
END IF


COLOR 0, 7
LOCATE 2, xpo - 1: PRINT CHR$(218) + STRING$(leng, 196) + CHR$(191)
FOR it = 1 TO items
    IF menuarray(it) <> "-" THEN LOCATE 2 + it, xpo - 1: PRINT CHR$(179)
    IF selecteditem = it THEN COLOR 7, 0 ELSE COLOR 0, 7
    IF menuarray(it) <> "-" THEN LOCATE 2 + it, xpo: PRINT menuarray(it)
    COLOR 0, 7
    IF menuarray(it) <> "-" THEN LOCATE 2 + it, xpo + leng: PRINT CHR$(179)
    IF menuarray(it) = "-" THEN LOCATE 2 + it, xpo - 1: PRINT CHR$(195) + STRING$(leng, 196) + CHR$(180)
NEXT
LOCATE 2 + items + 1, xpo - 1: PRINT CHR$(192) + STRING$(leng, 196) + CHR$(217)
IF okey$ = CHR$(27) THEN createmenu = -1
IF okey$ = CHR$(0) + "H" THEN
    IF thekeysel > 1 THEN thekeysel = thekeysel - 1 ELSE thekeysel = items
    IF menuarray(thekeysel) = "-" THEN thekeysel = thekeysel - 1
    IF thekeysel < 1 THEN thekeysel = items
END IF
IF okey$ = CHR$(0) + "P" THEN
    IF thekeysel < items THEN thekeysel = thekeysel + 1 ELSE thekeysel = 1
    IF menuarray(thekeysel) = "-" THEN thekeysel = thekeysel + 1
    IF thekeysel > items THEN thekeysel = 1
END IF
IF okey$ = CHR$(0) + "K" THEN
    createmenu = -3
END IF
IF okey$ = CHR$(0) + "M" THEN
    createmenu = -4
END IF
IF okey$ = CHR$(13) THEN createmenu = selecteditem
LOCATE bcury, bcurx
END FUNCTION


FUNCTION formatkeywords$ (text AS STRING, numkey, keyword() AS STRING, keytype() AS STRING)
'keytype can be function or statement (operators etc. formats as statements), "(function)" or "(statement)" works too.


FOR keynum = 1 TO numkey
    morekey = 1
    DO
        startofloop:
        posikey = INSTR(morekey, LCASE$(text), LCASE$(keyword(keynum)))
        lenokey = LEN(keyword(keynum))
        IF posikey THEN
            'found keyword, now determine if it is a valid one.
            datafound = 0
            FOR chdata = posikey TO 1 STEP -1
                IF MID$(LCASE$(text), posikey, lenokey) = "data" THEN EXIT FOR
                IF chdata > 1 THEN
                    IF MID$(text, chdata, 1) = ":" THEN EXIT FOR
                    IF LCASE$(MID$(text, chdata, 6)) = " data " THEN datafound = 1: EXIT FOR

                END IF
                IF chdata = 1 AND LCASE$(MID$(text, chdata, 5)) = "data " THEN datafound = 1: EXIT FOR
            NEXT
            IF datafound = 1 THEN morekey = posikey + 1: GOTO startofloop
            morekey = posikey + 1
            IF posikey = 1 THEN
                'it starts at the first position so no need to check that.
                'checking the end position:
                IF lenokey < LEN(text) THEN
                    ascii = ASC(text, lenokey + 1)
                    IF ((ascii >= 32 AND ascii < 48) OR (ascii > 57 AND ascii < 63)) AND ascii <> 46 THEN
                        IF INSTR(1, keytype(keynum), "statement") THEN
                            IF ascii = 32 OR ascii = 0 THEN MID$(text, 1, lenokey) = UCASE$(MID$(text, 1, lenokey))
                            IF ascii <> 32 AND ascii <> 0 AND ascii <> 58 AND ascii <> 59 THEN text = UCASE$(MID$(text, 1, lenokey)) + " " + MID$(text, lenokey + 1) ELSE text = UCASE$(MID$(text, 1, lenokey)) + MID$(text, lenokey + 1)
                        END IF
                    END IF
                END IF
                IF lenokey = LEN(text) THEN text = UCASE$(text)
            END IF

            IF posikey > 1 THEN
                fascii = ASC(text, posikey - 1)
                IF ((fascii >= 32 AND fascii < 48) OR (fascii > 57 AND fascii < 63)) AND fascii <> 46 THEN
                    validkey = 0
                    IF posikey + lenokey > LEN(text) THEN validkey = 1
                    IF posikey + lenokey <= LEN(text) THEN
                        EASCII = ASC(text, posikey + lenokey)
                        IF ((EASCII >= 32 AND EASCII < 48) OR (EASCII > 57 AND EASCII < 63)) AND EASCII <> 46 THEN
                            validkey = 1
                        END IF
                    END IF
                    IF validkey = 1 THEN

                        IF INSTR(1, keytype(keynum), "statement") THEN
                            IF EASCII = 32 OR EASCII = 0 THEN MID$(text, posikey, lenokey) = UCASE$(MID$(text, posikey, lenokey))
                            IF EASCII <> 32 AND EASCII <> 0 AND EASCII <> 58 AND EASCII <> 59 THEN text = MID$(text, 1, posikey - 1) + UCASE$(MID$(text, posikey, lenokey)) + " " + MID$(text, posikey + lenokey) ELSE text = MID$(text, 1, posikey - 1) + UCASE$(MID$(text, posikey, lenokey)) + MID$(text, posikey + lenokey)
                            IF fascii <> 32 AND fascii <> 0 THEN text = MID$(text, 1, posikey - 1) + " " + MID$(text, posikey)
                        ELSE
                            MID$(text, posikey, lenokey) = UCASE$(MID$(text, posikey, lenokey))
                        END IF
                    END IF
                END IF
            END IF
        END IF
    LOOP UNTIL posikey = 0
NEXT

formatkeywords$ = text
END FUNCTION

FUNCTION formatremovestuff$ (text AS STRING)
'This function removes unwanted single spaces.
'It also deals with other things related to removal.
IF LEN(text) >= 2 THEN
    DO
        lol = lol + 1
        'defint a-z, a - z
        'defint -z,
        'defint z-,
        checking$ = "defint "
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            notok = 0
            IF lol > 1 THEN IF MID$(text, lol - 1, 1) <> CHR$(32) THEN notok = 1
            IF notok = 0 THEN

                further = 0
                DO
                    IF LEN(text) > lol + 9 + further THEN
                        IF ASC(text, lol + 9 + further) = ASC("-") AND ASC(text, lol + 10 + further) <> ASC(",") THEN
                            text = MID$(text, 1, lol + 9 + further - 2) + MID$(text, lol + 9 + further)
                        END IF
                        IF ASC(text, lol + 8 + further) = ASC("-") THEN
                            text = MID$(text, 1, lol + 10 - 2 + further) + MID$(text, lol + 10 + further)
                        END IF
                    END IF
                    IF LEN(text) > lol + 7 + further THEN
                        IF ASC(text, lol + 7 + further) = ASC("-") THEN
                            text = MID$(text, 1, lol + 9 - 2 + further) + MID$(text, lol + 9 + further)
                        END IF
                    END IF
                    IF LEN(text) > lol + 8 + further THEN
                        IF ASC(text, lol + 9 + further) = ASC("-") THEN
                            text = MID$(text, 1, lol + 9 - 2 + further) + MID$(text, lol + 9 + further)
                        END IF
                    END IF
                    MID$(text, lol + 7 + further, 1) = UCASE$(MID$(text, lol + 7 + further, 1))
                    MID$(text, lol + 8 + further, 1) = UCASE$(MID$(text, lol + 8 + further, 1))
                    MID$(text, lol + 9 + further, 1) = UCASE$(MID$(text, lol + 9 + further, 1))
                    IF MID$(text, lol + 10 + further, 1) = "," OR MID$(text, lol + 9 + further, 1) = "," OR MID$(text, lol + 8 + further, 1) = "," THEN
                        IF MID$(text, lol + 10 + further, 1) = "," THEN further = further + 5
                        IF MID$(text, lol + 9 + further, 1) = "," THEN further = further + 4
                        IF MID$(text, lol + 8 + further, 1) = "," THEN further = further + 3
                    ELSE
                        further = 0
                    END IF
                LOOP UNTIL further = 0
            END IF
        END IF
        checking$ = "defsng "
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            notok = 0
            IF lol > 1 THEN IF MID$(text, lol - 1, 1) <> CHR$(32) THEN notok = 1
            IF notok = 0 THEN

                further = 0
                DO
                    IF LEN(text) > lol + 9 + further THEN
                        IF ASC(text, lol + 9 + further) = ASC("-") AND ASC(text, lol + 10 + further) <> ASC(",") THEN
                            text = MID$(text, 1, lol + 9 + further - 2) + MID$(text, lol + 9 + further)
                        END IF
                        IF ASC(text, lol + 8 + further) = ASC("-") THEN
                            text = MID$(text, 1, lol + 10 - 2 + further) + MID$(text, lol + 10 + further)
                        END IF
                    END IF
                    IF LEN(text) > lol + 7 + further THEN
                        IF ASC(text, lol + 7 + further) = ASC("-") THEN
                            text = MID$(text, 1, lol + 9 - 2 + further) + MID$(text, lol + 9 + further)
                        END IF
                    END IF
                    IF LEN(text) > lol + 8 + further THEN
                        IF ASC(text, lol + 9 + further) = ASC("-") THEN
                            text = MID$(text, 1, lol + 9 - 2 + further) + MID$(text, lol + 9 + further)
                        END IF
                    END IF
                    MID$(text, lol + 7 + further, 1) = UCASE$(MID$(text, lol + 7 + further, 1))
                    MID$(text, lol + 8 + further, 1) = UCASE$(MID$(text, lol + 8 + further, 1))
                    MID$(text, lol + 9 + further, 1) = UCASE$(MID$(text, lol + 9 + further, 1))
                    IF MID$(text, lol + 10 + further, 1) = "," OR MID$(text, lol + 9 + further, 1) = "," OR MID$(text, lol + 8 + further, 1) = "," THEN
                        IF MID$(text, lol + 10 + further, 1) = "," THEN further = further + 5
                        IF MID$(text, lol + 9 + further, 1) = "," THEN further = further + 4
                        IF MID$(text, lol + 8 + further, 1) = "," THEN further = further + 3
                    ELSE
                        further = 0
                    END IF
                LOOP UNTIL further = 0
            END IF
        END IF
        checking$ = "deflng "
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            notok = 0
            IF lol > 1 THEN IF MID$(text, lol - 1, 1) <> CHR$(32) THEN notok = 1
            IF notok = 0 THEN

                further = 0
                DO
                    IF LEN(text) > lol + 9 + further THEN
                        IF ASC(text, lol + 9 + further) = ASC("-") AND ASC(text, lol + 10 + further) <> ASC(",") THEN
                            text = MID$(text, 1, lol + 9 + further - 2) + MID$(text, lol + 9 + further)
                        END IF
                        IF ASC(text, lol + 8 + further) = ASC("-") THEN
                            text = MID$(text, 1, lol + 10 - 2 + further) + MID$(text, lol + 10 + further)
                        END IF
                    END IF
                    IF LEN(text) > lol + 7 + further THEN
                        IF ASC(text, lol + 7 + further) = ASC("-") THEN
                            text = MID$(text, 1, lol + 9 - 2 + further) + MID$(text, lol + 9 + further)
                        END IF
                    END IF
                    IF LEN(text) > lol + 8 + further THEN
                        IF ASC(text, lol + 9 + further) = ASC("-") THEN
                            text = MID$(text, 1, lol + 9 - 2 + further) + MID$(text, lol + 9 + further)
                        END IF
                    END IF
                    MID$(text, lol + 7 + further, 1) = UCASE$(MID$(text, lol + 7 + further, 1))
                    MID$(text, lol + 8 + further, 1) = UCASE$(MID$(text, lol + 8 + further, 1))
                    MID$(text, lol + 9 + further, 1) = UCASE$(MID$(text, lol + 9 + further, 1))
                    IF MID$(text, lol + 10 + further, 1) = "," OR MID$(text, lol + 9 + further, 1) = "," OR MID$(text, lol + 8 + further, 1) = "," THEN
                        IF MID$(text, lol + 10 + further, 1) = "," THEN further = further + 5
                        IF MID$(text, lol + 9 + further, 1) = "," THEN further = further + 4
                        IF MID$(text, lol + 8 + further, 1) = "," THEN further = further + 3
                    ELSE
                        further = 0
                    END IF
                LOOP UNTIL further = 0
            END IF
        END IF
        checking$ = "defstr "
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            notok = 0
            IF lol > 1 THEN IF MID$(text, lol - 1, 1) <> CHR$(32) THEN notok = 1
            IF notok = 0 THEN
                further = 0
                DO
                    IF LEN(text) > lol + 9 + further THEN
                        IF ASC(text, lol + 9 + further) = ASC("-") AND ASC(text, lol + 10 + further) <> ASC(",") THEN
                            text = MID$(text, 1, lol + 9 + further - 2) + MID$(text, lol + 9 + further)
                        END IF
                        IF ASC(text, lol + 8 + further) = ASC("-") THEN
                            text = MID$(text, 1, lol + 10 - 2 + further) + MID$(text, lol + 10 + further)
                        END IF
                    END IF
                    IF LEN(text) > lol + 7 + further THEN
                        IF ASC(text, lol + 7 + further) = ASC("-") THEN
                            text = MID$(text, 1, lol + 9 - 2 + further) + MID$(text, lol + 9 + further)
                        END IF
                    END IF
                    IF LEN(text) > lol + 8 + further THEN
                        IF ASC(text, lol + 9 + further) = ASC("-") THEN
                            text = MID$(text, 1, lol + 9 - 2 + further) + MID$(text, lol + 9 + further)
                        END IF
                    END IF
                    MID$(text, lol + 7 + further, 1) = UCASE$(MID$(text, lol + 7 + further, 1))
                    MID$(text, lol + 8 + further, 1) = UCASE$(MID$(text, lol + 8 + further, 1))
                    MID$(text, lol + 9 + further, 1) = UCASE$(MID$(text, lol + 9 + further, 1))
                    IF MID$(text, lol + 10 + further, 1) = "," OR MID$(text, lol + 9 + further, 1) = "," OR MID$(text, lol + 8 + further, 1) = "," THEN
                        IF MID$(text, lol + 10 + further, 1) = "," THEN further = further + 5
                        IF MID$(text, lol + 9 + further, 1) = "," THEN further = further + 4
                        IF MID$(text, lol + 8 + further, 1) = "," THEN further = further + 3
                    ELSE
                        further = 0
                    END IF
                LOOP UNTIL further = 0
            END IF
        END IF
        checking$ = "defdbl "
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            notok = 0
            IF lol > 1 THEN IF MID$(text, lol - 1, 1) <> CHR$(32) THEN notok = 1
            IF notok = 0 THEN

                further = 0
                DO
                    IF LEN(text) > lol + 9 + further THEN
                        IF ASC(text, lol + 9 + further) = ASC("-") AND ASC(text, lol + 10 + further) <> ASC(",") THEN
                            text = MID$(text, 1, lol + 9 + further - 2) + MID$(text, lol + 9 + further)
                        END IF
                        IF ASC(text, lol + 8 + further) = ASC("-") THEN
                            text = MID$(text, 1, lol + 10 - 2 + further) + MID$(text, lol + 10 + further)
                        END IF
                    END IF
                    IF LEN(text) > lol + 7 + further THEN
                        IF ASC(text, lol + 7 + further) = ASC("-") THEN
                            text = MID$(text, 1, lol + 9 - 2 + further) + MID$(text, lol + 9 + further)
                        END IF
                    END IF
                    IF LEN(text) > lol + 8 + further THEN
                        IF ASC(text, lol + 9 + further) = ASC("-") THEN
                            text = MID$(text, 1, lol + 9 - 2 + further) + MID$(text, lol + 9 + further)
                        END IF
                    END IF
                    MID$(text, lol + 7 + further, 1) = UCASE$(MID$(text, lol + 7 + further, 1))
                    MID$(text, lol + 8 + further, 1) = UCASE$(MID$(text, lol + 8 + further, 1))
                    MID$(text, lol + 9 + further, 1) = UCASE$(MID$(text, lol + 9 + further, 1))
                    IF MID$(text, lol + 10 + further, 1) = "," OR MID$(text, lol + 9 + further, 1) = "," OR MID$(text, lol + 8 + further, 1) = "," THEN
                        IF MID$(text, lol + 10 + further, 1) = "," THEN further = further + 5
                        IF MID$(text, lol + 9 + further, 1) = "," THEN further = further + 4
                        IF MID$(text, lol + 8 + further, 1) = "," THEN further = further + 3
                    ELSE
                        further = 0
                    END IF
                LOOP UNTIL further = 0
            END IF
        END IF
        checking$ = "_define "
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            notok = 0
            IF lol > 1 THEN IF MID$(text, lol - 1, 1) <> CHR$(32) THEN notok = 1
            IF notok = 0 THEN

                further = 0
                DO
                    IF LEN(text) > lol + 10 + further THEN
                        IF ASC(text, lol + 10 + further) = ASC("-") AND ASC(text, lol + 11 + further) <> ASC(",") AND ASC(text, lol + 13 + further) <> ASC("s") AND ASC(text, lol + 13 + further) <> ASC("S") THEN
                            text = MID$(text, 1, lol + 10 + further - 2) + MID$(text, lol + 10 + further)
                        END IF
                        IF ASC(text, lol + 9 + further) = ASC("-") THEN
                            text = MID$(text, 1, lol + 11 - 2 + further) + MID$(text, lol + 11 + further)
                        END IF
                    END IF
                    IF LEN(text) > lol + 8 + further THEN
                        IF ASC(text, lol + 8 + further) = ASC("-") THEN
                            text = MID$(text, 1, lol + 10 - 2 + further) + MID$(text, lol + 10 + further)
                        END IF
                    END IF
                    IF LEN(text) > lol + 9 + further THEN
                        IF ASC(text, lol + 10 + further) = ASC("-") THEN
                            text = MID$(text, 1, lol + 10 - 2 + further) + MID$(text, lol + 10 + further)
                        END IF
                    END IF
                    MID$(text, lol + 8 + further, 1) = UCASE$(MID$(text, lol + 8 + further, 1))
                    MID$(text, lol + 9 + further, 1) = UCASE$(MID$(text, lol + 9 + further, 1))
                    MID$(text, lol + 10 + further, 1) = UCASE$(MID$(text, lol + 10 + further, 1))
                    IF MID$(text, lol + 11 + further, 1) = "," OR MID$(text, lol + 10 + further, 1) = "," OR MID$(text, lol + 9 + further, 1) = "," THEN
                        IF MID$(text, lol + 11 + further, 1) = "," THEN further = further + 5
                        IF MID$(text, lol + 10 + further, 1) = "," THEN further = further + 4
                        IF MID$(text, lol + 9 + further, 1) = "," THEN further = further + 3
                    ELSE
                        further = 0
                    END IF
                LOOP UNTIL further = 0
            END IF
        END IF

        checking$ = "mid$ ("
        remove = 5
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "( mid$"
        remove = 2
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "( screen"
        remove = 2
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "= screen ("
        remove = 9
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "+ screen ("
        remove = 9
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "- screen ("
        remove = 9
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "(screen ("
        remove = 8
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "( screen ("
        remove = 9
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "^ screen ("
        remove = 9
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "\ screen ("
        remove = 9
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "/ screen ("
        remove = 9
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " or screen ("
        remove = 11
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " and screen ("
        remove = 12
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " xor screen ("
        remove = 12
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " imp screen ("
        remove = 12
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " not screen ("
        remove = 12
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " inkey$ )"
        remove = 8
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "( inkey$"
        remove = 2
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF

        checking$ = " integer "
        remove = 9
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " single "
        remove = 8
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " double "
        remove = 8
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " long "
        remove = 6
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF

        checking$ = " then "
        remove = 6
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ AND (lol + remove + 1 > LEN(text)) THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "call interruptx ("
        remove = 16
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            MID$(text, lol + 4, LEN(checking$)) = " InterruptX ("
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF

        checking$ = "( _clipboard$"
        remove = 2
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "timer ("
        remove = 6
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF

        checking$ = "as string ,"
        remove = 10
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "as string )"
        remove = 10
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " integer ,"
        remove = 9
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " integer )"
        remove = 9
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " as # "
        remove = 6
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "print # "
        remove = 8
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ AND lol = 1 THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "input # "
        remove = 8
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ AND lol = 1 THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "get # "
        remove = 6
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ AND lol = 1 THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "put # "
        remove = 6
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ AND lol = 1 THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "write # "
        remove = 8
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ AND lol = 1 THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "close # "
        remove = 8
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ AND lol = 1 THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF

        checking$ = " print # "
        remove = 9
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " input # "
        remove = 9
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " get # "
        remove = 7
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " put # "
        remove = 7
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " write # "
        remove = 9
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " close # "
        remove = 9
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF

        checking$ = " long ,"
        remove = 6
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " long )"
        remove = 6
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " single ,"
        remove = 8
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " single )"
        remove = 8
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " double ,"
        remove = 8
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " double )"
        remove = 8
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " _float ,"
        remove = 8
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " _float )"
        remove = 8
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " _bit ,"
        remove = 6
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " _bit )"
        remove = 6
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " any ,"
        remove = 5
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " any )"
        remove = 5
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF

        checking$ = " _byte ,"
        remove = 7
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " _byte )"
        remove = 7
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " _integer64 ,"
        remove = 12
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " _integer64 )"
        remove = 12
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " $"
        remove = 1
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            IF lol > 2 THEN text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove) ELSE text = LTRIM$(text)
            IF lol > 2 THEN lol = lol - 1
        END IF
        checking$ = " %"
        remove = 1
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            IF lol > 2 THEN text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove) ELSE text = LTRIM$(text)
            IF lol > 2 THEN lol = lol - 1
        END IF
        checking$ = " !"
        remove = 1
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            IF lol > 2 THEN text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove) ELSE text = LTRIM$(text)
            IF lol > 2 THEN lol = lol - 1
        END IF
        checking$ = "< >"
        remove = 2
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF

        checking$ = " :"
        remove = 1
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            IF lol > 2 THEN text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove) ELSE text = LTRIM$(text)
            IF lol > 2 THEN lol = lol - 1
        END IF
        checking$ = " ,"
        remove = 1
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            IF lol <= 2 THEN text = LTRIM$(text)
        END IF
        checking$ = " ;"
        remove = 1
        IF MID$(text, lol, LEN(checking$)) = checking$ AND MID$(text, lol - 1, 1) <> "," AND MID$(text, lol - 1, 1) <> ";" THEN
            IF lol > 2 THEN text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove) ELSE text = LTRIM$(text)
            IF lol > 2 THEN lol = lol - 1
        END IF

        checking$ = " & "
        remove = 1
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            IF lol > 2 THEN text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove) ELSE text = LTRIM$(text)
            IF lol > 2 THEN lol = lol - 1
        END IF
        checking$ = "= ="
        remove = 1
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            IF lol > 2 THEN text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove) ELSE text = LTRIM$(text)
            IF lol > 2 THEN lol = lol - 1
        END IF
        checking$ = "= +"
        remove = 3
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "* +"
        remove = 3
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "/ +"
        remove = 3
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "- +"
        remove = 3
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "^ +"
        remove = 3
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "\ +"
        remove = 3
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "> - "
        remove = 4
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF

        checking$ = "> +"
        remove = 3
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "< - "
        remove = 4
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF

        checking$ = "< +"
        remove = 3
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "<> - "
        remove = 5
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF

        checking$ = "<> +"
        remove = 4
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = ">= +"
        remove = 4
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "<= +"
        remove = 4
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF

        checking$ = "> >"
        remove = 1
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            IF lol > 2 THEN text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "< <"
        remove = 1
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            IF lol > 2 THEN text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove) ELSE text = LTRIM$(text)
            IF lol > 2 THEN lol = lol - 1
        END IF
        checking$ = "+ +"
        remove = 1
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            IF lol > 2 THEN text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove) ELSE text = LTRIM$(text)
            IF lol > 2 THEN lol = lol - 1
        END IF
        checking$ = "$ ,"
        remove = 2
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            IF lol > 2 THEN text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove) ELSE text = LTRIM$(text)
            IF lol > 2 THEN lol = lol - 1
        END IF

        checking$ = "+ - "
        remove = 4
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "= - "
        remove = 4
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "- - "
        remove = 4
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "* - "
        remove = 4
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "^ - "
        remove = 4
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = ", - "
        remove = 4
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "; - "
        remove = 4
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF

        checking$ = "( - "
        remove = 4
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "( -"
        remove = 2
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " or - "
        remove = 6
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " and - "
        remove = 7
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " xor - "
        remove = 7
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " imp - "
        remove = 7
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " not - "
        remove = 7
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF

        checking$ = " to - "
        remove = 6
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " step - "
        remove = 8
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " case - "
        remove = 8
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = " data - "
        remove = 8
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "case - "
        remove = 7
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ AND lol = 1 THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF
        checking$ = "data - "
        remove = 7
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ AND lol = 1 THEN
            text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
            lol = lol - 1
        END IF

        checking$ = " )"
        remove = 1
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            IF lol > 2 THEN text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove) ELSE text = LTRIM$(text)
            IF lol > 2 THEN lol = lol - 1
        END IF
        checking$ = "( "
        remove = 2
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            IF lol >= 1 THEN text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove) ELSE text = LTRIM$(text)
            IF lol > 1 THEN lol = lol - 1
        END IF
        checking$ = ") - ("
        remove = 2
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            FOR checka = lol + LEN(checking$) TO LEN(text)
                ch$ = MID$(text, checka, 1)
                IF ch$ = "," AND para = 0 THEN validrange = 1: EXIT FOR
                IF ch$ = "(" THEN para = 1
                IF ch$ = ")" THEN para = 0
            NEXT
            IF validrange THEN
                text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
                text = MID$(text, 1, lol + remove - 1) + MID$(text, lol + remove + 1)
                lol = lol - 1
            END IF
        END IF
        checking$ = "- ("
        remove = 2
        IF MID$(LCASE$(text), lol, LEN(checking$)) = checking$ THEN
            FOR checka = lol + LEN(checking$) TO LEN(text)
                ch$ = MID$(text, checka, 1)
                IF ch$ = "," AND para = 0 THEN validrange = 1: EXIT FOR
                IF ch$ = "(" THEN para = 1
                IF ch$ = ")" THEN para = 0
            NEXT
            IF validrange THEN
                text = MID$(text, 1, lol + remove - 2) + MID$(text, lol + remove)
                lol = lol - 1
            END IF
        END IF


    LOOP UNTIL lol >= LEN(text)
END IF
formatremovestuff$ = text
END FUNCTION


FUNCTION formatparanteses$ (text AS STRING)
IF LEN(text) >= 1 THEN
    look = 0

    DO
        look = look + 1
        IF LEN(text) >= look + 1 THEN
            IF MID$(text, look, 1) = "(" AND MID$(text, look + 1, 1) = " " AND LEN(text) <> look THEN
                text = MID$(text, 1, look) + MID$(text, look + 2)
                look = look - 1
            END IF
        END IF
        IF look > LEN(text) THEN EXIT DO
    LOOP
    look = 0
    DO
        look = look + 1
        IF MID$(text, look, 1) = ")" AND MID$(text, look - 1, 1) = " " AND LEN(text) <> look THEN
            text = MID$(text, 1, look - 2) + MID$(text, look)
            look = look - 1
        END IF
        IF look > LEN(text) THEN EXIT DO
    LOOP
    look = 0
    DO
        look = look + 1
        IF MID$(text, look, 1) = "(" AND MID$(text, look - 1, 1) = " " AND LEN(text) <> look THEN
            IF look - 2 > 1 THEN looky = ASC(MID$(text, look - 2, 1))
            IF looky = 96 OR looky = 126 OR (looky >= 34 AND looky < 42) OR looky = 33 OR looky = 32 OR (looky > 47 AND looky < 58) OR (looky > 64 AND looky < 91) OR (looky > 96 AND looky < 123) THEN
                text = MID$(text, 1, look - 2) + MID$(text, look)
                look = look - 1
            END IF
        END IF
        IF look >= LEN(text) THEN EXIT DO
    LOOP
END IF
formatparanteses$ = text
END FUNCTION


FUNCTION formatcommaop$ (text AS STRING)
'formatting comma signs and operands (<=>)

look = 0
IF LEN(text) >= 2 THEN
    DO
        look = look + 1

        IF MID$(text, look, 2) = "=<" THEN MID$(text, look, 2) = "<="
        IF MID$(text, look, 2) = "=>" THEN MID$(text, look, 2) = ">="
        IF MID$(text, look, 2) = "><" THEN MID$(text, look, 2) = "<>"


        IF MID$(text, look, 1) = "=" AND MID$(text, look - 1, 1) <> "<" AND MID$(text, look - 1, 1) <> ">" AND MID$(text, look - 1, 1) <> " " THEN
            text = MID$(text, 1, look - 1) + " " + MID$(text, look)
        END IF
        IF LEN(text) > look THEN
            IF MID$(text, look, 1) = "=" AND MID$(text, look + 1, 1) <> " " THEN
                text = MID$(text, 1, look) + " " + MID$(text, look + 1)
            END IF
        END IF
        IF MID$(text, look, 1) = "<" AND MID$(text, look - 1, 1) <> " " AND MID$(text, look - 1, 1) <> ">" AND MID$(text, look - 1, 1) <> "=" THEN
            text = MID$(text, 1, look - 1) + " " + MID$(text, look)
        END IF
        IF LEN(text) > look THEN
            IF MID$(text, look, 1) = "<" AND MID$(text, look + 1, 1) <> " " AND MID$(text, look + 1, 1) <> ">" AND MID$(text, look + 1, 1) <> "=" THEN
                text = MID$(text, 1, look) + " " + MID$(text, look + 1)
            END IF
        END IF
        IF LEN(text) > look THEN
            IF MID$(text, look, 1) = ">" AND MID$(text, look + 1, 1) <> " " AND MID$(text, look + 1, 1) <> "=" THEN
                text = MID$(text, 1, look) + " " + MID$(text, look + 1)
            END IF
        END IF
        IF MID$(text, look, 1) = ">" AND MID$(text, look - 1, 1) <> " " AND MID$(text, look - 1, 1) <> "<" THEN
            text = MID$(text, 1, look - 1) + " " + MID$(text, look)
        END IF
        IF MID$(text, look, 1) = "+" AND MID$(text, look - 1, 1) <> " " THEN
            text = MID$(text, 1, look - 1) + " " + MID$(text, look)
        END IF
        IF LEN(text) > look THEN
            IF MID$(text, look, 1) = "+" AND MID$(text, look + 1, 1) <> " " THEN
                text = MID$(text, 1, look) + " " + MID$(text, look + 1)
            END IF
        END IF
        IF MID$(text, look, 1) = "-" AND MID$(text, look - 1, 1) <> " " THEN
            text = MID$(text, 1, look - 1) + " " + MID$(text, look)
        END IF
        IF LEN(text) > look THEN
            IF MID$(text, look, 1) = "-" AND MID$(text, look + 1, 1) <> " " THEN
                text = MID$(text, 1, look) + " " + MID$(text, look + 1)
            END IF
        END IF
        IF MID$(text, look, 1) = "*" AND MID$(text, look - 1, 1) <> " " THEN
            text = MID$(text, 1, look - 1) + " " + MID$(text, look)
        END IF
        IF LEN(text) > look THEN
            IF MID$(text, look, 1) = "*" AND MID$(text, look + 1, 1) <> " " THEN
                text = MID$(text, 1, look) + " " + MID$(text, look + 1)
            END IF
        END IF
        IF MID$(text, look, 1) = "/" AND MID$(text, look - 1, 1) <> " " THEN
            text = MID$(text, 1, look - 1) + " " + MID$(text, look)
        END IF
        IF LEN(text) > look THEN
            IF MID$(text, look, 1) = "/" AND MID$(text, look + 1, 1) <> " " THEN
                text = MID$(text, 1, look) + " " + MID$(text, look + 1)
            END IF
        END IF
        IF MID$(text, look, 1) = "\" AND MID$(text, look - 1, 1) <> " " THEN
            text = MID$(text, 1, look - 1) + " " + MID$(text, look)
        END IF
        IF LEN(text) > look THEN
            IF MID$(text, look, 1) = "\" AND MID$(text, look + 1, 1) <> " " THEN
                text = MID$(text, 1, look) + " " + MID$(text, look + 1)
            END IF
        END IF
        IF MID$(text, look, 1) = "^" AND MID$(text, look - 1, 1) <> " " THEN
            text = MID$(text, 1, look - 1) + " " + MID$(text, look)
        END IF
        IF LEN(text) > look THEN
            IF MID$(text, look, 1) = "^" AND MID$(text, look + 1, 1) <> " " THEN
                text = MID$(text, 1, look) + " " + MID$(text, look + 1)
            END IF
        END IF
        IF LEN(text) > look THEN
            IF MID$(text, look, 1) = "," AND MID$(text, look + 1, 1) <> " " THEN
                text = MID$(text, 1, look) + " " + MID$(text, look + 1)
            END IF
        END IF
        IF LEN(text) > look THEN
            IF MID$(text, look, 1) = ":" AND MID$(text, look + 1, 1) <> " " THEN
                text = MID$(text, 1, look) + " " + MID$(text, look + 1)
            END IF
        END IF
        IF LEN(text) > look THEN
            IF MID$(text, look, 1) = ";" AND MID$(text, look + 1, 1) <> " " THEN
                text = MID$(text, 1, look) + " " + MID$(text, look + 1)
            END IF
        END IF
        'variable types
        IF LEN(text) > look THEN
            IF MID$(text, look, 1) = "$" AND MID$(text, look + 1, 1) <> " " AND MID$(text, look + 1, 1) <> "(" AND MID$(text, look + 1, 1) <> ")" THEN
                text = MID$(text, 1, look) + " " + MID$(text, look + 1)
            END IF
        END IF
        IF LEN(text) > look THEN
            IF MID$(text, look, 1) = "%" AND MID$(text, look + 1, 1) <> " " AND MID$(text, look + 1, 1) <> "%" AND MID$(text, look + 1, 1) <> "(" AND MID$(text, look + 1, 1) <> ")" THEN
                text = MID$(text, 1, look) + " " + MID$(text, look + 1)
            END IF
        END IF
        IF LEN(text) > look THEN
            IF MID$(text, look, 1) = "!" AND MID$(text, look + 1, 1) <> " " AND MID$(text, look + 1, 1) <> "(" AND MID$(text, look + 1, 1) <> ")" THEN
                text = MID$(text, 1, look) + " " + MID$(text, look + 1)
            END IF
        END IF
        IF LEN(text) > look THEN
            IF MID$(text, look, 1) = "#" AND MID$(text, look + 1, 1) <> " " AND MID$(text, look + 1, 1) <> "#" AND MID$(text, look + 1, 1) <> "(" AND MID$(text, look + 1, 1) <> ")" THEN
                text = MID$(text, 1, look) + " " + MID$(text, look + 1)
            END IF

            IF MID$(text, look, 1) = "&" AND MID$(text, look + 1, 1) <> " " AND MID$(text, look + 1, 1) <> "&" AND MID$(text, look + 1, 1) <> "H" AND MID$(text, look + 1, 1) <> "O" AND MID$(text, look + 1, 1) <> "(" AND MID$(text, look + 1, 1) <> ")" THEN
                text = MID$(text, 1, look) + " " + MID$(text, look + 1)
            END IF
            IF MID$(text, look, 1) = "`" AND MID$(text, look + 1, 1) <> " " AND MID$(text, look + 1, 1) <> "(" AND MID$(text, look + 1, 1) <> ")" THEN
                text = MID$(text, 1, look) + " " + MID$(text, look + 1)
            END IF
            IF MID$(text, look, 1) = ")" AND (MID$(text, look + 1, 1) = ">" OR MID$(text, look + 1, 1) = "<" OR MID$(text, look + 1, 1) = "=") THEN
                text = MID$(text, 1, look) + " " + MID$(text, look + 1)
            END IF
            IF UCASE$(MID$(text, look, 4)) = ")OR " OR UCASE$(MID$(text, look, 5)) = ")XOR " OR UCASE$(MID$(text, look, 5)) = ")AND " OR UCASE$(MID$(text, look, 5)) = ")NOT " OR UCASE$(MID$(text, look, 5)) = ")IMP " THEN
                text = MID$(text, 1, look) + " " + MID$(text, look + 1)
            END IF
            IF UCASE$(MID$(text, look, 5)) = " XOR(" OR UCASE$(MID$(text, look, 5)) = " AND(" OR UCASE$(MID$(text, look, 5)) = " NOT(" OR UCASE$(MID$(text, look, 5)) = " IMP(" THEN
                text = MID$(text, 1, look + 3) + " " + MID$(text, look + 4)
            END IF
            IF UCASE$(MID$(text, look, 5)) = ")XOR(" OR UCASE$(MID$(text, look, 5)) = ")AND(" OR UCASE$(MID$(text, look, 5)) = ")NOT(" OR UCASE$(MID$(text, look, 5)) = ")IMP(" THEN
                text = MID$(text, 1, look) + " " + MID$(text, look + 1, 3) + " " + MID$(text, look + 4)
            END IF
            IF UCASE$(MID$(text, look, 4)) = ")OR(" THEN
                text = MID$(text, 1, look) + " " + MID$(text, look + 1, 2) + " " + MID$(text, look + 3)
            END IF


            IF UCASE$(MID$(text, look, 4)) = " OR(" THEN
                text = MID$(text, 1, look + 2) + " " + MID$(text, look + 3)
            END IF
        END IF

        IF look >= LEN(text) THEN EXIT DO
    LOOP
END IF
formatcommaop$ = text
END FUNCTION

FUNCTION formatmultispace$ (text AS STRING, indent)
'formatting multiple spaces to one space

DIM text2 AS STRING

IF LEN(text) >= 1 THEN

    IF indent = 1 THEN
        FOR start = 1 TO LEN(text)
            IF MID$(text, start, 1) <> " " THEN EXIT FOR
        NEXT
    ELSE
        start = 1
    END IF


    DO
        e = INSTR(start, text, "  ")

        IF e THEN
            text = MID$(text, 1, e) + MID$(text, e + 2)
        ELSE

            formatmultispace$ = text
            EXIT DO

        END IF
    LOOP

END IF

END FUNCTION


SUB shiftit (startx, starty, endx, endy, selinfo$)
selinfo$ = ""
IF starty > 0 AND endy > 0 THEN
    IF startx - (xrel - 1) > tfx + tfw - 1 THEN stx = tfx + tfw - 1
    IF startx - (xrel - 1) < tfx THEN stx = tfx
    IF startx - (xrel - 1) <= tfx + tfw - 1 AND startx - (xrel - 1) >= tfx THEN stx = startx - (xrel - 1)
    IF endx - (xrel - 1) > tfx + tfw - 1 THEN enx = tfx + tfw - 1
    IF endx - (xrel - 1) < tfx THEN enx = tfx
    IF endx - (xrel - 1) <= (tfx + tfw - 1) AND endx - (xrel - 1) >= tfx THEN enx = endx - (xrel - 1)
    IF starty - (yrel - 1) > tfy + tfh - 1 THEN sty = tfy + tfh - 1
    IF starty - (yrel - 1) < tfy THEN sty = tfy
    IF starty - (yrel - 1) <= (tfy + tfh - 1) AND starty - (yrel - 1) >= tfy THEN sty = starty - (yrel - 1)
    IF endy - (yrel - 1) > tfy + tfh - 1 THEN eny = tfy + tfh - 1
    IF endy - (yrel - 1) < tfy THEN eny = tfy
    IF endy - (yrel - 1) <= (tfy + tfh - 1) AND endy - (yrel - 1) >= tfy THEN eny = endy - (yrel - 1)
    moremore = 0
    IF starty = endy AND startx <= endx AND startx <> 0 THEN

        FOR pospos = stx TO enx
            COLOR bgcsetting, 7
            LOCATE sty, pospos: PRINT CHR$(SCREEN(sty, pospos))
        NEXT
        COLOR fgcsetting, bgcsetting
        selinfo$ = MID$(codetext(starty - tfy), startx - (tfx - 1), (endx - startx) + 1)
    END IF
    IF starty = endy AND startx > endx AND endx <> 0 THEN

        FOR pospos = enx TO stx - 1

            COLOR bgcsetting, 7
            LOCATE sty, pospos: PRINT CHR$(SCREEN(sty, pospos))

        NEXT
        IF startx - xrel > (tfw + tfx - 2) THEN
            COLOR bgcsetting, 7
            LOCATE sty, (tfw + tfx) - 1: PRINT CHR$(SCREEN(sty, (tfw + tfx) - 1))

        END IF
        COLOR fgcsetting, bgcsetting

        selinfo$ = MID$(codetext(starty - tfy), endx - (tfx - 1), (startx - endx))
    END IF
    IF starty < endy THEN

        FOR pospos = sty TO eny
            FOR posposx = tfx TO tfx + tfw - 1
                COLOR bgcsetting, 7
                LOCATE pospos, posposx: PRINT CHR$(SCREEN(pospos, posposx))
            NEXT
            COLOR fgcsetting, bgcsetting
        NEXT
        FOR pospos = starty TO endy
            IF pospos <> endy THEN selinfo$ = selinfo$ + codetext(pospos - tfy) + CHR$(13) + CHR$(10)
            IF pospos = endy THEN selinfo$ = selinfo$ + codetext(pospos - tfy)
        NEXT
    END IF
    IF starty > endy THEN

        FOR pospos = eny TO sty
            FOR posposx = tfx TO tfx + tfw - 1
                COLOR bgcsetting, 7
                LOCATE pospos, posposx: PRINT CHR$(SCREEN(pospos, posposx))
            NEXT
            COLOR fgcsetting, bgcsetting
        NEXT
        IF starty < tfy THEN starty = tfy
        IF endy < tfy THEN endy = tfy
        FOR pospos = endy TO starty
            IF pospos - tfy < 0 THEN PRINT "ERROR pospos-tfy = "; pospos - tfy: PRINT "pospos = "; pospos: PRINT "endy = "; endy: PRINT "starty = "; starty: _DISPLAY: END
            IF pospos <> starty THEN selinfo$ = selinfo$ + codetext(pospos - tfy) + CHR$(13) + CHR$(10)
            IF pospos = starty THEN selinfo$ = selinfo$ + codetext(pospos - tfy)
        NEXT

    END IF


END IF

END SUB

SUB createcursor (curx, curpos, mode)
IF mode = 0 THEN
    IF onoff = 0 THEN
        COLOR 0, 6
        IF endx = curx + (xrel - 1) AND startx > endx AND starty = endy THEN COLOR 0, 7
        LOCATE curpos, curx: PRINT CHR$(SCREEN(curpos, curx))
        COLOR fgcsetting, bgcsetting
    ELSE
        COLOR 4, 6

        LOCATE curpos, curx: PRINT CHR$(SCREEN(curpos, curx))
        COLOR fgcsetting, bgcsetting

    END IF
END IF
IF mode = 1 THEN
    COLOR 4, 2
    LOCATE curpos, curx: PRINT CHR$(SCREEN(curpos, curx))
    COLOR fgcsetting, bgcsetting
END IF

END SUB


SUB textbox (xp1, yp1, xp2, yp2, codetext() AS STRING, x, y)
FOR yy = yp1 TO yp2
    COLOR fgcsetting, bgcsetting
    LOCATE yy, xp1: PRINT MID$(codetext(yy - tfy + y - 1), x, xp2 - xp1 + 1)
NEXT
END SUB

SUB print24 (text AS STRING * 200, fgc, bgc)
DIM row23 AS STRING * 200
DIM row24 AS STRING * 200
DIM col23 AS STRING * 200
DIM col24 AS STRING * 200

row23 = SPACE$(_WIDTH)
row24 = SPACE$(_WIDTH)
col23 = SPACE$(_WIDTH)
col24 = SPACE$(_WIDTH)

FOR colu = 1 TO _WIDTH
    MID$(row23, colu, 1) = CHR$(SCREEN(_HEIGHT - 2, colu))
    MID$(col23, colu, 1) = CHR$(SCREEN(_HEIGHT - 2, colu, 1))
    MID$(row24, colu, 1) = CHR$(SCREEN(_HEIGHT - 1, colu))
    MID$(col24, colu, 1) = CHR$(SCREEN(_HEIGHT - 1, colu, 1))
NEXT
preback = _BACKGROUNDCOLOR
lastclin = CSRLIN
lastcrow = POS(0)
LOCATE _HEIGHT, 1: PRINT "Press a key."
locate _height-2,1:
IF CSRLIN = _HEIGHT AND flag = 1 THEN PRINT: LOCATE _HEIGHT, 1
PRINT text;
IF CSRLIN <> _HEIGHT THEN PRINT ELSE flag = 1
IF CSRLIN = _HEIGHT AND flag = 1 THEN PRINT: LOCATE _HEIGHT, 1
PRINT text;
IF CSRLIN <> _HEIGHT THEN PRINT ELSE flag = 1
IF CSRLIN = _HEIGHT AND flag = 1 THEN PRINT: LOCATE _HEIGHT, 1
COLOR fgc, bgc
PRINT text;
COLOR , preback
FOR colu = 1 TO _WIDTH
    LOCATE _HEIGHT - 2, colu
    COLOR ASC(MID$(col23, colu, 1))
    PRINT MID$(row23, colu, 1)
    LOCATE _HEIGHT - 1, colu
    COLOR ASC(MID$(col24, colu, 1))
    PRINT MID$(row24, colu, 1)
NEXT

LOCATE lastclin, lastcrow
END SUB



SUB print25 (text AS STRING * 200, fgc, bgc)
DIM row23 AS STRING * 200
DIM row24 AS STRING * 200
DIM col23 AS STRING * 200
DIM col24 AS STRING * 200

row23 = SPACE$(_WIDTH)
row24 = SPACE$(_WIDTH)
col23 = SPACE$(_WIDTH)
col24 = SPACE$(_WIDTH)

FOR colu = 1 TO _WIDTH
    MID$(row23, colu, 1) = CHR$(SCREEN(_HEIGHT - 2, colu))
    MID$(col23, colu, 1) = CHR$(SCREEN(_HEIGHT - 2, colu, 1))
    MID$(row24, colu, 1) = CHR$(SCREEN(_HEIGHT - 1, colu))
    MID$(col24, colu, 1) = CHR$(SCREEN(_HEIGHT - 1, colu, 1))
NEXT
preback = _BACKGROUNDCOLOR
lastclin = CSRLIN
lastcrow = POS(0)
LOCATE _HEIGHT, 1: PRINT "Press a key."
locate _height-2,1:
IF CSRLIN = _HEIGHT AND flag = 1 THEN PRINT: LOCATE _HEIGHT, 1
PRINT text;
IF CSRLIN <> _HEIGHT THEN PRINT ELSE flag = 1
IF CSRLIN = _HEIGHT AND flag = 1 THEN PRINT: LOCATE _HEIGHT, 1
PRINT text;
IF CSRLIN <> _HEIGHT THEN PRINT ELSE flag = 1
IF CSRLIN = _HEIGHT AND flag = 1 THEN PRINT: LOCATE _HEIGHT, 1
COLOR fgc, bgc
PRINT text;
COLOR , preback
FOR colu = 1 TO _WIDTH
    LOCATE _HEIGHT - 2, colu
    IF ASC(MID$(col23, colu, 1)) <= 15 THEN COLOR ASC(MID$(col23, colu, 1))
    PRINT MID$(row23, colu, 1)
    LOCATE _HEIGHT - 1, colu
    IF ASC(MID$(col24, colu, 1)) <= 15 THEN COLOR ASC(MID$(col24, colu, 1))
    PRINT MID$(row24, colu, 1)
NEXT

LOCATE lastclin, lastcrow
END SUB


SUB DrawMenu (items, selitem, spacing, itemlist() AS STRING)
k = 1
COLOR 0, 7
LOCATE 1, 1
PRINT SPACE$(_WIDTH)
FOR a = 1 TO items
    IF k + LEN(itemlist(a)) > _WIDTH THEN k = _WIDTH - LEN(itemlist(a))
    LOCATE 1, k
    IF a = selitem THEN COLOR 7, 0
    PRINT itemlist(a)
    IF a = selitem THEN COLOR 0, 7
    k = k + LEN(itemlist(a)) + spacing
NEXT
COLOR 7, 0
END SUB

SUB DrawMenuItem (locx, selitem, itemlist() AS STRING, itemnum)
COLOR 0, 7
IF locx + LEN(itemlist(itemnum)) > _WIDTH THEN locx = _WIDTH - LEN(itemlist(itemnum))
LOCATE 1, locx
IF itemnum = selitem THEN COLOR 7, 0
PRINT itemlist(itemnum)
COLOR 7, 0
END SUB

SUB DrawFrame (x, y, wide, high, replace)
COLOR fgcsetting, bgcsetting
IF x + wide - 1 > _WIDTH THEN IF x < _WIDTH THEN wide = _WIDTH - x + 1
IF y + high - 1 > _HEIGHT THEN IF y < _HEIGHT THEN high = _HEIGHT - y + 1

IF replace = 1 THEN LOCATE y, x: PRINT CHR$(218)
IF replace = 0 THEN
    IF (SCREEN(y, x) = 218 OR SCREEN(y, x) = 179 OR SCREEN(y, x) = 192) THEN LOCATE y, x: PRINT CHR$(195) ELSE LOCATE y, x: PRINT CHR$(218)
END IF

LOCATE y, x + 1: PRINT STRING$(wide - 2, 196)
IF replace = 1 THEN LOCATE y, x + wide - 1: PRINT CHR$(191)
IF replace = 0 THEN
    IF (SCREEN(y, x + wide - 1) = 191 OR SCREEN(y, x + wide - 1) = 179 OR SCREEN(y, x + wide - 1) = 217) THEN LOCATE y, x + wide - 1: PRINT CHR$(180) ELSE LOCATE y, x + wide - 1: PRINT CHR$(191)
END IF

FOR r = y + 1 TO y + high - 2
    LOCATE r, x: PRINT CHR$(179)
    LOCATE r, x + wide - 1: PRINT CHR$(179)
    'LOCATE _HEIGHT - 1, _WIDTH - 1: PRINT "O"
NEXT

IF y + high - 1 <> _HEIGHT THEN
    IF replace = 1 THEN LOCATE y + high - 1, x: PRINT CHR$(192)
    IF replace = 0 THEN
        IF (SCREEN(y + high - 1, x) = 192 OR SCREEN(y + high - 1, x) = 179) THEN LOCATE y + high - 1, x: PRINT CHR$(195) ELSE LOCATE y + high - 1, x: PRINT CHR$(192)
    END IF


    LOCATE y + high - 1, x + 1: PRINT STRING$(wide - 2, 196)

    IF replace = 1 THEN LOCATE y + high - 1, x + wide - 1: PRINT CHR$(217)
    IF replace = 0 THEN
        IF (SCREEN(y + high - 1, x + wide - 1) = 217 OR SCREEN(y + high - 1, x + wide - 1) = 179) THEN LOCATE y + high - 1, x + wide - 1: PRINT CHR$(180) ELSE LOCATE y + high - 1, x + wide - 1: PRINT CHR$(217)
    END IF
END IF
END SUB

SUB DrawVScrollBar (xpos, ypos, length, current, min, max)
COLOR 0, 7
LOCATE ypos, xpos: PRINT CHR$(24)
FOR r = ypos + 1 TO ypos + length - 2
    LOCATE r, xpos: PRINT CHR$(176)
NEXT
LOCATE ypos + length - 1, xpos: PRINT CHR$(25)
COLOR 0, 0
IF current < max - 1 THEN LOCATE ypos + 1 + INT((current) * ((length - 2) / (min + max + 1))), xpos: PRINT "M"
IF current >= max - 1 AND current > min THEN LOCATE ypos + length - 2, xpos: PRINT "M"
IF current >= max - 1 AND current <= min THEN LOCATE ypos + 1, xpos: PRINT "M"
COLOR 0, 7
'ypos + length = max
'ypos + length = 10
'max = 20

END SUB

SUB DrawHScrollBar (xpos, ypos, length, current, min, max)
COLOR 0, 7
LOCATE ypos, xpos: PRINT CHR$(27)
FOR r = xpos + 1 TO xpos + length - 2
    LOCATE ypos, r: PRINT CHR$(176)
NEXT
LOCATE ypos, xpos + length - 1: PRINT CHR$(26)
COLOR 0, 0
IF current < max - 1 THEN LOCATE ypos, xpos + 1 + INT((current) * ((length - 2) / (min + max + 1))): PRINT "M"
IF current >= max - 1 AND current > min THEN LOCATE ypos, xpos + length - 2: PRINT "M"
IF current >= max - 1 AND current <= min THEN LOCATE ypos, xpos + 1: PRINT "M"
COLOR 0, 7

END SUB


FUNCTION scankey% (scancode%)
i% = INP(&H60)
IF i% = 170 OR i% = 54 OR i% = 42 THEN FOR a = 0 TO 127: keyflags%(a) = 0: NEXT a
IF (i% AND 128) THEN keyflags%(i% XOR 128) = 0
IF (i% AND 128) = 0 THEN keyflags%(i%) = -1
'WHILE INKEY$ <> "": WEND
scankey% = keyflags%(scancode%)
END FUNCTION




